#ifndef lint
char yysccsid[] = "@(#)yaccpar	1.4 (Berkeley) 02/25/90";
#endif
#line 2 "parser.y"
/*
 *  $Id: parser.y,v 1.2.4.1 1996/11/26 19:03:10 wfs Exp $
 */

/* Gated Release 3.5 */
/* Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.  All */
/* rights reserved.  Refer to Particulars and other Copyright notices at */
/* the end of this file.  */
/*  */


#define	MALLOC_OK
#include "include.h"
#include "inet.h"
#include "parse.h"
#include "krt.h"
#include "rip.h"
#include "hello.h"
#include "icmp.h"
#include "ospf.h"

#undef	vsprintf

#ifdef	notdef
#define	free(a)		task_mem_free((task *) 0, a)
#define	malloc(a)	task_mem_malloc((task *) 0, a)
#define	calloc(a, b)	task_mem_calloc((task *) 0, a, b)
#define	realloc(a, b)	task_mem_realloc((task *) 0, a, b)
#define	strdup(a)	task_mem_strdup((task *) 0, a)
#endif	/* notdef */

char parse_error[LINE_MAX] = { 0 };
char *parse_filename = 0;

static	proto_t	parse_proto;			/* For correctly tagging ADV lists */
static	proto_t	parse_export_proto;		/* For checking metrics */
static	gw_entry	**parse_gwlist;
static	gw_entry	*parse_gwp;		/* To fake a list for EGP and BGP */
static	int	parse_contig_masks = TRUE;	/* Masks must be contiguous */
static struct AREA *ospf_AREA;
static size_t ospf_auth_length;
static if_info parse_ifi;	/* Used for configuring interfaces that do not exist */

u_int parse_state = PS_INITIAL;
proto_t protos_seen = 0;

PROTOTYPE(yyerror,
	  static void,
	  (const char *));

#define	free_string(s)	task_mem_free((task *) 0, (caddr_t) s); s = 0
#define	free_charstr(s)	task_mem_free((task *) 0, (caddr_t) (s).ptr); (s).ptr = (char *) 0; (s).len = (s).type = 0
#define	free_bytestr(s)	task_mem_free((task *) 0, (caddr_t) (s).ptr); (s).ptr = (byte *) 0; (s).len = (s).type = 0

#define	PARSE_ERROR	yyerror(parse_error); yynerrs++; YYERROR;

#define	PROTO_SEEN(proto) \
	if (BIT_TEST(protos_seen, RTPROTO_BIT(proto))) { \
	    sprintf(parse_error, "parse_proto_seen: duplicate %s clause", gd_lower(trace_state(rt_proto_bits, proto))); \
	    PARSE_ERROR; \
	} else { \
	    BIT_SET(protos_seen, RTPROTO_BIT(proto)); \
	    parse_proto = proto; \
	} \

#line 70 "parser.y"
typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    utime_t	utime;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    void_t	vt;
    sockaddr_un	*sockaddr;
    trace_file	*trace_file;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#ifdef	PROTO_ASPATHS
    as_path *aspath;
    asmatch_t *asp_match;
    asp_range asp_range;
    asp_stack asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#line 119 "y.tab.c"
#define L_EOS 257
#define L_ERROR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_HNAME 261
#define L_KEYWORD 262
#define L_HEXSTRING 263
#define L_OCTETSTRING 264
#define T_DIRECT 265
#define T_INTERFACE 266
#define T_INTERFACES 267
#define T_LCLADDR 268
#define T_PROTO 269
#define T_METRIC 270
#define T_METRICIN 271
#define T_METRICOUT 272
#define T_INFINITY 273
#define T_DOWN 274
#define T_PARSE 275
#define T_ADV 276
#define T_DEFAULT 277
#define T_DEFAULTS 278
#define T_YYDEBUG 279
#define T_YYSTATE 280
#define T_YYQUIT 281
#define T_DEBUG 282
#define T_SYSLOG 283
#define T_UPTO 284
#define T_EMERG 285
#define T_ALERT 286
#define T_CRIT 287
#define T_ERR 288
#define T_WARNING 289
#define T_NOTICE 290
#define T_INFO 291
#define T_ON 292
#define T_OFF 293
#define T_GATEWAY 294
#define T_PREFERENCE 295
#define T_PREFERENCE2 296
#define T_DEFAULTMETRIC 297
#define T_NONBROADCAST 298
#define T_BROADCAST 299
#define T_TYPE 300
#define T_POINTOPOINT 301
#define T_MULTICAST 302
#define T_NETMASK 303
#define T_DEFINE 304
#define T_INTERNAL 305
#define T_EXTERNAL 306
#define T_IGNORE 307
#define T_NOP 308
#define T_NOP1 309
#define T_NOP_DM 310
#define T_NOP_ADV 311
#define T_NOP_PROTO 312
#define T_NOP_SOCKADDR 313
#define T_PEERAS 314
#define T_LOCALAS 315
#define T_NEIGHBOR 316
#define T_GROUP 317
#define T_NOGENDEFAULT 318
#define T_VERSION 319
#define T_ACQUIRE 320
#define T_TTL 321
#define T_EGP 322
#define T_ASPATH 323
#define T_ORIGIN 324
#define T_INCOMPLETE 325
#define T_ANY 326
#define T_LOOPS 327
#define T_TAG 328
#define T_KERNEL 329
#define T_SYMBOLS 330
#define T_REMNANTS 331
#define T_IFLIST 332
#define T_ROUTES 333
#define T_NOCHANGE 334
#define T_NOFLUSHATEXIT 335
#define T_REMNANTHOLDTIME 336
#define T_HIGHER 337
#define T_LOWER 338
#define T_FLASH 339
#define T_INTERIOR 340
#define T_BACKGROUND 341
#define T_LIMIT 342
#define T_TRUSTEDGATEWAYS 343
#define T_SOURCEGATEWAYS 344
#define T_RIP 345
#define T_RIPOUT 346
#define T_NORIPOUT 347
#define T_RIPIN 348
#define T_NORIPIN 349
#define T_NOCHECKZERO 350
#define T_HELLOOUT 351
#define T_HELLOIN 352
#define T_NOHELLOOUT 353
#define T_NOHELLOIN 354
#define T_OSPF 355
#define T_OSPF_ASE 356
#define T_BACKBONE 357
#define T_VIRTUALLINK 358
#define T_STUB 359
#define T_STUBHOSTS 360
#define T_RXMITINTERVAL 361
#define T_INFTRANSDELAY 362
#define T_NETWORKS 363
#define T_POLLINTERVAL 364
#define T_ROUTERS 365
#define T_NEIGHBORID 366
#define T_TRANSITAREA 367
#define T_ELIGIBLE 368
#define T_MONITORAUTH 369
#define T_MONITORAUTHKEY 370
#define T_NOMULTICAST 371
#define T_DD 372
#define T_ACK 373
#define T_LSA_BLD 374
#define T_LSA_RX 375
#define T_LSA_TX 376
#define T_EXPORTINTERVAL 377
#define T_EXPORTLIMIT 378
#define T_FIRST 379
#define T_EVERY 380
#define T_AREA 381
#define T_SPF 382
#define T_HELLO 383
#define T_HELLOINTERVAL 384
#define T_ROUTERDEADINTERVAL 385
#define T_PRIORITY 386
#define T_ENABLE 387
#define T_DISABLE 388
#define T_QUERY 389
#define T_QUERYINTERVAL 390
#define T_MODE 391
#define T_ADVERTISE 392
#define T_REGISTER 393
#define T_SNMP 394
#define T_ICMP 395
#define T_ROUTERDISCOVERY 396
#define T_REDIRECT 397
#define T_REDIRECTS 398
#define T_NOREDIRECTS 399
#define T_AUTHTYPE 400
#define T_AUTHKEY 401
#define T_NONE 402
#define T_SIMPLE 403
#define T_AUTH 404
#define T_MD5 405
#define T_SECONDARY 406
#define T_PASSIVE 407
#define T_SIMPLEX 408
#define T_STRICTIFS 409
#define T_SCANINTERVAL 410
#define T_STATIC 411
#define T_MARTIANS 412
#define T_RETAIN 413
#define T_EXPORT 414
#define T_IMPORT 415
#define T_EXACT 416
#define T_REFINE 417
#define T_HOST 418
#define T_MASK 419
#define T_MASKLEN 420
#define T_REJECT 421
#define T_BLACKHOLE 422
#define T_RESTRICT 423
#define T_ALLOW 424
#define T_ANNOUNCE 425
#define T_LISTEN 426
#define T_AS 427
#define T_ROUTERID 428
#define T_IGP 429
#define T_OPTIONS 430
#define T_NOINSTALL 431
#define T_NOSEND 432
#define T_NORESOLV 433
#define T_MARK 434
#define T_TRACEOPTIONS 435
#define T_EXCEPT 436
#define T_REPLACE 437
#define T_SIZE 438
#define T_FILES 439
#define T_K 440
#define T_M 441
#define T_ALL 442
#define T_ROUTE 443
#define T_STATE 444
#define T_POLICY 445
#define T_NORMAL 446
#define T_GENERAL 447
#define T_TASK 448
#define T_TIMER 449
#define T_NOSTAMP 450
#define T_UPDATE 451
#define T_DETAIL 452
#define T_SEND 453
#define T_RECEIVE 454
#define T_ERROR 455
#define T_PACKETS 456
#define T_RESPONSE 457
#define T_REQUEST 458
#define T_OTHER 459
#define T_TRAP 460
#define L_USEC 461
#define T_AGGREGATE 462
#define T_GENERATE 463
#define T_BRIEF 464
#define T_INET 465
#define T_GENDEFAULT 466
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,  173,  173,  174,  174,  174,  174,  174,  174,
  174,  174,  174,  174,  175,  175,  175,  176,  106,  106,
  106,  107,  107,  107,  110,  110,  105,  105,  104,  100,
  100,  100,  101,  101,  101,  101,   99,   99,   98,   98,
   98,   98,   98,   98,   98,   98,  102,  102,  103,  103,
  103,  181,  182,  189,  182,  182,  182,  145,  145,  145,
  144,  144,  144,  160,  160,  177,  178,  190,  190,  191,
  191,  191,  191,  191,  146,  192,  146,    3,    3,    2,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
  179,  193,  180,  194,  194,  194,  195,  195,  198,  195,
  196,  196,  200,  200,  197,  197,  197,  199,  199,  201,
  201,  108,  108,  109,  109,  109,  109,  109,  109,  109,
  156,  156,  158,  158,  157,  157,  155,  155,  153,  154,
  154,  127,  128,  128,  183,  184,  184,  184,  184,  184,
  184,  184,  209,  203,  210,  210,  210,  211,  211,  211,
  211,  211,  211,  212,  212,  215,  215,  213,  213,  216,
  216,   24,   24,   24,  214,  214,  217,  217,   25,   25,
   25,   21,   21,   21,   22,   22,   23,   23,   23,   23,
   23,   23,   23,   20,   20,   20,   20,   20,  218,  207,
  219,  219,  220,  220,  220,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,   27,   27,   26,   26,   26,
   26,   26,   26,   26,   26,   26,   33,   33,   33,   35,
   35,   29,   29,   29,   30,   30,   30,   31,   31,   32,
   32,   28,   28,   28,   28,   34,  222,  204,  223,  223,
  224,  224,  224,  225,  225,  225,  225,  225,  225,  225,
  225,   37,   37,   36,   36,   36,   36,   36,   36,   39,
   39,   39,   40,   40,   41,   41,   38,   42,  226,  206,
  227,  227,  228,  228,  228,  229,  229,  229,  229,  229,
  231,  229,  229,  232,  229,   59,   59,   60,   60,  230,
  230,  230,  234,  234,  234,  234,  233,  233,  233,  235,
  235,  235,  235,  235,  235,   43,   43,   44,   44,   46,
   46,   46,   45,   45,   48,   48,   48,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   49,   49,
   49,   50,   50,   51,   52,   52,   53,   58,   58,   57,
  237,   56,   54,   54,   54,   55,   55,   55,  236,  236,
  236,  238,   64,   64,   64,   63,   62,   62,   61,   69,
   70,   65,   65,   65,   66,   66,   67,   67,   67,   67,
   67,   67,   67,   67,   68,   68,   68,   68,   68,   68,
   74,   74,   74,   73,   73,   72,   72,  239,  205,  240,
  240,  240,  241,   76,   76,   76,   77,   77,   78,   78,
   75,   75,   75,   75,   75,  242,  202,  243,  243,  244,
  244,  244,  245,  245,  245,  245,   80,   80,   79,   79,
   81,   81,   81,   82,   82,   83,  208,  185,  246,  186,
  247,  247,  247,  248,  248,   85,   85,   84,   84,   84,
   84,   86,   86,   87,   87,   87,   87,  187,  188,  188,
  188,  188,  188,  188,  188,  188,  188,  116,  116,  143,
  143,  149,  149,  149,  150,  150,  150,  150,  151,  151,
  151,  151,  151,  151,  151,  151,  151,  112,   88,   88,
  113,  163,  163,  161,  161,  161,  249,  162,  114,   71,
   89,   89,  169,  169,  165,  165,  165,  164,  164,  164,
  164,  164,  164,  164,  164,  164,  164,  164,  164,  118,
  119,  121,  120,  117,  170,  170,  168,  168,  167,  167,
  167,  250,  166,  137,  137,  137,  137,  141,  142,  148,
  148,  147,  134,  134,  138,  135,  135,  139,  139,  139,
  140,  136,  133,  132,  132,    4,  130,  130,  131,  131,
  129,  129,  159,  159,  152,  152,  152,  172,  172,  172,
  115,  115,  115,  111,   97,   97,   93,   93,   94,   94,
   95,   95,  125,  125,  126,  126,  124,  171,   90,   90,
   91,   91,   92,   92,   96,   96,   96,  123,  123,  122,
   17,   17,   16,   16,   16,   15,   15,   18,   19,   19,
   19,   19,   19,   14,   14,   14,   14,   14,   14,  251,
    5,   13,   13,   13,   11,   11,   12,   12,   12,    6,
    6,    7,    7,    9,    9,    9,    9,    9,    8,    8,
    8,   10,   10,   10,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    2,    2,    2,    2,
    2,    2,    2,    1,    3,    3,    2,    5,    0,    2,
    6,    1,    2,    2,    0,    1,    0,    2,    1,    1,
    1,    3,    1,    1,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,
    1,    0,    1,    0,    6,    4,    3,    0,    4,    3,
    1,    1,    1,    0,    1,    0,    3,    1,    2,    1,
    1,    2,    2,    3,    0,    0,    3,    0,    1,    1,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    0,    6,    0,    3,    3,    2,    3,    0,    5,
    1,    2,    1,    2,    2,    2,    0,    0,    2,    2,
    1,    1,    2,    2,    3,    1,    1,    1,    1,    2,
    0,    2,    1,    2,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    0,    2,    2,    2,    2,    2,
    2,    2,    0,    5,    0,    3,    3,    4,    2,    2,
    2,    2,    2,    1,    2,    1,    1,    1,    2,    2,
    2,    1,    1,    1,    1,    2,    2,    2,    1,    1,
    1,    1,    1,    3,    1,    2,    1,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    4,
    0,    3,    0,    3,    3,    2,    2,    1,    1,    4,
    1,    3,    2,    2,    3,    1,    2,    1,    1,    1,
    1,    2,    2,    2,    3,    3,    0,    1,    1,    1,
    2,    0,    1,    1,    1,    1,    3,    1,    2,    1,
    3,    1,    1,    1,    1,    1,    0,    4,    0,    3,
    0,    3,    3,    2,    2,    1,    1,    4,    3,    2,
    2,    1,    2,    1,    1,    1,    1,    2,    2,    1,
    1,    3,    1,    2,    1,    3,    1,    1,    0,    4,
    0,    3,    0,    3,    3,    4,    4,    2,    2,    2,
    0,    3,    3,    0,    5,    0,    2,    0,    2,    0,
    3,    3,    2,    2,    2,    2,    0,    3,    3,    2,
    2,    4,    4,    2,    6,    3,    4,    0,    3,    2,
    3,    3,    0,    3,    2,    3,    3,    1,    1,    2,
    2,    2,    2,    2,    1,    2,    3,    2,    1,    2,
    4,    0,    2,    1,    0,    2,    1,    2,    1,    1,
    0,    3,    1,    1,    1,    1,    1,    1,    2,    3,
    3,    3,    2,    3,    3,    2,    0,    1,    1,    1,
    1,    1,    1,    3,    1,    2,    1,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    4,    3,    1,    1,    0,    1,    0,    5,    0,
    3,    3,    4,    1,    1,    3,    1,    2,    1,    3,
    1,    1,    1,    1,    1,    0,    4,    0,    3,    0,
    3,    3,    2,    3,    2,    4,    1,    2,    1,    1,
    1,    1,    3,    1,    2,    1,    2,    0,    0,    5,
    2,    3,    2,    5,    7,    0,    2,    1,    1,    1,
    1,    0,    2,    1,    1,    1,    1,    0,    1,    7,
    6,    6,    7,    6,    7,    8,    7,    0,    1,    1,
    1,    1,    2,    3,    4,    6,    5,    6,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,
    1,    1,    4,    0,    3,    3,    0,    4,    1,    1,
    0,    1,    1,    4,    0,    3,    3,    4,    4,    3,
    4,    3,    5,    4,    5,    4,    4,    3,    3,    1,
    1,    1,    1,    1,    1,    2,    0,    3,    0,    3,
    3,    0,    4,    1,    1,    1,    1,    1,    1,    1,
    2,    1,    1,    1,    2,    1,    1,    1,    3,    3,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    2,
    1,    1,    0,    2,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    1,    3,    5,    0,    2,    1,
    0,    2,    1,    1,    2,    0,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    5,    0,    1,    1,    1,    3,    1,    1,    1,    1,
    3,    1,    2,    1,    2,    2,    2,    4,    1,    1,
    3,    1,    2,    3,
};
short yydefred[] = {                                      0,
    0,   14,    0,    0,    0,    0,    0,    0,    3,    5,
    6,    0,    0,    0,    0,    0,    0,   13,  565,  566,
    0,    0,   17,  578,   27,    0,    4,    0,    7,   92,
    8,   53,   54,    0,    0,    9,  143,  189,  269,  237,
    0,  388,  406,   10,    0,    0,    0,    0,    0,    0,
    0,  429,   11,  449,    0,    0,    0,    0,   12,   15,
   16,    0,   26,    0,    0,   70,   71,    0,    0,    0,
   68,    0,    0,  590,    0,  544,  558,  559,  583,  584,
  545,  543,  534,    0,  560,  533,    0,    0,    0,    0,
  427,    0,    0,  136,  137,  138,  139,  140,  141,  142,
    0,    0,    0,  529,  537,    0,  460,  461,    0,  536,
    0,   37,   38,   30,   46,   39,   42,   43,   40,   41,
   44,   45,   29,   33,   34,    0,    0,   28,    0,   90,
    0,   83,   84,   85,   86,   87,   88,   89,   80,    0,
    0,   73,   79,    0,    0,   67,   69,   94,   58,    0,
    0,   57,  145,    0,    0,    0,  390,    0,    0,  564,
  563,  490,  562,  561,    0,  478,    0,    0,  489,    0,
    0,    0,  481,    0,    0,    0,    0,   18,    0,   35,
   36,  581,    0,  582,    0,   81,   82,    0,  577,  574,
   76,   74,    0,    0,  589,   56,    0,  193,  190,  273,
  270,  241,  238,    0,  410,  407,    0,  441,  438,    0,
    0,  439,  440,    0,    0,    0,    0,    0,    0,    0,
  123,    0,    0,    0,    0,    0,  542,  540,  539,  459,
    0,    0,    0,   23,   24,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   61,    0,   62,   63,
    0,    0,    0,    0,    0,    0,    0,    0,  144,    0,
    0,    0,    0,    0,    0,  389,    0,    0,  433,  535,
    0,    0,  430,    0,  431,  337,  336,    0,    0,    0,
  551,  131,  552,  127,  129,    0,  130,  553,  532,  530,
    0,  124,    0,  493,    0,    0,  597,  598,  482,    0,
    0,    0,    0,    0,    0,    0,  462,   21,    0,   77,
   96,  125,    0,    0,   99,  103,    0,    0,  101,   93,
   95,   60,   55,  556,  557,  541,   65,    0,  147,  153,
  150,    0,    0,    0,  158,    0,    0,    0,  165,  156,
  157,    0,  154,   27,  146,    0,    0,    0,    0,  199,
  198,    0,    0,  201,    0,    0,  192,    0,    0,    0,
    0,  339,    0,  281,    0,    0,    0,    0,  272,  284,
    0,    0,    0,    0,    0,  247,  246,    0,    0,    0,
  240,    0,  392,   27,  391,    0,    0,    0,    0,    0,
  409,    0,    0,    0,  432,    0,  592,  593,    0,    0,
  128,  531,  568,  567,  570,  495,  454,  484,  452,    0,
  451,    0,  470,  472,  475,  476,  477,  474,  471,  469,
  473,    0,    0,    0,  463,  587,    0,    0,  116,  117,
  118,  119,    0,    0,  112,    0,  104,  102,   59,  162,
  163,  164,  160,  579,    0,  161,  159,  168,  170,  171,
  169,  167,  166,  155,    0,  195,    0,  196,  197,    0,
    0,    0,   27,  194,  275,  290,    0,    0,  343,  344,
  345,  341,  280,    0,  278,  279,  338,  340,   27,    0,
  274,  243,    0,  244,  245,    0,    0,   27,  242,    0,
  412,    0,  413,  415,   27,  411,  442,    0,  595,  455,
  453,    0,    0,  450,    0,  610,    0,    0,    0,    0,
  464,  457,    0,  114,  120,  113,    0,    0,  108,  580,
  183,  179,  180,  181,  172,   48,  182,  148,    0,  175,
  177,    0,    0,    0,    0,  210,  211,  208,  209,    0,
    0,  206,    0,  220,  223,  224,    0,  205,    0,    0,
  287,    0,  283,    0,  347,  282,  348,  346,    0,  297,
    0,    0,  256,  254,  257,  255,  252,    0,    0,  394,
  393,    0,  397,  399,    0,  419,  420,  417,    0,    0,
    0,    0,    0,    0,    0,  494,    0,    0,  480,  483,
  487,    0,  456,    0,    0,    0,    0,  465,  115,  547,
  105,  548,  106,    0,    0,  176,   50,   51,    0,  212,
  213,    0,  214,    0,  207,  221,  225,  200,    0,  228,
  230,    0,    0,    0,    0,    0,    0,  276,    0,  289,
  342,  374,  369,  371,  370,  372,  362,  373,  277,    0,
  365,  367,    0,    0,  258,  259,  253,  260,  248,    0,
  263,  265,    0,    0,  398,    0,  418,  421,  416,    0,
  424,  426,  444,  445,  446,  447,  443,  437,  442,  497,
  510,  514,  513,  236,  360,  361,  268,  511,  604,  512,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  496,  486,    0,  485,  630,    0,    0,    0,
    0,  622,  629,    0,    0,  467,  111,    0,  109,    0,
  187,  185,  186,  184,  188,  178,  219,  218,  216,  215,
    0,  229,    0,  292,  294,  334,  293,  296,  295,  291,
    0,  366,    0,    0,    0,    0,    0,    0,    0,    0,
  285,    0,    0,  264,    0,    0,  404,  403,  402,  405,
  401,  400,    0,  425,    0,    0,    0,    0,    0,  515,
    0,  508,  509,    0,  502,    0,    0,    0,  500,  528,
    0,  526,  527,  524,  525,    0,    0,    0,  623,    0,
  625,  626,  627,  468,  466,  549,  110,  550,    0,  232,
  234,  233,  235,  231,    0,  377,  380,  376,  379,  375,
  378,  368,  299,  304,    0,    0,    0,  301,    0,  381,
  300,  298,    0,  267,  266,    0,  504,    0,  506,  507,
  519,  516,    0,  498,  499,  501,  576,  575,  488,  631,
  618,  619,  613,  617,    0,  615,  611,    0,    0,    0,
    0,    0,    0,  333,    0,    0,    0,    0,  505,    0,
  503,    0,  628,    0,    0,    0,  306,    0,    0,    0,
  302,    0,  349,    0,  303,    0,  384,  385,    0,  492,
  518,  522,    0,  616,  634,    0,  307,    0,    0,  325,
    0,    0,    0,  318,  319,    0,    0,    0,    0,    0,
    0,  352,  351,  350,  383,  387,    0,  521,    0,  520,
    0,    0,  329,    0,    0,  320,  321,  323,  324,  359,
  322,  328,  326,    0,    0,  309,    0,  310,  305,  382,
    0,  330,    0,    0,  314,    0,  315,  327,  312,  311,
  572,  571,  523,    0,    0,    0,  317,  316,  353,    0,
  331,    0,  358,  356,  355,  354,
};
short yydgoto[] = {                                       7,
  139,  140,  142,    0,  509,  699,  700,  701,  702,  839,
  835,  836,  837,  681,  224,  397,  279,  398,  682,  716,
  528,  529,  530,  443,  452,  542,  543,  794,  547,  618,
  619,  620,  719,  683,  548,  567,  568,  815,  649,  650,
  651,  684,  804,  857,  877,  889,  903,  904,  905,  808,
  725,  217,  277,  472,  556,  473,  477,  370,  468,  553,
  911,  944,  934,  935,  639,  640,  641,  802,  685,  686,
  165,  897,  866,  848,  752,  571,  572,  573,  578,  579,
  659,  660,  661,  211,  583,  581,  667,  591,  872,  446,
  404,   81,  726,  761,  933,  143,   21,  531,  125,  126,
  127,  532,  609,  128,   62,   25,  185,  434,  435,   64,
  166,  167,  172,  168,  169,  231,  688,  689,  690,  691,
  692,  703,  151,  190,  300,  829,    0,    0,  282,  845,
  787,   82,   83,  289,  106,  228,  771,  212,  248,  773,
  774,  108,  109,  251,  194,  192,  290,  291,  306,  307,
  422,  326,  284,  285,  313,  221,  314,  222,  292,  328,
  503,  592,  301,  587,  502,  873,  850,  822,  296,  762,
   85,   86,    8,    9,   10,   11,   12,   29,   13,   31,
   14,   36,   15,   44,   16,   53,   17,   59,   73,   70,
   71,  238,   72,  193,  244,  318,  519,  436,  604,  319,
  709,   45,   46,   47,   48,   49,   50,   51,   87,  197,
  260,  342,  334,  338,  343,  335,  339,   88,  199,  261,
  358,   90,  203,  263,  382,   89,  201,  262,  371,  550,
  474,  480,  644,  629,  742,  846,  554,  847,   92,  204,
  267,   93,  206,  268,  392,  101,  214,  215,  695,  899,
  594,
};
short yysindex[] = {                                   -137,
 -165,    0, -143, -160, -104,  -89,    0, -137,    0,    0,
    0, -238,  -43,  337, 1238, -216,  293,    0,    0,    0,
   28,   54,    0,    0,    0,  -94,    0,  328,    0,    0,
    0,    0,    0,   90, 1325,    0,    0,    0,    0,    0,
   78,    0,    0,    0,  123,  129,  146,  153,  162,  167,
  171,    0,    0,    0,  165,  173, 1211, 1211,    0,    0,
    0,  928,    0,   -2, 1461,    0,    0,  188,  159, -190,
    0,  327,  341,    0,  139,    0,    0,    0,    0,    0,
    0,    0,    0,  212,    0,    0,  351, -143, -143, -143,
    0,  354, -143,    0,    0,    0,    0,    0,    0,    0,
  356,  467,  659,    0,    0,   40,    0,    0,  159,    0,
  159,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  233,  989,    0,  759,    0,
 1608,    0,    0,    0,    0,    0,    0,    0,    0, 1608,
  435,    0,    0,  244,  211,    0,    0,    0,    0,  256,
  261,    0,    0,  407,  423,  426,    0,  428, 1205,    0,
    0,    0,    0,    0,  255,    0,  150, -142,    0,  253,
  156, -142,    0,  828,  759,  131,  478,    0, 1011,    0,
    0,    0,   98,    0,  177,    0,    0,  353,    0,    0,
    0,    0,  -67,  371,    0,    0,  -18,    0,    0,    0,
    0,    0,    0, -100,    0,    0,  363,    0,    0, 1325,
 -127,    0,    0,  427,  372,  378,  323,   90,  718, 1406,
    0, -235,  759, -209,   90, -209,    0,    0,    0,    0,
  535,  395, 1011,    0,    0,  759,  608, 1325,  411,  566,
 1325,  154,  413,  421,  424,  443,    0,  181,    0,    0,
  259,  456,  759,  188, -206, -270,  236,  -89,    0,  459,
  -17,  -82,  102,  466,  -89,    0,  510,  -75,    0,    0,
  718, 1406,    0,  513,    0,    0,    0, -138, -235, -235,
    0,    0,    0,    0,    0,  718,    0,    0,    0,    0,
 1325,    0,  585,    0,  562,  518,    0,    0,    0,  572,
  528, -209,  533,  395,  658,    5,    0,    0,  446,    0,
    0,    0,  718,   30,    0,    0,  188,  154,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  540,    0,    0,
    0, -178,  -24, -206,    0,  759,  772, -270,    0,    0,
    0,  236,    0,    0,    0,  542,  566,  244,  585,    0,
    0, 1325, 1325,    0,  401,  -89,    0,  556,  558,  695,
  441,    0,  155,    0,  188,  759,  759,  -89,    0,    0,
  584,  606,  566,  244,  585,    0,    0, 1325, 1325,  -89,
    0,  612,    0,    0,    0,  615,  566,  244, 1406,  -89,
    0,  617,  159,  620,    0,  759,    0,    0,  643,  645,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  648,
    0,  214,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  448,  668,  671,    0,    0,  614,  244,    0,    0,
    0,    0,   90,   30,    0, -170,    0,    0,    0,    0,
    0,    0,    0,    0,  678,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1075,    0, 1271,    0,    0, 1325,
 1325,  238,    0,    0,    0,    0,  759,  581,    0,    0,
    0,    0,    0,  807,    0,    0,    0,    0,    0,  845,
    0,    0,  727,    0,    0, 1325, 1325,    0,    0, 1207,
    0,  330,    0,    0,    0,    0,    0,  543,    0,    0,
    0,  494,  -88,    0,  716,    0,  759,   90, -209,  734,
    0,    0,  244,    0,    0,    0, 1366, 1366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1049,    0,
    0,  438,  585,  585,  742,    0,    0,    0,    0,  238,
  598,    0, 1271,    0,    0,    0,  -89,    0, 1278,  289,
    0,  759,    0,  807,    0,    0,    0,    0,  943,    0,
  585,  585,    0,    0,    0,    0,    0,  727, 1292,    0,
    0, 1389,    0,    0,  438,    0,    0,    0,  330, 1311,
  493,   90,  159,  750,  682,    0,  753,  760,    0,    0,
    0,  763,    0,   -1, -209, -209,  767,    0,    0,    0,
    0,    0,    0,  479, 1092,    0,    0,    0, -228,    0,
    0, -218,    0,  238,    0,    0,    0,    0, 1403,    0,
    0,  438,  777,  585,  244,  378, -138,    0,  786,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  852,
    0,    0,  438,  215,    0,    0,    0,    0,    0, 1418,
    0,    0,  438, 1440,    0,  124,    0,    0,    0, 1432,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  706,  708, -142, -142, -133, -133,  618, -133,  620,  620,
  620, -133,    0,    0,  813,    0,    0,   -1,  -23,   -1,
   34,    0,    0,  796,  800,    0,    0,  795,    0, 1092,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1440,    0,  699,    0,    0,    0,    0,    0,    0,    0,
  967,    0,  282,  811,  566,  720,  814,  975,  976,  155,
    0,  857, 1440,    0,  661, 1440,    0,    0,    0,    0,
    0,    0, 1458,    0,  493, -133,  759, -133, -133,    0,
  995,    0,    0,   90,    0, -133, -133, -133,    0,    0,
    8,    0,    0,    0,    0,   11, -252,   -1,    0,  759,
    0,    0,    0,    0,    0,    0,    0,    0, 1440,    0,
    0,    0,    0,    0,  967,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   -5, 1366,  585,    0, 1366,    0,
    0,    0, 1440,    0,    0, 1458,    0, -133,    0,    0,
    0,    0, -133,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  998,    0,    0,   -1,  994, 1079,
  814, 1010,  768,    0,  871,  788,  885,  362,    0,  -81,
    0,  107,    0,  759, 1020, 1423,    0,  759,  585,  888,
    0,  891,    0,  905,    0,  740,    0,    0,  908,    0,
    0,    0,  912,    0,    0, 1417,    0,  188,  188,    0,
  188,  188,  911,    0,    0,  807,  155,  789,  568,  914,
 1010,    0,    0,    0,    0,    0,  935,    0,  813,    0,
  188, 1071,    0,  532,  939,    0,    0,    0,    0,    0,
    0,    0,    0,  155,  941,    0,  942,    0,    0,    0,
 -123,    0, 1325,  944,    0,  945,    0,    0,    0,    0,
    0,    0,    0,  948, 1318,  861,    0,    0,    0,  973,
    0,  982,    0,    0,    0,    0,
};
short yyrindex[] = {                                     61,
    0,    0,    0,    0,    0, 1002,    0,  389,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  730,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  764,    0,    0,    0, -161,  110,    0,
    0,    0,    0,    0,  996,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -87,    0,    0,  -99,    0,
 1143,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1018,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   29,
  243,    0,    0,    0,  325,    0,    0,    0,    0,    0,
    0,    0,    0, 1022, 1023, 1032,    0, 1033,    0,    0,
    0,    0,    0,    0,  -59,    0,    0,  -77,    0,  -76,
    0,  -40,    0,    0,    0, 1144,    0,    0,    0,    0,
    0,    0,  829,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -68,    0,    0,    0,
    0, 1170,    0, 1143,    0, 1143,    0,    0,    0,    0,
    0,    0, 1045,    0,    0,    0,  444,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  552,    0,    0,
 1046,    0,    0,    0,    0,    0,    0,  798,    0,    0,
    0,    0,    0,    0, 1109,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1170, 1170,
    0,    0,    0,    0,    0,  183,    0,    0,    0,    0,
  299,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1143,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  536,    0,    0,    0,    0,  153,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1048,    0,    0,    0,  212,    0,    0,
    0, 1050,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1243,    0,    0,    0,    0,
   50,    0,    0,    0,    0,    0,    0,  909,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1262,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1327,
    0,    0,  178,  694,    0,  -41,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1143,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  162,    0, -157,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  629,    0,    0,    0,    0, 1052,
 1053, 1054,    0,    0,    0,    0,    0, 1056,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1059, 1063,    0,    0,  873,
    0,    0,    0,    0,    0,    0,    0,  902,    0,    0,
    0,    0,  890,    0,    0,    0,    0,    0, 1143,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  414,    0,
    0,  295,    0,    0,    0,    0,    0,    0,    0, 1054,
    0,    0, 1064,    0,    0,    0,    0,    0,  779,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1025,    0,
    0,    0,    0,    0,    0,    0,    0, 1065,  492,    0,
    0,  511,    0,    0,  276,    0,    0,    0, 1074,    0,
 1077,    0,  178,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1143, 1143,    0,    0,    0,    0,
    0,    0,    0,  171,  629,    0,    0,    0,    0,    0,
    0, 1257,    0, 1054,    0,    0,    0,    0,  379,    0,
    0,  815,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  134,
    0,    0,  577,    0,    0,    0,    0,    0,    0,  -97,
    0,    0,  850,  873,    0,    0,    0,    0,    0, 1078,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -72,  -44,   53,  169,   -4,  -63,  -36,  -36,
  -36,  -63,    0,    0,    0,    0,    0,    0,    0,  -11,
   49,    0,    0,    0,    0,    0,    0,    0,    0,  445,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  779,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1025,    0,    0,    0,    0,    0, 1080,    0,    0,    0,
    0,    0,  492,    0,    0,  530,    0,    0,    0,    0,
    0,    0,    0,    0, 1081,  -63,    0,  -63,  -63,    0,
 1082,    0,    0,    0,    0,  -63,  -63,  -63,    0,    0,
 1087,    0,    0,    0,    0,    0,  -45,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  403,    0,
    0,    0,    0,    0,  539,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -57,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0, 1089,    0,  -63,    0,    0,
    0,    0,  -63,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -25,    0,    0,  -10,    0, 1222,
  -57, 1091,    0,    0,    0,    0,    0,    0,    0,  999,
    0,    0,    0, 1225, 1107,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1111,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1091,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1125,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1127,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
  235,    0,    0,    0,  655,  696,  621,    0, -666,    0,
    0,  544,    0,    0,    0,  774,    0, -210,    0,    0,
    0,  797, -500,    0,    0,  875,    0,    0,    0,    0,
  700, -586,    0,    0, -487,  858,    0,    0,    0,  677,
 -609,    0,    0,  538,    0,    0, -738,    0,  524, -730,
 -744,    0,  804,  702, -534, -759,  582,    0,    0,    0,
    0,    0,  504,    0,    0,  731, -549,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  809, -540,  901,    0,
    0,  733, -611,    0,    0,  818,    0,    0,    0,    0,
 -119, -113,  191, -211,    0, -232,  439,  -47,  -85,    0,
 1305, -227,  366,    0,  537, 1244,    0,    0, 1055,    0,
  915, 1387,    0,    0, 1396,    0,    0,    0,    0,    0,
    0,  -28,    0,   37,  -52,    0,    0,    0,    0, -490,
    0, -155,  -56,  -32,    0,  802,  604, -185,  -50, 1310,
    0, -182, 1450,    0,    0,    0, -220,  487, 1208, -258,
    0,    0,  196,    0, 1294, -282, -333, -149, -207,    0,
    0,    0, -200,    0,    0,    0,    0,    0,  652,  880,
   -6,  -53,    0, 1508,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1456,    0,    0,    0,    0,    0,    0,    0,    0, 1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1189, 1198, 1209,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  703,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1331,    0,    0,
    0,
};
#define YYTABLESIZE 1907
short yytable[] = {                                      26,
  105,  105,   84,  110,  110,   75,  107,  107,  247,  183,
  295,  250,  297,  457,  124,  184,  145,  310,  227,  631,
  445,  331,  226,  573,  266,  303,  601,  603,  606,  620,
  621,  655,  722,  779,  293,  538,  590,  711,  698,  483,
  744,  181,  369,  871,  697,  121,  596,  425,  754,  391,
  121,  830,  613,  492,  591,  229,  176,  243,  177,  569,
    1,  184,  844,  335,  394,  332,  146,  295,  295,  831,
  402,  336,  832,  833,  842,  781,  782,  612,  121,  180,
  717,  594,  121,  718,  437,  144,  121,  440,  624,  624,
  732,   18,   65,  332,  624,   78,  783,  614,   22,  107,
  778,  410,  105,  298,  712,  110,  259,  357,  213,  184,
  855,  498,  620,  621,  892,  337,  308,  890,    1,    2,
  182,   78,  184,  219,   79,   80,  720,  913,  517,  424,
  518,  124,  475,  330,  778,  333,  293,  105,  271,  184,
  110,    3,    4,    5,  107,  107,  293,  181,   19,   20,
  917,  220,   23,  425,  928,  264,  780,  105,  298,  261,
  110,  441,  283,  213,  184,  287,  272,  588,  713,  538,
   24,  779,  624,  359,  869,  569,  834,  270,  538,  184,
  386,  494,  538,  283,  121,  180,  287,  294,  239,  280,
  387,   28,  121,  569,   52,  360,  302,  121,  240,  332,
  361,  591,  722,  744,  754,  655,  538,  538,  315,  606,
  335,  612,  121,  299,  283,  594,  448,  287,  596,  388,
  121,  510,  184,   30,  612,  121,  381,  714,  594,  283,
  715,  614,  287,  121,  444,  184,  241,  252,  346,  402,
  402,   66,   67,   68,  614,  732,  476,  478,  347,  612,
  606,   26,  184,  184,  121,  600,  283,   74,   26,  287,
  423,  184,  575,  442,  807,  402,  402,  389,  335,  614,
   78,   78,   78,  305,  362,   69,  499,  348,  607,  349,
  350,  351,  184,  601,   60,   72,  363,  364,  396,  760,
  283,  569,  841,  287,  365,  366,  595,    6,  367,  931,
  777,  262,  144,  427,   78,  122,  286,  624,  597,  569,
   61,   72,  620,  621,  253,  843,  283,  254,  605,  287,
  255,  622,  256,  599,  428,  352,  353,   91,  538,  538,
  283,  643,  354,  287,  265,  538,  538,  589,  505,  741,
  497,  653,   63,  870,  575,  121,  596,  551,   74,   26,
  121,  912,  368,  184,  591,   47,   47,  372,   47,  390,
  557,   26,  242,  335,  573,  186,  573,  373,   52,  448,
   91,  355,  624,   26,  187,  608,  538,  612,  121,   94,
  602,  594,  121,   26,  458,   95,  121,  298,    2,  135,
  363,  622,  573,  184,  704,  705,  374,  614,  375,  376,
  377,  805,   96,  573,  515,  135,  766,  767,  768,   97,
  484,  257,  643,  628,  747,  135,  258,  356,   98,  184,
  184,  554,  653,   99,  493,  569,  575,  100,  831,  286,
  827,  832,  630,  102,  573,  129,  429,  430,  184,  122,
  557,  103,  574,  135,  378,  379,  141,  184,  184,  148,
  431,  432,  122,  144,  135,  135,  433,  135,  174,  175,
   72,   72,   72,  149,  514,  150,  393,  558,  152,  423,
  734,  428,   52,  153,  448,  448,  157,  122,  159,  596,
  735,  401,  305,  405,  602,  602,  865,   52,   52,  178,
   66,  609,  188,  622,   72,  246,  603,   47,   47,  585,
   47,  621,  189,  643,  191,   47,   47,  298,  401,  772,
  184,  642,  775,  184,  195,  653,   47,  196,  575,  748,
  749,  652,  448,  448,  574,  585,  154,  155,  156,  198,
  669,  158,  662,  758,  759,  834,  380,  234,  235,  459,
  616,  573,  573,  573,  623,  200,  818,  558,  202,  599,
  205,  273,  227,  668,  216,  554,  469,  470,  624,  471,
   49,  622,  316,  317,  554,  485,   49,  643,  554,  340,
  341,  621,  736,  737,  738,  573,  218,  739,  750,  751,
  223,   75,  225,  625,   47,  653,   47,   47,  626,   47,
  573,   47,  642,  554,  230,  122,  324,  325,  573,  573,
  232,   54,  652,  122,  122,  122,  574,   75,  573,  122,
   65,  237,  662,  122,  740,  236,  627,  864,  586,  269,
   76,   24,   77,   78,   79,   80,  245,   49,  275,   76,
   24,   77,   78,   79,   80,  226,  276,  298,  105,  544,
  545,  110,  546,  184,   32,  906,  907,  104,  908,  909,
  278,  585,  585,  796,  797,   91,  925,  304,  126,  227,
  840,  727,  867,  305,  798,  309,  184,  311,  922,  320,
  173,   49,   49,  621,  585,  585,  585,  321,  283,   47,
  322,  287,  327,  642,  406,   76,   24,   77,   78,   79,
   80,   49,  916,  184,  408,  652,   52,  448,  574,  323,
  586,  174,  936,  208,  426,  662,   55,   56,  585,  932,
   47,  554,  329,  772,  936,  345,  775,  135,  828,  554,
  554,  554,  383,  610,  611,  554,  586,  576,  577,  554,
   49,   49,  799,  135,  875,  823,  209,  800,  478,  801,
  184,  621,  144,  135,  184,  184,   47,  642,   33,  584,
   49,  645,  646,   49,   57,   58,   75,   75,   75,   66,
   67,   68,  585,   34,   35,  652,  385,  395,  662,  395,
  506,  135,  557,  602,  407,  507,  602,   47,  160,  210,
  707,  708,  135,  135,  409,  135,  396,  924,  210,  411,
   75,  105,  126,   69,  110,  364,  439,  868,  456,  428,
   52,   47,  448,  448,  462,  126,  126,  126,  555,  126,
   47,  161,  464,  602,  465,   52,   52,  466,   66,  467,
   47,  555,  162,  915,   76,   24,   77,   78,   79,   80,
  126,   47,   47,  126,   47,   47,   47,   47,  460,  461,
  481,   47,  105,  182,  210,  110,  555,   79,   80,  163,
  448,  448,  586,  586,  126,   47,   47,  403,   47,   47,
   47,   47,  482,  164,  486,  487,   47,   47,  489,   47,
  299,  491,   47,  496,  508,  586,  586,  586,  281,  558,
  455,  126,  126,  126,  126,  219,  126,  126,  126,  126,
  607,  608,  878,  879,   47,  901,  902,   47,   47,  500,
   47,  501,  880,   47,  504,  663,   47,   47,  513,  586,
   47,   47,  861,  664,  665,  881,  882,  883,  884,  885,
  490,   47,  413,  666,  511,   47,   47,  512,  878,  879,
  399,  400,  886,  126,  126,  887,  520,  888,  880,  126,
  656,  126,  126,  126,   47,   47,  671,   47,   49,   49,
  121,  881,  882,  883,  884,  885,  126,  126,  672,   49,
  552,   47,  126,   47,   47,   47,   47,  560,  886,  582,
  160,  887,  593,  888,  555,  555,   76,   24,   77,   78,
   79,   80,   47,   47,   47,   47,  414,  723,  121,   47,
  598,   47,   47,  160,   47,   25,   47,  561,  562,  549,
  612,  614,  415,  161,   25,   25,  670,  312,  733,  693,
  673,   25,  416,  417,  170,  559,  694,  182,  745,  696,
   25,   79,   80,  706,  569,   47,  674,   49,  506,   20,
  281,  580,   49,  724,   49,  757,  675,  676,   20,   20,
  418,  163,  730,  860,  764,   20,   76,   24,   77,   78,
   79,   80,  784,   76,   20,  164,  785,   79,   80,   25,
   25,   25,   25,   19,  677,  555,   24,  803,  419,   79,
   80,   76,   24,   77,   78,   79,   80,  563,  564,  565,
  566,   47,   47,  807,   47,  806,   76,   47,   19,  104,
   79,   80,  678,   20,   20,   20,   20,  809,  810,  420,
  600,   25,   25,   25,   25,   25,  121,  786,  449,  450,
  451,   25,   25,  812,  121,  121,  814,  821,  853,  421,
  121,  852,  854,  679,  121,   25,   25,   19,   19,   19,
   19,   25,  856,  632,  858,   20,   20,   20,   20,   20,
  859,  863,  876,  680,  893,   20,   20,  894,  479,  479,
  479,  479,  479,  479,  790,  791,  792,  793,  436,   20,
   20,  895,  896,   47,  898,   20,  479,   25,  900,  910,
  918,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   19,  920,  914,  923,   19,  927,  436,  929,  930,   19,
  937,  938,  112,  113,  939,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,  632,  633,  634,  635,  943,  945,
  210,   47,   47,  636,   47,   47,   47,   47,  946,   19,
   19,   19,   19,   19,   19,   19,   19,   19,  632,   19,
   19,   19,  588,   19,  770,   19,   19,  491,  491,  491,
  491,  491,  491,  112,  113,  573,  458,   22,   47,   47,
   49,   49,   49,   49,   31,  491,   19,   19,  191,  271,
   19,   19,   19,   19,   19,  112,  113,  731,  239,  408,
   19,   19,  569,  115,  116,  117,  118,  119,  120,  121,
  122,   32,   64,  526,  151,   49,  149,  479,  203,  204,
   19,  638,  288,  222,  436,  250,  633,  634,  635,  251,
  202,  249,  436,  436,  636,   47,   47,   47,   47,  114,
  414,  479,  436,  434,  422,  756,  332,  435,  517,  521,
  633,  634,  635,  573,  637,  423,  632,  308,  636,  633,
   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
   19,   19,   19,  313,   19,  521,   19,  386,   19,  115,
  116,  117,  118,  119,  120,  121,  122,  123,  522,  523,
  524,  569,  521,  357,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  776,  526,  874,   47,   47,  838,   19,
  729,  710,  638,   19,  522,  523,  524,   47,  115,  116,
  117,  118,  119,  120,  121,  122,  491,  615,  526,  813,
  789,  522,  523,  524,  179,  647,  638,  926,  919,  728,
  115,  116,  117,  118,  119,  120,  121,  122,  942,  891,
  491,  811,  941,   19,   19,   19,   19,   19,   19,   19,
   19,   19,  115,  116,  117,  118,  119,  120,  121,  122,
  207,  795,  746,   76,   24,   77,   78,   79,   80,   76,
   24,   77,   78,   79,   80,   47,  525,   47,   47,  657,
   47,  208,   47,  233,  605,  816,  755,  104,  516,  171,
  115,  116,  117,  118,  119,  120,  121,  122,  173,  687,
  526,  344,  921,  249,   19,   19,  527,  111,  384,  788,
   19,  412,  286,  217,  209,   27,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  147,  526,  217,  217,  438,
  454,  447,  527,  115,  116,  117,  118,  119,  120,  121,
  122,  533,  534,  526,  274,    0,  453,    0,  862,  527,
   19,   19,   19,   19,   19,   19,   19,   19,   19,    0,
   19,   19,   19,   19,   19,  763,   37,  765,    0,    0,
    0,  769,    0,  940,    0,  217,   76,   24,   77,   78,
   79,   80,   38,   76,   24,   77,   78,   79,   80,  535,
    0,    0,   39,    0,    0,    0,    0,    0,    0,  463,
    0,    0,  217,  217,  217,  217,    0,    0,  570,    0,
    0,  479,    0,    0,    0,    0,  536,  537,  538,  539,
   40,    0,  210,  488,   76,   24,   77,   78,   79,   80,
    0,   41,   42,  495,   43,  817,    0,  819,  820,    0,
    0,    0,    0,    0,   19,  824,  825,  826,  115,  116,
  117,  118,  119,  120,  121,  122,  123,    0,  526,    0,
  217,    0,  217,   19,   76,   24,   77,   78,   79,   80,
    0,    0,    0,    0,  540,    0,  541,    0,  600,  617,
    0,    0,    0,    0,   19,   19,   19,   19,   19,   19,
   19,   19,   19,  648,   19,   19,   19,  849,   19,   19,
   19,   19,  851,   19,   19,   19,   19,   19,   19,   19,
   19,   19,  658,   19,   19,   19,  288,   19,    0,  115,
  116,  117,  118,  119,  120,  121,  122,  123,   19,  526,
    0,    0,    0,  115,  116,  117,  118,  119,  120,  121,
  122,  123,  130,  526,  131,  132,  133,  134,  135,  136,
  137,  138,  115,  116,  117,  118,  119,  120,  121,  122,
  123,    0,    0,    0,    0,    0,    0,    0,   19,   19,
   19,   19,   19,   19,   19,   19,   19,  878,  879,    0,
  901,  902,    0,  878,  879,    0,    0,  880,    0,    0,
    0,    0,    0,  880,    0,    0,    0,    0,    0,    0,
  881,  882,  883,  884,  885,    0,  881,  882,  883,  884,
  885,    0,    0,    0,    0,    0,    0,  886,    0,    0,
  887,    0,  888,  886,  654,    0,  887,    0,  888,    0,
  115,  116,  117,  118,  119,  120,  121,  122,  721,    0,
  526,    0,    0,    0,  115,  116,  117,  118,  119,  120,
  121,  122,    0,  743,  526,    0,    0,    0,    0,  115,
  116,  117,  118,  119,  120,  121,  122,  753,    0,  526,
    0,    0,    0,  115,  116,  117,  118,  119,  120,  121,
  122,  115,  116,  117,  118,  119,  120,  121,  122,  130,
    0,  526,  132,  133,  134,  135,  136,  137,  138,  115,
  116,  117,  118,  119,  120,  121,  122,
};
short yycheck[] = {                                       6,
   57,   58,   35,   57,   58,   34,   57,   58,  194,  129,
  222,  194,  223,  347,   62,  129,   69,  238,  174,  554,
   45,  254,  172,  123,  125,  226,  517,  518,  529,   41,
   41,  572,  619,  700,  270,  123,  125,  266,   40,  373,
  650,  127,  125,  125,   46,  123,  123,  306,  660,  125,
  123,   41,  540,  387,  123,  175,  109,  125,  111,  123,
    0,  175,  807,  123,  272,  123,  257,  279,  280,  322,
  291,  342,  325,  326,  805,   42,   43,  123,  123,  127,
  299,  123,  123,  302,  317,  295,  123,  266,   40,   41,
  640,  257,  283,  300,   46,  257,   63,  123,  259,  257,
  124,  302,  159,  223,  333,  159,  125,  125,  159,  223,
  841,  394,  124,  124,  859,  386,  236,  856,  256,  257,
  259,  283,  236,  266,  263,  264,  614,  887,  299,  125,
  301,  179,  365,  253,  124,  342,  270,  194,  266,  253,
  194,  279,  280,  281,  302,  303,  270,  233,  292,  293,
  889,  294,  257,  412,  914,  256,  123,  214,  278,  257,
  214,  340,  219,  214,  278,  219,  294,  256,  397,  257,
  260,  838,  124,  256,  256,  123,  429,  210,  266,  293,
  256,  389,  270,  240,  257,  233,  240,  423,  256,  218,
  266,  430,  270,  257,  411,  278,  225,  270,  266,  257,
  283,  270,  789,  813,  816,  746,  294,  295,  241,  710,
  270,  257,  257,  423,  271,  257,  336,  271,  295,  295,
  257,  422,  336,  267,  270,  270,  125,  456,  270,  286,
  459,  257,  286,  270,  259,  349,  304,  256,  256,  460,
  461,  432,  433,  434,  270,  795,  366,  367,  266,  295,
  323,  258,  366,  367,  295,  328,  313,  259,  265,  313,
  256,  375,  490,  442,  270,  486,  487,  343,  328,  295,
  432,  433,  434,  269,  357,  466,  396,  295,  323,  297,
  298,  299,  396,  328,  257,  257,  369,  370,  427,  423,
  347,  123,  298,  347,  377,  378,  507,  435,  381,  423,
  324,  257,  295,  274,  466,  123,  257,  259,  509,  257,
  257,  283,  324,  324,  333,  806,  373,  336,  323,  373,
  339,  549,  341,  328,  295,  343,  344,  267,  416,  417,
  387,  559,  350,  387,  435,  423,  424,  426,  125,  125,
  393,  569,  437,  425,  572,  423,  423,  467,  259,  356,
  423,  886,  435,  467,  423,  453,  454,  256,  456,  435,
  474,  368,  430,  423,  464,  131,  257,  266,  308,  309,
  293,  389,  324,  380,  140,  323,  464,  423,  423,  257,
  328,  423,  423,  390,  348,  257,  423,  507,    0,  329,
  257,  619,  283,  507,  595,  596,  295,  423,  297,  298,
  299,  735,  257,  294,  433,  345,  689,  690,  691,  257,
  374,  430,  640,  125,  291,  355,  435,  435,  257,  533,
  534,  123,  650,  257,  388,  257,  654,  257,  322,  380,
  423,  325,  552,  269,  257,  438,  407,  408,  552,  257,
  554,  269,  490,  383,  343,  344,  259,  561,  562,  123,
  421,  422,  270,  295,  394,  395,  427,  397,  419,  420,
  432,  433,  434,  123,  428,  327,  271,  474,  257,  256,
  256,  411,  412,  123,  414,  415,  123,  295,  123,  508,
  266,  286,  269,  293,  517,  518,  125,  427,  428,  257,
  430,  323,   58,  721,  466,  125,  328,  453,  454,  257,
  456,  549,  259,  731,  294,  372,  373,  627,  313,  695,
  624,  559,  695,  627,  259,  743,  383,  257,  746,  396,
  397,  569,  462,  463,  572,  283,   88,   89,   90,  123,
  583,   93,  580,  683,  684,  429,  435,  440,  441,  349,
  547,  432,  433,  434,  256,  123,  757,  554,  123,  513,
  123,  125,  708,  582,  300,  257,  402,  403,  270,  405,
  266,  789,  409,  410,  266,  375,  291,  795,  270,  334,
  335,  619,  358,  359,  360,  466,  427,  363,  455,  456,
  328,  257,  427,  295,  451,  813,  453,  454,  300,  456,
  413,  458,  640,  295,  464,  413,  416,  417,  421,  422,
  123,  309,  650,  421,  422,  423,  654,  283,  431,  427,
  283,  259,  660,  431,  400,  439,  328,  256,  125,  257,
  259,  260,  261,  262,  263,  264,  256,  333,  257,  259,
  260,  261,  262,  263,  264,  257,  259,  757,  695,  402,
  403,  695,  405,  757,  308,  878,  879,  277,  881,  882,
  328,  409,  410,  372,  373,  267,  125,  123,  123,  257,
  780,  625,  848,  269,  383,   58,  780,  257,  901,  257,
  257,  396,  397,  721,  432,  433,  434,  257,  735,  266,
  257,  735,  424,  731,  123,  259,  260,  261,  262,  263,
  264,  397,  125,  807,  123,  743,  308,  309,  746,  257,
  257,  257,  923,  277,  259,  753,  414,  415,  466,  921,
  266,  413,  257,  899,  935,  257,  899,  329,  771,  421,
  422,  423,  257,  533,  534,  427,  283,  398,  399,  431,
  455,  456,  451,  345,  854,  764,  310,  456,  858,  458,
  854,  789,  295,  355,  858,  859,  333,  795,  412,  256,
  456,  561,  562,  459,  462,  463,  432,  433,  434,  432,
  433,  434,  269,  427,  428,  813,  257,  257,  816,  257,
  323,  383,  886,  806,  257,  328,  809,  333,  312,  418,
  302,  303,  394,  395,  257,  397,  257,  256,  418,  257,
  466,  848,  257,  466,  848,  257,  257,  848,  257,  411,
  412,  291,  414,  415,  404,  270,  271,  272,  257,  274,
  397,  345,  257,  846,  257,  427,  428,  123,  430,  379,
  291,  270,  356,  256,  259,  260,  261,  262,  263,  264,
  295,  453,  454,  298,  456,  457,  458,  459,  352,  353,
  257,  397,  899,  259,  418,  899,  295,  263,  264,  383,
  462,  463,  409,  410,  319,  453,  454,  273,  456,  457,
  458,  459,  257,  397,  378,  379,  453,  454,  257,  456,
  423,  257,  459,  257,  427,  432,  433,  434,  313,  886,
  344,  346,  347,  348,  349,  266,  351,  352,  353,  354,
  453,  454,  361,  362,  266,  364,  365,  453,  454,  257,
  456,  257,  371,  459,  257,  413,  396,  397,  295,  466,
  372,  373,  125,  421,  422,  384,  385,  386,  387,  388,
  384,  383,  265,  431,  257,  396,  397,  257,  361,  362,
  279,  280,  401,  398,  399,  404,  259,  406,  371,  404,
  575,  406,  407,  408,  453,  454,  265,  456,  372,  373,
  257,  384,  385,  386,  387,  388,  421,  422,  277,  383,
  380,  333,  427,  453,  454,  455,  456,  123,  401,  427,
  312,  404,  257,  406,  423,  424,  259,  260,  261,  262,
  263,  264,  453,  454,  455,  456,  329,  622,  295,  451,
  257,  453,  454,  312,  456,  266,  458,  271,  272,  463,
  259,  404,  345,  345,  275,  276,  257,  442,  643,  257,
  329,  282,  355,  356,  356,  479,  257,  259,  653,  257,
  291,  263,  264,  257,  488,  397,  345,  451,  323,  266,
  313,  495,  456,  257,  458,  328,  355,  356,  275,  276,
  383,  383,  257,  256,  427,  282,  259,  260,  261,  262,
  263,  264,  257,  259,  291,  397,  257,  263,  264,  330,
  331,  332,  333,  266,  383,  259,  260,  257,  411,  263,
  264,  259,  260,  261,  262,  263,  264,  351,  352,  353,
  354,  453,  454,  270,  456,  366,  259,  459,  291,  277,
  263,  264,  411,  330,  331,  332,  333,  123,  123,  442,
  313,  372,  373,  374,  375,  376,  413,  313,  337,  338,
  339,  382,  383,  257,  421,  422,  456,  123,  125,  462,
  427,  124,   44,  442,  431,  396,  397,  330,  331,  332,
  333,  402,  123,  282,  367,  372,  373,  374,  375,  376,
  270,  257,  123,  462,  257,  382,  383,  257,  259,  260,
  261,  262,  263,  264,  456,  457,  458,  459,  257,  396,
  397,  257,  423,  291,  257,  402,  277,  438,  257,  259,
  257,  442,  443,  444,  445,  446,  447,  448,  449,  450,
  451,  452,  453,  454,  455,  456,  457,  458,  459,  460,
  282,  257,  404,  123,  397,  257,  295,  257,  257,  402,
  257,  257,  275,  276,  257,  442,  443,  444,  445,  446,
  447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
  457,  458,  459,  460,  282,  374,  375,  376,  368,  257,
  418,  453,  454,  382,  456,  457,  458,  459,  257,  442,
  443,  444,  445,  446,  447,  448,  449,  450,  282,  452,
  453,  454,  257,  456,  442,  458,  459,  259,  260,  261,
  262,  263,  264,  275,  276,  123,  123,  439,  396,  397,
  456,  457,  458,  459,  257,  277,  275,  276,  257,  257,
  372,  373,  374,  375,  376,  275,  276,  436,  257,  257,
  382,  383,  123,  442,  443,  444,  445,  446,  447,  448,
  449,  257,  257,  452,  257,  456,  257,  418,  257,  257,
  402,  460,  257,  260,  413,  257,  374,  375,  376,  257,
  257,  257,  421,  422,  382,  453,  454,  455,  456,  402,
  257,  442,  431,  257,  257,  681,  257,  257,  257,  291,
  374,  375,  376,  257,  402,  257,  125,  257,  382,  125,
  442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,  454,  257,  456,  291,  458,  257,  460,  442,
  443,  444,  445,  446,  447,  448,  449,  450,  330,  331,
  332,  257,  291,  257,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  698,  452,  852,  372,  373,  778,  291,
  627,  605,  460,  402,  330,  331,  332,  383,  442,  443,
  444,  445,  446,  447,  448,  449,  418,  543,  452,  743,
  721,  330,  331,  332,  436,  568,  460,  904,  891,  626,
  442,  443,  444,  445,  446,  447,  448,  449,  935,  858,
  442,  740,  125,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  442,  443,  444,  445,  446,  447,  448,  449,
  256,  731,  654,  259,  260,  261,  262,  263,  264,  259,
  260,  261,  262,  263,  264,  451,  402,  453,  454,  579,
  456,  277,  458,  179,  436,  753,  669,  277,  434,  103,
  442,  443,  444,  445,  446,  447,  448,  449,  103,  585,
  452,  258,  899,  194,  396,  397,  458,   58,  265,  708,
  402,  304,  219,  257,  310,    8,  442,  443,  444,  445,
  446,  447,  448,  449,  450,   70,  452,  271,  272,  318,
  342,  334,  458,  442,  443,  444,  445,  446,  447,  448,
  449,  271,  272,  452,  214,   -1,  338,   -1,  846,  458,
  442,  443,  444,  445,  446,  447,  448,  449,  450,   -1,
  452,  453,  454,  455,  456,  686,  329,  688,   -1,   -1,
   -1,  692,   -1,  256,   -1,  319,  259,  260,  261,  262,
  263,  264,  345,  259,  260,  261,  262,  263,  264,  319,
   -1,   -1,  355,   -1,   -1,   -1,   -1,   -1,   -1,  356,
   -1,   -1,  346,  347,  348,  349,   -1,   -1,  402,   -1,
   -1,  368,   -1,   -1,   -1,   -1,  346,  347,  348,  349,
  383,   -1,  418,  380,  259,  260,  261,  262,  263,  264,
   -1,  394,  395,  390,  397,  756,   -1,  758,  759,   -1,
   -1,   -1,   -1,   -1,  402,  766,  767,  768,  442,  443,
  444,  445,  446,  447,  448,  449,  450,   -1,  452,   -1,
  404,   -1,  406,  402,  259,  260,  261,  262,  263,  264,
   -1,   -1,   -1,   -1,  404,   -1,  406,   -1,  313,  402,
   -1,   -1,   -1,   -1,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  402,  452,  453,  454,  818,  456,  457,
  458,  459,  823,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  402,  452,  453,  454,  311,  456,   -1,  442,
  443,  444,  445,  446,  447,  448,  449,  450,  402,  452,
   -1,   -1,   -1,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  282,  452,  284,  285,  286,  287,  288,  289,
  290,  291,  442,  443,  444,  445,  446,  447,  448,  449,
  450,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
  444,  445,  446,  447,  448,  449,  450,  361,  362,   -1,
  364,  365,   -1,  361,  362,   -1,   -1,  371,   -1,   -1,
   -1,   -1,   -1,  371,   -1,   -1,   -1,   -1,   -1,   -1,
  384,  385,  386,  387,  388,   -1,  384,  385,  386,  387,
  388,   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,
  404,   -1,  406,  401,  436,   -1,  404,   -1,  406,   -1,
  442,  443,  444,  445,  446,  447,  448,  449,  436,   -1,
  452,   -1,   -1,   -1,  442,  443,  444,  445,  446,  447,
  448,  449,   -1,  436,  452,   -1,   -1,   -1,   -1,  442,
  443,  444,  445,  446,  447,  448,  449,  436,   -1,  452,
   -1,   -1,   -1,  442,  443,  444,  445,  446,  447,  448,
  449,  442,  443,  444,  445,  446,  447,  448,  449,  282,
   -1,  452,  285,  286,  287,  288,  289,  290,  291,  442,
  443,  444,  445,  446,  447,  448,  449,
};
#define YYFINAL 7
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 466
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,
"':'",0,0,0,0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"L_EOS","L_ERROR","L_NUMBER","L_STRING","L_HNAME","L_KEYWORD",
"L_HEXSTRING","L_OCTETSTRING","T_DIRECT","T_INTERFACE","T_INTERFACES",
"T_LCLADDR","T_PROTO","T_METRIC","T_METRICIN","T_METRICOUT","T_INFINITY",
"T_DOWN","T_PARSE","T_ADV","T_DEFAULT","T_DEFAULTS","T_YYDEBUG","T_YYSTATE",
"T_YYQUIT","T_DEBUG","T_SYSLOG","T_UPTO","T_EMERG","T_ALERT","T_CRIT","T_ERR",
"T_WARNING","T_NOTICE","T_INFO","T_ON","T_OFF","T_GATEWAY","T_PREFERENCE",
"T_PREFERENCE2","T_DEFAULTMETRIC","T_NONBROADCAST","T_BROADCAST","T_TYPE",
"T_POINTOPOINT","T_MULTICAST","T_NETMASK","T_DEFINE","T_INTERNAL","T_EXTERNAL",
"T_IGNORE","T_NOP","T_NOP1","T_NOP_DM","T_NOP_ADV","T_NOP_PROTO",
"T_NOP_SOCKADDR","T_PEERAS","T_LOCALAS","T_NEIGHBOR","T_GROUP","T_NOGENDEFAULT",
"T_VERSION","T_ACQUIRE","T_TTL","T_EGP","T_ASPATH","T_ORIGIN","T_INCOMPLETE",
"T_ANY","T_LOOPS","T_TAG","T_KERNEL","T_SYMBOLS","T_REMNANTS","T_IFLIST",
"T_ROUTES","T_NOCHANGE","T_NOFLUSHATEXIT","T_REMNANTHOLDTIME","T_HIGHER",
"T_LOWER","T_FLASH","T_INTERIOR","T_BACKGROUND","T_LIMIT","T_TRUSTEDGATEWAYS",
"T_SOURCEGATEWAYS","T_RIP","T_RIPOUT","T_NORIPOUT","T_RIPIN","T_NORIPIN",
"T_NOCHECKZERO","T_HELLOOUT","T_HELLOIN","T_NOHELLOOUT","T_NOHELLOIN","T_OSPF",
"T_OSPF_ASE","T_BACKBONE","T_VIRTUALLINK","T_STUB","T_STUBHOSTS",
"T_RXMITINTERVAL","T_INFTRANSDELAY","T_NETWORKS","T_POLLINTERVAL","T_ROUTERS",
"T_NEIGHBORID","T_TRANSITAREA","T_ELIGIBLE","T_MONITORAUTH","T_MONITORAUTHKEY",
"T_NOMULTICAST","T_DD","T_ACK","T_LSA_BLD","T_LSA_RX","T_LSA_TX",
"T_EXPORTINTERVAL","T_EXPORTLIMIT","T_FIRST","T_EVERY","T_AREA","T_SPF",
"T_HELLO","T_HELLOINTERVAL","T_ROUTERDEADINTERVAL","T_PRIORITY","T_ENABLE",
"T_DISABLE","T_QUERY","T_QUERYINTERVAL","T_MODE","T_ADVERTISE","T_REGISTER",
"T_SNMP","T_ICMP","T_ROUTERDISCOVERY","T_REDIRECT","T_REDIRECTS",
"T_NOREDIRECTS","T_AUTHTYPE","T_AUTHKEY","T_NONE","T_SIMPLE","T_AUTH","T_MD5",
"T_SECONDARY","T_PASSIVE","T_SIMPLEX","T_STRICTIFS","T_SCANINTERVAL","T_STATIC",
"T_MARTIANS","T_RETAIN","T_EXPORT","T_IMPORT","T_EXACT","T_REFINE","T_HOST",
"T_MASK","T_MASKLEN","T_REJECT","T_BLACKHOLE","T_RESTRICT","T_ALLOW",
"T_ANNOUNCE","T_LISTEN","T_AS","T_ROUTERID","T_IGP","T_OPTIONS","T_NOINSTALL",
"T_NOSEND","T_NORESOLV","T_MARK","T_TRACEOPTIONS","T_EXCEPT","T_REPLACE",
"T_SIZE","T_FILES","T_K","T_M","T_ALL","T_ROUTE","T_STATE","T_POLICY",
"T_NORMAL","T_GENERAL","T_TASK","T_TIMER","T_NOSTAMP","T_UPDATE","T_DETAIL",
"T_SEND","T_RECEIVE","T_ERROR","T_PACKETS","T_RESPONSE","T_REQUEST","T_OTHER",
"T_TRAP","L_USEC","T_AGGREGATE","T_GENERATE","T_BRIEF","T_INET","T_GENDEFAULT",
};
char *yyrule[] = {
"$accept : config",
"config :",
"config : statements",
"statements : statement",
"statements : statements statement",
"statement : parse_statement",
"statement : trace_statement",
"statement : option_order option_statement",
"statement : interface_order interface_statement",
"statement : define_order define_statement",
"statement : proto_order proto_statement",
"statement : route_order route_statement",
"statement : control_order control_statement",
"statement : error L_EOS",
"statement : L_EOS",
"parse_statement : T_YYDEBUG onoff_option L_EOS",
"parse_statement : T_YYSTATE L_NUMBER L_EOS",
"parse_statement : T_YYQUIT L_EOS",
"trace_statement : T_TRACEOPTIONS trace_file_option trace_control_option trace_trace_options_none L_EOS",
"trace_file_option :",
"trace_file_option : string trace_replace",
"trace_file_option : string trace_replace T_SIZE trace_size T_FILES number",
"trace_size : number",
"trace_size : number T_K",
"trace_size : number T_M",
"trace_replace :",
"trace_replace : T_REPLACE",
"trace_control_option :",
"trace_control_option : trace_control_option trace_control_options",
"trace_control_options : T_NOSTAMP",
"trace_trace_options_none : T_NONE",
"trace_trace_options_none : trace_trace_options",
"trace_trace_options_none : trace_trace_options T_EXCEPT trace_trace_options",
"trace_trace_options : trace_option",
"trace_trace_options : trace_option_global",
"trace_trace_options : trace_trace_options trace_option",
"trace_trace_options : trace_trace_options trace_option_global",
"trace_option_global : T_PARSE",
"trace_option_global : T_ADV",
"trace_option : T_ROUTE",
"trace_option : T_NORMAL",
"trace_option : T_GENERAL",
"trace_option : T_STATE",
"trace_option : T_POLICY",
"trace_option : T_TASK",
"trace_option : T_TIMER",
"trace_option : T_ALL",
"trace_option_detail :",
"trace_option_detail : T_DETAIL",
"trace_option_sendrecv :",
"trace_option_sendrecv : T_SEND",
"trace_option_sendrecv : T_RECEIVE",
"define_order :",
"define_statement : T_NOP",
"$$1 :",
"define_statement : T_MARTIANS $$1 '{' martian_list_inet '}' L_EOS",
"define_statement : T_AS as as_loop_option L_EOS",
"define_statement : T_ROUTERID host_inet L_EOS",
"martian_list_inet :",
"martian_list_inet : martian_list_inet martian_inet martian_option L_EOS",
"martian_list_inet : martian_list_inet error L_EOS",
"martian_inet : host_mask_inet",
"martian_inet : network_mask_flags_inet",
"martian_inet : default_mask_inet",
"martian_option :",
"martian_option : T_ALLOW",
"option_order :",
"option_statement : T_OPTIONS option_list L_EOS",
"option_list : option",
"option_list : option_list option",
"option : T_NOSEND",
"option : T_NORESOLV",
"option : T_SYSLOG syslog_mask",
"option : T_MARK mark_time",
"option : T_GENDEFAULT preference_option default_gateway_option",
"default_gateway_option :",
"$$2 :",
"default_gateway_option : T_GATEWAY $$2 gateway_inet",
"mark_time :",
"mark_time : time",
"syslog_mask : syslog_level",
"syslog_mask : T_UPTO syslog_level",
"syslog_mask : syslog_mask syslog_level",
"syslog_level : T_EMERG",
"syslog_level : T_ALERT",
"syslog_level : T_CRIT",
"syslog_level : T_ERR",
"syslog_level : T_WARNING",
"syslog_level : T_NOTICE",
"syslog_level : T_INFO",
"syslog_level : T_DEBUG",
"interface_order :",
"$$3 :",
"interface_statement : T_INTERFACES $$3 '{' interface_stmts '}' L_EOS",
"interface_stmts :",
"interface_stmts : interface_stmts interface_stmt L_EOS",
"interface_stmts : interface_stmts error L_EOS",
"interface_stmt : T_OPTIONS interface_options",
"interface_stmt : T_INTERFACE interface_all_list interface_define_options",
"$$4 :",
"interface_stmt : T_DEFINE host_inet $$4 interface_type_options interface_common_options",
"interface_options : interface_option",
"interface_options : interface_options interface_option",
"interface_option : T_STRICTIFS",
"interface_option : T_SCANINTERVAL time",
"interface_type_options : T_BROADCAST host",
"interface_type_options : T_POINTOPOINT host",
"interface_type_options :",
"interface_common_options :",
"interface_common_options : interface_common_options interface_common_option",
"interface_common_option : T_NETMASK mask",
"interface_common_option : T_MULTICAST",
"interface_define_options : interface_define_option",
"interface_define_options : interface_define_options interface_define_option",
"interface_define_option : T_PREFERENCE preference",
"interface_define_option : T_DOWN T_PREFERENCE preference",
"interface_define_option : T_PASSIVE",
"interface_define_option : T_SIMPLEX",
"interface_define_option : T_REJECT",
"interface_define_option : T_BLACKHOLE",
"interface_define_option : T_AS as",
"interface_list_option :",
"interface_list_option : T_INTERFACE interface_list",
"interface_gateway_list : interface_list_option",
"interface_gateway_list : T_GATEWAY gateway_list",
"interface_all_list : T_ALL",
"interface_all_list : interface_list",
"interface_list : interface_all",
"interface_list : interface_list interface_all",
"interface_all : interface_all_adv",
"interface_all_adv : host_name",
"interface_all_adv : addr",
"interface_local : interface_addr",
"interface_addr : addr",
"interface_addr : host_name",
"proto_order :",
"proto_statement : redirect_statement L_EOS",
"proto_statement : kernel_statement L_EOS",
"proto_statement : hello_statement L_EOS",
"proto_statement : icmp_statement L_EOS",
"proto_statement : ospf_statement L_EOS",
"proto_statement : rip_statement L_EOS",
"proto_statement : snmp_statement L_EOS",
"$$5 :",
"kernel_statement : T_KERNEL $$5 '{' kernel_group '}'",
"kernel_group :",
"kernel_group : kernel_group kernel_stmt L_EOS",
"kernel_group : kernel_group error L_EOS",
"kernel_stmt : T_TRACEOPTIONS trace_file_option trace_control_option kernel_trace_options_none",
"kernel_stmt : T_OPTIONS kernel_options",
"kernel_stmt : T_REMNANTHOLDTIME time",
"kernel_stmt : T_FLASH kernel_flash_options",
"kernel_stmt : T_BACKGROUND kernel_bg_options",
"kernel_stmt : T_ROUTES number",
"kernel_options : kernel_option",
"kernel_options : kernel_options kernel_option",
"kernel_option : T_NOCHANGE",
"kernel_option : T_NOFLUSHATEXIT",
"kernel_flash_options : kernel_flash_option",
"kernel_flash_options : kernel_flash_options kernel_flash_option",
"kernel_flash_option : T_TYPE kernel_flash_type",
"kernel_flash_option : T_LIMIT neg_number",
"kernel_flash_type : T_INTERFACE",
"kernel_flash_type : T_INTERIOR",
"kernel_flash_type : T_ALL",
"kernel_bg_options : kernel_bg_option",
"kernel_bg_options : kernel_bg_options kernel_bg_option",
"kernel_bg_option : T_PRIORITY kernel_bg_type",
"kernel_bg_option : T_LIMIT number",
"kernel_bg_type : T_FLASH",
"kernel_bg_type : T_HIGHER",
"kernel_bg_type : T_LOWER",
"kernel_trace_options_none : T_NONE",
"kernel_trace_options_none : kernel_trace_options",
"kernel_trace_options_none : kernel_trace_options T_EXCEPT kernel_trace_options",
"kernel_trace_options : kernel_trace_option",
"kernel_trace_options : kernel_trace_options kernel_trace_option",
"kernel_trace_option : trace_option",
"kernel_trace_option : trace_option_detail trace_option_sendrecv kernel_trace_option_index",
"kernel_trace_option : T_SYMBOLS",
"kernel_trace_option : T_REMNANTS",
"kernel_trace_option : T_IFLIST",
"kernel_trace_option : T_REQUEST",
"kernel_trace_option : T_INFO",
"kernel_trace_option_index : T_PACKETS",
"kernel_trace_option_index : T_ROUTES",
"kernel_trace_option_index : T_REDIRECT",
"kernel_trace_option_index : T_INTERFACE",
"kernel_trace_option_index : T_OTHER",
"$$6 :",
"rip_statement : T_RIP $$6 onoff_option rip_group",
"rip_group :",
"rip_group : '{' rip_group_stmts '}'",
"rip_group_stmts :",
"rip_group_stmts : rip_group_stmts rip_group_stmt L_EOS",
"rip_group_stmts : rip_group_stmts error L_EOS",
"rip_group_stmt : T_PREFERENCE preference",
"rip_group_stmt : T_DEFAULTMETRIC metric",
"rip_group_stmt : T_BROADCAST",
"rip_group_stmt : T_NONBROADCAST",
"rip_group_stmt : T_TRACEOPTIONS trace_file_option trace_control_option rip_trace_options_none",
"rip_group_stmt : T_NOCHECKZERO",
"rip_group_stmt : T_INTERFACE interface_all_list rip_interface_options",
"rip_group_stmt : T_TRUSTEDGATEWAYS gateway_list_inet",
"rip_group_stmt : T_SOURCEGATEWAYS gateway_list_inet",
"rip_group_stmt : T_QUERY T_AUTH rip_auth",
"rip_interface_options : rip_interface_option",
"rip_interface_options : rip_interface_options rip_interface_option",
"rip_interface_option : T_RIPIN",
"rip_interface_option : T_NORIPIN",
"rip_interface_option : T_RIPOUT",
"rip_interface_option : T_NORIPOUT",
"rip_interface_option : T_METRICIN metric",
"rip_interface_option : T_METRICOUT metric",
"rip_interface_option : T_AUTH rip_auth",
"rip_interface_option : T_SECONDARY T_AUTH rip_auth",
"rip_interface_option : T_VERSION L_NUMBER rip_v2_options",
"rip_v2_options :",
"rip_v2_options : T_MULTICAST",
"rip_v2_options : T_BROADCAST",
"rip_auth : T_NONE",
"rip_auth : rip_auth_type string",
"rip_auth_type :",
"rip_auth_type : T_SIMPLE",
"rip_auth_type : T_MD5",
"rip_trace_options_none : T_NONE",
"rip_trace_options_none : rip_trace_options",
"rip_trace_options_none : rip_trace_options T_EXCEPT rip_trace_options",
"rip_trace_options : rip_trace_option",
"rip_trace_options : rip_trace_options rip_trace_option",
"rip_trace_option : trace_option",
"rip_trace_option : trace_option_detail trace_option_sendrecv rip_trace_option_index",
"rip_trace_option_index : T_PACKETS",
"rip_trace_option_index : T_REQUEST",
"rip_trace_option_index : T_RESPONSE",
"rip_trace_option_index : T_OTHER",
"rip_prop_init : T_RIP",
"$$7 :",
"hello_statement : T_HELLO $$7 onoff_option hello_group",
"hello_group :",
"hello_group : '{' hello_group_stmts '}'",
"hello_group_stmts :",
"hello_group_stmts : hello_group_stmts hello_group_stmt L_EOS",
"hello_group_stmts : hello_group_stmts error L_EOS",
"hello_group_stmt : T_PREFERENCE preference",
"hello_group_stmt : T_DEFAULTMETRIC metric",
"hello_group_stmt : T_BROADCAST",
"hello_group_stmt : T_NONBROADCAST",
"hello_group_stmt : T_TRACEOPTIONS trace_file_option trace_control_option hello_trace_options_none",
"hello_group_stmt : T_INTERFACE interface_all_list hello_interface_options",
"hello_group_stmt : T_TRUSTEDGATEWAYS gateway_list_inet",
"hello_group_stmt : T_SOURCEGATEWAYS gateway_list_inet",
"hello_interface_options : hello_interface_option",
"hello_interface_options : hello_interface_options hello_interface_option",
"hello_interface_option : T_HELLOIN",
"hello_interface_option : T_NOHELLOIN",
"hello_interface_option : T_HELLOOUT",
"hello_interface_option : T_NOHELLOOUT",
"hello_interface_option : T_METRICIN metric",
"hello_interface_option : T_METRICOUT metric",
"hello_trace_options_none : T_NONE",
"hello_trace_options_none : hello_trace_options",
"hello_trace_options_none : hello_trace_options T_EXCEPT hello_trace_options",
"hello_trace_options : hello_trace_option",
"hello_trace_options : hello_trace_options hello_trace_option",
"hello_trace_option : trace_option",
"hello_trace_option : trace_option_detail trace_option_sendrecv hello_trace_option_index",
"hello_trace_option_index : T_PACKETS",
"hello_prop_init : T_HELLO",
"$$8 :",
"ospf_statement : T_OSPF $$8 onoff_option ospf_group",
"ospf_group :",
"ospf_group : '{' ospf_group_stmts '}'",
"ospf_group_stmts :",
"ospf_group_stmts : ospf_group_stmts ospf_group_stmt L_EOS",
"ospf_group_stmts : ospf_group_stmts error L_EOS",
"ospf_group_stmt : T_DEFAULTS '{' ospf_defaults '}'",
"ospf_group_stmt : T_TRACEOPTIONS trace_file_option trace_control_option ospf_trace_options_none",
"ospf_group_stmt : T_EXPORTINTERVAL time",
"ospf_group_stmt : T_EXPORTLIMIT number",
"ospf_group_stmt : T_MONITORAUTH ospf_auth",
"$$9 :",
"ospf_group_stmt : T_MONITORAUTHKEY $$9 ospf_auth_key",
"ospf_group_stmt : T_SYSLOG ospf_syslog_first ospf_syslog_every",
"$$10 :",
"ospf_group_stmt : ospf_area_option $$10 '{' ospf_area_stmts '}'",
"ospf_syslog_first :",
"ospf_syslog_first : T_FIRST number",
"ospf_syslog_every :",
"ospf_syslog_every : T_EVERY number",
"ospf_defaults :",
"ospf_defaults : ospf_defaults ospf_default L_EOS",
"ospf_defaults : ospf_defaults error L_EOS",
"ospf_default : T_PREFERENCE preference",
"ospf_default : T_METRIC ospf_cost",
"ospf_default : T_TAG tag_as",
"ospf_default : T_TYPE ospf_type",
"ospf_area_stmts :",
"ospf_area_stmts : ospf_area_stmts ospf_area_stmt L_EOS",
"ospf_area_stmts : ospf_area_stmts error L_EOS",
"ospf_area_stmt : T_AUTHTYPE ospf_auth_type",
"ospf_area_stmt : T_STUB ospf_cost_option",
"ospf_area_stmt : T_STUBHOSTS '{' ospf_stub_list '}'",
"ospf_area_stmt : T_NETWORKS '{' ospf_area_range_list '}'",
"ospf_area_stmt : T_INTERFACE ospf_interface",
"ospf_area_stmt : T_VIRTUALLINK T_NEIGHBORID host T_TRANSITAREA ospf_area ospf_common",
"ospf_interface : interface_all_list ospf_cost_option ospf_common",
"ospf_interface : interface_all_list T_NONBROADCAST ospf_cost_option ospf_nonbroadcast",
"ospf_common :",
"ospf_common : '{' ospf_common_options '}'",
"ospf_common_options : ospf_common_option L_EOS",
"ospf_common_options : ospf_common_options ospf_common_option L_EOS",
"ospf_common_options : ospf_common_options error L_EOS",
"ospf_nonbroadcast :",
"ospf_nonbroadcast : '{' ospf_nonbroadcast_options '}'",
"ospf_nonbroadcast_options : ospf_nonbroadcast_option L_EOS",
"ospf_nonbroadcast_options : ospf_nonbroadcast_options ospf_nonbroadcast_option L_EOS",
"ospf_nonbroadcast_options : ospf_nonbroadcast_options error L_EOS",
"ospf_common_option : T_ENABLE",
"ospf_common_option : T_DISABLE",
"ospf_common_option : T_RXMITINTERVAL time",
"ospf_common_option : T_INFTRANSDELAY time",
"ospf_common_option : T_PRIORITY ospf_priority",
"ospf_common_option : T_HELLOINTERVAL time",
"ospf_common_option : T_ROUTERDEADINTERVAL time",
"ospf_common_option : T_NOMULTICAST",
"ospf_common_option : T_AUTH ospf_auth",
"ospf_common_option : T_SECONDARY T_AUTH ospf_auth",
"ospf_common_option : T_AUTHKEY ospf_auth_key",
"ospf_nonbroadcast_option : ospf_common_option",
"ospf_nonbroadcast_option : T_POLLINTERVAL time",
"ospf_nonbroadcast_option : T_ROUTERS '{' ospf_router_eligible_list '}'",
"ospf_cost_option :",
"ospf_cost_option : T_METRIC ospf_cost",
"ospf_cost : metric",
"ospf_type_option :",
"ospf_type_option : T_TYPE ospf_type",
"ospf_type : L_NUMBER",
"ospf_area_option : T_AREA ospf_area",
"ospf_area_option : T_BACKBONE",
"ospf_area : number",
"$$11 :",
"ospf_auth : ospf_auth_type $$11 ospf_auth_key",
"ospf_auth_type : T_NONE",
"ospf_auth_type : T_SIMPLE",
"ospf_auth_type : T_MD5",
"ospf_auth_key : string",
"ospf_auth_key : L_NUMBER",
"ospf_auth_key : byte_string",
"ospf_stub_list : ospf_stub L_EOS",
"ospf_stub_list : ospf_stub_list ospf_stub L_EOS",
"ospf_stub_list : ospf_stub_list error L_EOS",
"ospf_stub : host T_METRIC ospf_cost",
"ospf_router_eligible_list : ospf_router_eligible L_EOS",
"ospf_router_eligible_list : ospf_router_eligible_list ospf_router_eligible L_EOS",
"ospf_router_eligible_list : ospf_router_eligible_list error L_EOS",
"ospf_router_eligible : gateway_inet ospf_eligible_option",
"ospf_eligible_option :",
"ospf_eligible_option : T_ELIGIBLE",
"ospf_priority : L_NUMBER",
"ospf_prop_init : T_OSPF",
"ospf_ase_prop_init : T_OSPF_ASE",
"ospf_trace_options_none : T_NONE",
"ospf_trace_options_none : ospf_trace_options",
"ospf_trace_options_none : ospf_trace_options T_EXCEPT ospf_trace_options",
"ospf_trace_options : ospf_trace_option",
"ospf_trace_options : ospf_trace_options ospf_trace_option",
"ospf_trace_option : trace_option",
"ospf_trace_option : trace_option_detail trace_option_sendrecv ospf_trace_option_index",
"ospf_trace_option : T_LSA_BLD",
"ospf_trace_option : T_LSA_TX",
"ospf_trace_option : T_LSA_RX",
"ospf_trace_option : T_SPF",
"ospf_trace_option : T_TRAP",
"ospf_trace_option : T_DEBUG",
"ospf_trace_option_index : T_PACKETS",
"ospf_trace_option_index : T_HELLO",
"ospf_trace_option_index : T_DD",
"ospf_trace_option_index : T_REQUEST",
"ospf_trace_option_index : T_UPDATE",
"ospf_trace_option_index : T_ACK",
"ospf_area_range_list :",
"ospf_area_range_list : ospf_area_range_list ospf_area_range ospf_area_range_option L_EOS",
"ospf_area_range_list : ospf_area_range_list error L_EOS",
"ospf_area_range : host_mask_inet",
"ospf_area_range : network_mask_inet",
"ospf_area_range_option :",
"ospf_area_range_option : T_RESTRICT",
"$$12 :",
"icmp_statement : T_ICMP $$12 '{' icmp_group_stmts '}'",
"icmp_group_stmts :",
"icmp_group_stmts : icmp_group_stmts icmp_group_stmt L_EOS",
"icmp_group_stmts : icmp_group_stmts error L_EOS",
"icmp_group_stmt : T_TRACEOPTIONS trace_file_option trace_control_option icmp_trace_options_none",
"icmp_trace_options_none : T_NONE",
"icmp_trace_options_none : icmp_trace_options",
"icmp_trace_options_none : icmp_trace_options T_EXCEPT icmp_trace_options",
"icmp_trace_options : icmp_trace_option",
"icmp_trace_options : icmp_trace_options icmp_trace_option",
"icmp_trace_option : trace_option",
"icmp_trace_option : trace_option_detail trace_option_sendrecv icmp_trace_option_index",
"icmp_trace_option_index : T_PACKETS",
"icmp_trace_option_index : T_REDIRECT",
"icmp_trace_option_index : T_ROUTERDISCOVERY",
"icmp_trace_option_index : T_INFO",
"icmp_trace_option_index : T_ERROR",
"$$13 :",
"redirect_statement : T_REDIRECT $$13 onoff_option redirect_group",
"redirect_group :",
"redirect_group : '{' redirect_group_stmts '}'",
"redirect_group_stmts :",
"redirect_group_stmts : redirect_group_stmts redirect_group_stmt L_EOS",
"redirect_group_stmts : redirect_group_stmts error L_EOS",
"redirect_group_stmt : T_PREFERENCE preference",
"redirect_group_stmt : T_INTERFACE interface_all_list redirect_interface_options",
"redirect_group_stmt : T_TRUSTEDGATEWAYS gateway_list",
"redirect_group_stmt : T_TRACEOPTIONS trace_file_option trace_control_option redirect_trace_options_none",
"redirect_interface_options : redirect_interface_option",
"redirect_interface_options : redirect_interface_options redirect_interface_option",
"redirect_interface_option : T_REDIRECTS",
"redirect_interface_option : T_NOREDIRECTS",
"redirect_trace_options_none : T_NONE",
"redirect_trace_options_none : redirect_trace_options",
"redirect_trace_options_none : redirect_trace_options T_EXCEPT redirect_trace_options",
"redirect_trace_options : redirect_trace_option",
"redirect_trace_options : redirect_trace_options redirect_trace_option",
"redirect_trace_option : trace_option",
"snmp_statement : T_SNMP T_OFF",
"route_order :",
"$$14 :",
"route_statement : T_STATIC $$14 '{' route_stmts '}'",
"route_stmts : route_stmt L_EOS",
"route_stmts : route_stmts route_stmt L_EOS",
"route_stmts : error L_EOS",
"route_stmt : route_dest T_INTERFACE interface_all preference_option rts_options",
"route_stmt : route_dest T_GATEWAY gateway_list interface_list_option route_aspath preference_option rts_options",
"route_aspath :",
"route_aspath : T_AS as",
"route_dest : T_NOP_DM",
"route_dest : host_mask_inet",
"route_dest : network_mask_inet",
"route_dest : T_DEFAULT",
"rts_options :",
"rts_options : rts_options rts_option",
"rts_option : T_RETAIN",
"rts_option : T_REJECT",
"rts_option : T_BLACKHOLE",
"rts_option : T_NOINSTALL",
"control_order :",
"control_statement : T_NOP1",
"control_statement : T_IMPORT T_PROTO control_exterior T_AS as import_option_inet L_EOS",
"control_statement : T_IMPORT T_PROTO import_interior interface_gateway_list import_option_inet L_EOS",
"control_statement : T_IMPORT T_PROTO T_OSPF_ASE tag_option import_option_inet L_EOS",
"control_statement : T_EXPORT T_PROTO control_exterior T_AS as prop_source_option_inet L_EOS",
"control_statement : T_EXPORT T_PROTO export_interior interface_gateway_list prop_source_option_inet L_EOS",
"control_statement : T_EXPORT T_PROTO export_ospf_ase ospf_type_option tag_as_option prop_source_option_inet L_EOS",
"control_statement : T_AGGREGATE aggregate_dest_inet preference_option aggregate_options '{' aggregate_list_inet '}' L_EOS",
"control_statement : T_GENERATE aggregate_dest_inet preference_option '{' aggregate_list_inet '}' L_EOS",
"aggregate_options :",
"aggregate_options : T_BRIEF",
"aggregate_dest_inet : network_mask_inet",
"aggregate_dest_inet : default_mask_inet",
"aggregate_list_inet : aggregate_proto_inet",
"aggregate_list_inet : aggregate_list_inet aggregate_proto_inet",
"aggregate_list_inet : aggregate_list_inet error L_EOS",
"aggregate_proto_inet : T_PROTO aggregate_protos_inet import_option_inet L_EOS",
"aggregate_proto_inet : T_PROTO aggregate_protos_inet T_AS as import_option_inet L_EOS",
"aggregate_proto_inet : T_PROTO aggregate_protos_inet aspath_match import_option_inet L_EOS",
"aggregate_proto_inet : T_PROTO aggregate_protos_inet T_TAG tag import_option_inet L_EOS",
"aggregate_protos_inet : T_ALL",
"aggregate_protos_inet : T_DIRECT",
"aggregate_protos_inet : T_STATIC",
"aggregate_protos_inet : T_KERNEL",
"aggregate_protos_inet : T_AGGREGATE",
"aggregate_protos_inet : T_HELLO",
"aggregate_protos_inet : T_RIP",
"aggregate_protos_inet : T_OSPF",
"aggregate_protos_inet : T_OSPF_ASE",
"control_exterior : proto_exterior",
"import_listen_option :",
"import_listen_option : T_LISTEN",
"import_interior : proto_interior",
"import_option_inet : T_RESTRICT",
"import_option_inet : preference_option '{' import_list_inet '}'",
"import_list_inet :",
"import_list_inet : import_list_inet import_listen_inet L_EOS",
"import_list_inet : import_list_inet error L_EOS",
"$$15 :",
"import_listen_inet : import_listen_option $$15 dest_mask_inet preference_restrict_option",
"export_interior : proto_interior",
"export_ospf_ase : T_OSPF_ASE",
"prop_announce_option :",
"prop_announce_option : T_ANNOUNCE",
"prop_source_option_inet : T_RESTRICT",
"prop_source_option_inet : metric_option '{' prop_source_list_inet '}'",
"prop_source_list_inet :",
"prop_source_list_inet : prop_source_list_inet prop_source_inet L_EOS",
"prop_source_list_inet : prop_source_list_inet error L_EOS",
"prop_source_inet : T_PROTO prop_direct interface_list_option prop_metric_option_inet",
"prop_source_inet : T_PROTO prop_static interface_list_option prop_metric_option_inet",
"prop_source_inet : T_PROTO prop_aggregate prop_metric_option_inet",
"prop_source_inet : T_PROTO prop_kernel interface_list_option prop_metric_option_inet",
"prop_source_inet : T_PROTO prop_default prop_metric_option_inet",
"prop_source_inet : T_PROTO proto_exterior T_AS as prop_metric_option_inet",
"prop_source_inet : T_PROTO aspath_prop_init aspath_match prop_metric_option_inet",
"prop_source_inet : T_PROTO tag_prop_init T_TAG tag prop_metric_option_inet",
"prop_source_inet : T_PROTO rip_prop_init interface_gateway_list prop_metric_option_inet",
"prop_source_inet : T_PROTO hello_prop_init interface_gateway_list prop_metric_option_inet",
"prop_source_inet : T_PROTO ospf_prop_init prop_metric_option_inet",
"prop_source_inet : T_PROTO ospf_ase_prop_init prop_metric_option_inet",
"prop_direct : T_DIRECT",
"prop_static : T_STATIC",
"prop_aggregate : T_AGGREGATE",
"prop_kernel : T_KERNEL",
"prop_default : T_DEFAULT",
"prop_metric_option_inet : T_RESTRICT",
"prop_metric_option_inet : metric_option prop_restrict_list_option_inet",
"prop_restrict_list_option_inet :",
"prop_restrict_list_option_inet : '{' prop_restrict_list_inet '}'",
"prop_restrict_list_inet :",
"prop_restrict_list_inet : prop_restrict_list_inet prop_restrict_inet L_EOS",
"prop_restrict_list_inet : prop_restrict_list_inet error L_EOS",
"$$16 :",
"prop_restrict_inet : prop_announce_option $$16 dest_mask_inet metric_restrict_option",
"dest_mask_inet : all_mask_inet",
"dest_mask_inet : default_mask_inet",
"dest_mask_inet : host_mask_inet",
"dest_mask_inet : network_mask_flags_inet",
"all_mask_inet : T_ALL",
"default_mask_inet : T_DEFAULT",
"gateway_list_inet : gateway_inet",
"gateway_list_inet : gateway_list_inet gateway_inet",
"gateway_inet : host_inet",
"host_inet : host_name",
"host_inet : addr_inet",
"host_mask_inet : T_HOST host_inet",
"network_inet : host_name",
"network_inet : addr_inet",
"network_mask_inet : network_inet",
"network_mask_inet : network_inet T_MASKLEN number",
"network_mask_inet : network_inet T_MASK mask_inet",
"network_mask_flags_inet : network_mask_inet dm_flags",
"mask_inet : in_addr",
"addr_inet : in_addr",
"in_addr : L_NUMBER",
"in_addr : byte_string",
"inet_ttl : L_NUMBER",
"host : T_NOP_SOCKADDR",
"host : host_inet",
"mask : T_NOP_SOCKADDR",
"mask : mask_inet",
"addr : T_NOP_SOCKADDR",
"addr : addr_inet",
"gateway_list : T_NOP_ADV",
"gateway_list : gateway_list_inet",
"dm_flags :",
"dm_flags : T_EXACT",
"dm_flags : T_REFINE",
"host_name : L_HNAME",
"host_name : L_KEYWORD",
"host_name : string",
"proto_interior : T_REDIRECT",
"proto_interior : T_HELLO",
"proto_interior : T_RIP",
"proto_exterior : T_NOP_PROTO",
"onoff_option : T_ON",
"onoff_option : T_OFF",
"metric : number",
"metric : T_INFINITY",
"metric_option :",
"metric_option : T_METRIC metric",
"metric_restrict_option : metric_option",
"metric_restrict_option : T_RESTRICT",
"preference_option :",
"preference_option : T_PREFERENCE preference",
"preference_restrict_option : preference_option",
"preference_restrict_option : T_RESTRICT",
"preference : L_NUMBER",
"string : L_STRING",
"neg_number : L_NUMBER",
"neg_number : '-' L_NUMBER",
"number : L_NUMBER",
"number : byte_string",
"byte_string : L_HEXSTRING",
"byte_string : L_OCTETSTRING",
"time : L_NUMBER",
"time : L_NUMBER ':' L_NUMBER",
"time : L_NUMBER ':' L_NUMBER ':' L_NUMBER",
"as_loop_option :",
"as_loop_option : T_LOOPS L_NUMBER",
"as : L_NUMBER",
"tag_as_option :",
"tag_as_option : T_TAG tag_as",
"tag_as : tag",
"tag_as : T_AS",
"tag_as : T_AS number",
"tag_option :",
"tag_option : T_TAG tag",
"tag : number",
"tag_prop_init : proto_exterior",
"tag_prop_init : rip_prop_init",
"tag_prop_init : hello_prop_init",
"tag_prop_init : ospf_prop_init",
"tag_prop_init : ospf_ase_prop_init",
"aspath_prop_init : T_ALL",
"aspath_prop_init : proto_exterior",
"aspath_prop_init : rip_prop_init",
"aspath_prop_init : hello_prop_init",
"aspath_prop_init : ospf_prop_init",
"aspath_prop_init : ospf_ase_prop_init",
"$$17 :",
"aspath_match : T_ASPATH $$17 aspath_regex T_ORIGIN aspath_origin",
"aspath_origin :",
"aspath_origin : T_ANY",
"aspath_origin : aspath_origin_list",
"aspath_origin_list : aspath_origins",
"aspath_origin_list : aspath_origin_list '|' aspath_origins",
"aspath_origins : T_IGP",
"aspath_origins : T_EGP",
"aspath_origins : T_INCOMPLETE",
"aspath_regex : aspath_sum",
"aspath_regex : aspath_regex '|' aspath_sum",
"aspath_sum : aspath_term",
"aspath_sum : aspath_sum aspath_term",
"aspath_term : aspath_symbol",
"aspath_term : aspath_symbol '*'",
"aspath_term : aspath_symbol '+'",
"aspath_term : aspath_symbol '?'",
"aspath_term : aspath_symbol '{' aspath_range '}'",
"aspath_symbol : as",
"aspath_symbol : '.'",
"aspath_symbol : '(' aspath_regex ')'",
"aspath_range : number",
"aspath_range : number ','",
"aspath_range : number ',' number",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifndef YYSTACKSIZE
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 300
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
#define yystacksize YYSTACKSIZE
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#line 4951 "parser.y"

/*
 *	Log any parsing errors
 */
static void
yyerror(s)
const char *s;
{
    byte *cp;

    tracef("parse: %s ",
	   parse_where());

    switch (yychar) {
    case L_HEXSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%02x",
		   *cp);
	}
	tracef("'");
	break;	

    case L_OCTETSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%s%u",
		   (cp == yylval.hex.ptr) ? "" : ".",
		   *cp);
	}
	tracef("'");
	break;	

    case L_NUMBER:
	tracef("%s at '%d'",
	       s,
	       yylval.num);
	break;

    case L_EOS:
	tracef("%s at 'end-of-statement'",
	       s);
	break;

    case L_ERROR:
	tracef("%s",
	       parse_error);
	break;

#ifdef	YYEOF
    case YYEOF:
#else	/* YYEOF */
    case 0:
#endif	/* YYEOF */
	tracef("%s at 'end-of-file'",
	       s);
	break;

    default:
	if (!parse_keyword_lookup(yychar)) {
#if	YYDEBUG != 0
#ifdef	YYTRANSLATE
	    tracef("%s at '%s'",
		   s,
		   yytname[YYTRANSLATE(yychar)]);
#else	/* YYTRANSLATE */
	    tracef("%s at '%s'",
		   s,
		   yyname[yychar]);
#endif	/* YYTRANSLATE */
#else	/* YYDEBUG */
	    tracef("%s",
		   s);
#endif	/* YYDEBUG */
	    break;
	}
	tracef("%s at '%s' (%u) length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.type,
	       yylval.str.len);
	break;

    case L_STRING:
    case L_HNAME:
    case L_KEYWORD:
	tracef("%s at '%s' length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.len);
	break;

#ifdef	YYEMPTY
    case YYEMPTY:
	tracef("%s",
	       s);
	break;
#endif	/* YYEMPTY */
    }
    trace_log_tf(trace_global,
		 TRC_NL_BEFORE|TRC_NL_AFTER,
		 LOG_ERR,
		 (NULL));
}



/*
 * ------------------------------------------------------------------------
 * 
 * 	GateD, Release 3.5
 * 
 * 	Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.
 * 	    All rights reserved.
 * 
 * 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * 	AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * 	Royalty-free licenses to redistribute GateD Release
 * 	3 in whole or in part may be obtained by writing to:
 * 
 * 	    GateDaemon Project
 * 	    Information Technologies/Network Resources
 * 	    200 CCC
 * 	    Cornell University
 * 	    Ithaca, NY  14853-2601  USA
 * 
 * 	GateD is based on Kirton's EGP, UC Berkeley's routing
 * 	daemon	 (routed), and DCN's HELLO routing Protocol.
 * 	Development of GateD has been supported in part by the
 * 	National Science Foundation.
 * 
 * 	Please forward bug fixes, enhancements and questions to the
 * 	gated mailing list: gated-people@gated.cornell.edu.
 * 
 * ------------------------------------------------------------------------
 * 
 *       Portions of this software may fall under the following
 *       copyrights:
 * 
 * 	Copyright (c) 1988 Regents of the University of California.
 * 	All rights reserved.
 * 
 * 	Redistribution and use in source and binary forms are
 * 	permitted provided that the above copyright notice and
 * 	this paragraph are duplicated in all such forms and that
 * 	any documentation, advertising materials, and other
 * 	materials related to such distribution and use
 * 	acknowledge that the software was developed by the
 * 	University of California, Berkeley.  The name of the
 * 	University may not be used to endorse or promote
 * 	products derived from this software without specific
 * 	prior written permission.  THIS SOFTWARE IS PROVIDED
 * 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#line 2066 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 13:
#line 352 "parser.y"
{
				yyerrok;
			}
break;
case 15:
#line 361 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num  == T_OFF) {
				yydebug = 0;
			    } else {
				yydebug = 1;
			    }
#endif	/* YYDEBUG */
			}
break;
case 16:
#line 371 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num  < 0 || yyvsp[-1].num  > PS_MAX) {
				(void) sprintf(parse_error, "invalid yystate value: %d",
					       yyvsp[-1].num );
				PARSE_ERROR;
			    }
			    parse_state = yyvsp[-1].num ;
#endif	/* YYDEBUG */
			}
break;
case 17:
#line 382 "parser.y"
{
#if	YYDEBUG != 0
			    task_quit(0);
#endif	/* YYDEBUG */
			}
break;
case 18:
#line 392 "parser.y"
{
			    if (yyvsp[-3].trace_file  && !BIT_TEST(task_state, TASKS_TEST)) {

				trace_store(trace_global, yyvsp[-1].flag , yyvsp[-2].flag , yyvsp[-3].trace_file , (bits *) 0);

				if (yyvsp[-1].flag ) {
				    /* Turn on or change tracing */

				    trace_on(yyvsp[-3].trace_file );
				} else {
				    /* Turn off tracing */

				    trace_off(yyvsp[-3].trace_file );
				}
				trace_display(trace_global, TR_ALL);
			    }
			}
break;
case 19:
#line 413 "parser.y"
{
			    yyval.trace_file  = trace_file_locate((char *) 0,
						   (off_t) 0,
						   (u_int) 0,
						   (flag_t) 0);
			}
break;
case 20:
#line 420 "parser.y"
{
			    yyval.trace_file  = trace_file_locate(yyvsp[-1].str .ptr,
						   (off_t) 0,
						   (u_int) 0,
						   yyvsp[0].flag );
			}
break;
case 21:
#line 427 "parser.y"
{
			    if (parse_limit_check("file-size",
						  (u_int) yyvsp[-2].num ,
						  TRACE_LIMIT_FILE_SIZE)) {
				PARSE_ERROR;
			    }

			    if (parse_limit_check("files",
						  (u_int) yyvsp[0].num ,
						  TRACE_LIMIT_FILE_COUNT)) {
				PARSE_ERROR;
			    }

			    yyval.trace_file  = trace_file_locate(yyvsp[-5].str .ptr,
						   yyvsp[-2].num ,
						   (u_int) yyvsp[0].num ,
						   yyvsp[-4].flag );
			}
break;
case 23:
#line 449 "parser.y"
{
			    yyval.num  = yyvsp[-1].num  * 1024;
			}
break;
case 24:
#line 453 "parser.y"
{
			    yyval.num  = yyvsp[-1].num  * 1024 * 1024;
			}
break;
case 25:
#line 459 "parser.y"
{
			    yyval.flag  = 0;
			}
break;
case 26:
#line 463 "parser.y"
{
			    yyval.flag  = TRF_REPLACE;
			}
break;
case 27:
#line 470 "parser.y"
{
			    yyval.flag  = 0;
			}
break;
case 28:
#line 474 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 29:
#line 481 "parser.y"
{
			    yyval.flag  = TRC_NOSTAMP;
			}
break;
case 30:
#line 488 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 31:
#line 492 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 32:
#line 496 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~ yyvsp[-1].num ;
			}
break;
case 33:
#line 503 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 34:
#line 507 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 35:
#line 511 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 36:
#line 515 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 37:
#line 523 "parser.y"
{
			    yyval.flag  = TR_PARSE;
			}
break;
case 38:
#line 527 "parser.y"
{
#ifdef	TR_ADV
			    yyval.flag  = TR_ADV;
#else	/* TR_ADV */
			    yyval.flag  = 0;
#endif	/* TR_ADV */
			}
break;
case 39:
#line 538 "parser.y"
{
			    yyval.flag  = TR_ROUTE;
			}
break;
case 40:
#line 542 "parser.y"
{
			    yyval.flag  = TR_NORMAL;
			}
break;
case 41:
#line 546 "parser.y"
{
			    yyval.flag  = TR_GENERAL;
			}
break;
case 42:
#line 550 "parser.y"
{
			    yyval.flag  = TR_STATE;
			}
break;
case 43:
#line 554 "parser.y"
{
			    yyval.flag  = TR_POLICY;
			}
break;
case 44:
#line 558 "parser.y"
{
			    yyval.flag  = TR_TASK;
			}
break;
case 45:
#line 562 "parser.y"
{
			    yyval.flag  = TR_TIMER;
			}
break;
case 46:
#line 566 "parser.y"
{
			    yyval.flag  = TR_ALL;
			}
break;
case 47:
#line 573 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 48:
#line 577 "parser.y"
{
			    yyval.flag  = TR_PARSE_DETAIL;
			}
break;
case 49:
#line 584 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 50:
#line 588 "parser.y"
{
			    yyval.flag  = TR_PARSE_SEND;
			}
break;
case 51:
#line 592 "parser.y"
{
			    yyval.flag  = TR_PARSE_RECV;
			}
break;
case 52:
#line 601 "parser.y"
{
				if (parse_new_state(PS_DEFINE)) {
					PARSE_ERROR;
				}
			}
break;
case 54:
#line 611 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 55:
#line 615 "parser.y"
{
			    parse_contig_masks = TRUE;

			    SI_MARTIANS(AF_INET) = yyvsp[-2].adv ;
			}
break;
case 56:
#line 621 "parser.y"
{
			    if (inet_autonomous_system) {
				(void) sprintf(parse_error, "autonomous-system already specified");
				PARSE_ERROR;
			    }
			    inet_autonomous_system = yyvsp[-2].as ;
#ifdef	PROTO_ASPATHS
			    aslocal_set(inet_autonomous_system, yyvsp[-1].u_num );
#endif	/* PROTO_ASPATHS */
			}
break;
case 57:
#line 632 "parser.y"
{
			    if (inet_parse_routerid(yyvsp[-1].sockaddr , parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 58:
#line 641 "parser.y"
{
			    yyval.adv  = SI_MARTIANS(AF_INET);
			}
break;
case 59:
#line 645 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_DM | yyvsp[-1].flag , (proto_t) 0);

			    adv->adv_dm = yyvsp[-2].dm ;
			    yyval.adv  = adv_destmask_insert(parse_error, yyvsp[-3].adv , adv);
			    if (!yyval.adv ) {
				PARSE_ERROR;
			    }
			}
break;
case 60:
#line 655 "parser.y"
{
			    yyerrok;
			}
break;
case 64:
#line 666 "parser.y"
{
			    yyval.flag  = ADVF_NO;
			}
break;
case 65:
#line 670 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 66:
#line 678 "parser.y"
{
				if (parse_new_state(PS_OPTIONS)) {
					PARSE_ERROR;
				}
			}
break;
case 70:
#line 695 "parser.y"
{
			    task_newstate(TASKS_NOSEND, 0);
			}
break;
case 71:
#line 699 "parser.y"
{
			    task_newstate(TASKS_NORESOLV, 0);
			}
break;
case 72:
#line 703 "parser.y"
{
#ifdef	LOG_DAEMON
			    (void) setlogmask(yyvsp[0].num );
#else	/* LOG_DAEMON */
			    (void) sprintf(parse_error, "system does not support setlogmask()");
			    PARSE_ERROR;
#endif	/* LOG_DAEMON */
			}
break;
case 73:
#line 712 "parser.y"
{
			    task_mark_interval = yyvsp[0].time ;
			}
break;
case 74:
#line 716 "parser.y"
{
			    rt_default_needed = TRUE;
			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric )) {
				rt_default_rtparms.rtp_preference = yyvsp[-1].metric .metric;
			    }
			    rt_default_rtparms.rtp_router = yyvsp[0].sockaddr ;
			}
break;
case 75:
#line 728 "parser.y"
{
			    yyval.sockaddr  = (sockaddr_un *) 0;
			}
break;
case 76:
#line 732 "parser.y"
{
			    parse_gwlist = &parse_gwp;
			}
break;
case 77:
#line 736 "parser.y"
{
			    yyval.sockaddr  = sockdup(yyvsp[0].gwp ->gw_addr);
			    gw_freelist(*parse_gwlist);
			    *parse_gwlist = parse_gwp = (gw_entry *) 0;
			}
break;
case 78:
#line 744 "parser.y"
{
			    yyval.time  = TIME_MARK;
			}
break;
case 79:
#line 748 "parser.y"
{
			    yyval.time  = yyvsp[0].time ;
			}
break;
case 80:
#line 754 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num  = LOG_MASK(yyvsp[0].num );
#endif	/* LOG_DAEMON */
			}
break;
case 81:
#line 760 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num  = LOG_UPTO(yyvsp[0].num );
#endif	/* LOG_DAEMON */
			}
break;
case 82:
#line 766 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num  = yyvsp[-1].num  | LOG_MASK(yyvsp[0].num );
#endif	/* LOG_DAEMON */
			}
break;
case 83:
#line 774 "parser.y"
{
			    yyval.num  = LOG_EMERG;
			}
break;
case 84:
#line 778 "parser.y"
{
			    yyval.num  = LOG_ALERT;
			}
break;
case 85:
#line 782 "parser.y"
{
			    yyval.num  = LOG_CRIT;
			}
break;
case 86:
#line 786 "parser.y"
{
			    yyval.num  = LOG_ERR;
			}
break;
case 87:
#line 790 "parser.y"
{
			    yyval.num  = LOG_WARNING;
			}
break;
case 88:
#line 794 "parser.y"
{
			    yyval.num  = LOG_NOTICE;
			}
break;
case 89:
#line 798 "parser.y"
{
			    yyval.num  = LOG_INFO;
			}
break;
case 90:
#line 802 "parser.y"
{
			    yyval.num  = LOG_DEBUG;
			}
break;
case 91:
#line 810 "parser.y"
{
			    if (parse_new_state(PS_INTERFACE)) {
				PARSE_ERROR;
			    }
			}
break;
case 92:
#line 819 "parser.y"
{
			    PROTO_SEEN(RTPROTO_DIRECT);
			}
break;
case 93:
#line 823 "parser.y"
{
			    parse_proto = (proto_t) 0;
			}
break;
case 96:
#line 832 "parser.y"
{
			    yyerrok;
			}
break;
case 98:
#line 840 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config , 0);

			    parse_adv_propagate_config(yyvsp[-1].adv , list, (proto_t) 0);

			    if (parse_adv_append(&int_policy, yyvsp[-1].adv )) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 99:
#line 852 "parser.y"
{
			    bzero((caddr_t) &parse_ifi, sizeof (parse_ifi));

			    parse_ifi.ifi_addr = yyvsp[0].sockaddr ;
			}
break;
case 100:
#line 858 "parser.y"
{
			    if (if_parse_add(&parse_ifi, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 103:
#line 872 "parser.y"
{
			    task_newstate(TASKS_STRICTIFS, 0);
			}
break;
case 104:
#line 876 "parser.y"
{
			    if (parse_limit_check("scan-interval",
						  (u_int) yyvsp[0].time ,
						  KRT_LIMIT_SCANTIMER)) {
				PARSE_ERROR;
			    }
			    
			    task_timer_set(krt_timer_ifcheck,
					   yyvsp[0].time ,
					   (time_t) 0);
			}
break;
case 105:
#line 891 "parser.y"
{
			    parse_ifi.ifi_addr_broadcast = yyvsp[0].sockaddr ;
			    BIT_SET(parse_ifi.ifi_state, IFS_BROADCAST);
			}
break;
case 106:
#line 896 "parser.y"
{
			    parse_ifi.ifi_addr_local = yyvsp[0].sockaddr ;
			    BIT_SET(parse_ifi.ifi_state, IFS_POINTOPOINT);
			}
break;
case 107:
#line 901 "parser.y"
{
			}
break;
case 110:
#line 912 "parser.y"
{
			    parse_ifi.ifi_netmask = yyvsp[0].sockaddr ;
			}
break;
case 111:
#line 916 "parser.y"
{
			    BIT_SET(parse_ifi.ifi_state, IFS_MULTICAST);
			}
break;
case 113:
#line 924 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-1].config , yyvsp[0].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 114:
#line 934 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_PREFERENCE_UP, GS2A(yyvsp[0].pref ));
			}
break;
case 115:
#line 938 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_PREFERENCE_DOWN, GS2A(yyvsp[0].pref ));
			}
break;
case 116:
#line 942 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_PASSIVE, GS2A(TRUE));
			}
break;
case 117:
#line 946 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_SIMPLEX, GS2A(TRUE));
			}
break;
case 118:
#line 950 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_REJECT, GS2A(TRUE));
			}
break;
case 119:
#line 954 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_BLACKHOLE, GS2A(TRUE));
			}
break;
case 120:
#line 958 "parser.y"
{
			    yyval.config  = config_alloc(IF_CONFIG_AS, GS2A(yyvsp[0].as ));
			}
break;
case 121:
#line 965 "parser.y"
{
			    yyval.adv  = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 122:
#line 969 "parser.y"
{
			    yyval.adv  = yyvsp[0].adv ;
			}
break;
case 123:
#line 976 "parser.y"
{
			    yyval.adv  = yyvsp[0].adv ;
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 124:
#line 982 "parser.y"
{
			    yyval.adv  = yyvsp[0].adv ;
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 125:
#line 991 "parser.y"
{
			    yyval.adv  = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 127:
#line 999 "parser.y"
{
			    BIT_SET(yyvsp[0].adv ->adv_flag, ADVF_FIRST);
			    yyval.adv  = yyvsp[0].adv ;
			}
break;
case 128:
#line 1004 "parser.y"
{
			    yyval.adv  = yyvsp[-1].adv ;
			    if (parse_adv_append(&yyval.adv , yyvsp[0].adv )) {
				PARSE_ERROR;
			    }
			}
break;
case 129:
#line 1013 "parser.y"
{
			    switch (yyvsp[0].adv ->adv_flag & ADVF_TYPE) {

			    case ADVFT_IFN:
				trace_tf(trace_global,
					 TR_PARSE,
					 0,
					 ("parse: %s INTERFACE: %A*",
					  parse_where(),
					  yyval.adv ->adv_ifn->ifae_addr));
				break;
				
			    case ADVFT_IFAE:
				trace_tf(trace_global,
					 TR_PARSE,
					 0,
					 ("parse: %s INTERFACE: %A",
					  parse_where(),
					  yyval.adv ->adv_ifae->ifae_addr));
			    }
			}
break;
case 130:
#line 1038 "parser.y"
{
			    int valid_ifname = 0;

			    switch (yyvsp[0].str .type) {
			    case L_KEYWORD:
			    case L_STRING:
				if (yyvsp[0].str .len < IFL_NAMELEN) {
				    valid_ifname++;
				}
				break;

			    default:
				break;
			    }

			    if (valid_ifname) {
				/* First try to look up as an interface name */

				yyval.adv  = if_parse_name(yyvsp[0].str .ptr, FALSE);
			    } else {
				/* Doesn't meet the criteria to be a name */

				yyval.adv  = (adv_entry *) 0;
			    }
			    
			    if (!yyval.adv  && !BIT_TEST(task_state, TASKS_NORESOLV)) {
				/* Try to resolve as a host name */

				sockaddr_un *addr = parse_addr_hostname(yyvsp[0].str .ptr, parse_error);

				if (addr) {
				    yyval.adv  = if_parse_address(addr);
				}

			    }

			    if (!yyval.adv ) {
				if (valid_ifname && !BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    /* Assume it is a reference to an interface that does not exist */

				    yyval.adv  = if_parse_name(yyvsp[0].str .ptr, TRUE);
				} else {
				    /* Time to give up */
				    
				    (void) sprintf(parse_error, "Interface not found at '%s'",
						   yyvsp[0].str .ptr);
				    PARSE_ERROR;
				}
			    }
				
			    free_charstr(yyvsp[0].str );
			}
break;
case 131:
#line 1091 "parser.y"
{
			    yyval.adv  = if_parse_address(yyvsp[0].sockaddr );
			    if (!yyval.adv ) {
				(void) sprintf(parse_error, "Interface not found at '%A'",
					       yyvsp[0].sockaddr );
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[0].sockaddr );
			}
break;
case 132:
#line 1104 "parser.y"
{
			    if_addr *ifap;
			    
			    ifap = if_withlcladdr(yyvsp[0].sockaddr , FALSE);
			    if (ifap) {
				yyval.ifae  = ifae_alloc(ifap->ifa_addrent_local);
			    } else {
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    (void) sprintf(parse_error, "Invalid interface at '%A'",
						   yyvsp[0].sockaddr );
				    PARSE_ERROR;
				} else {
				    yyval.ifae  = ifae_locate(yyvsp[0].sockaddr , &if_local_list);
				}
			    }
			    sockfree(yyvsp[0].sockaddr );
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s LOCAL ADDRESS: %A",
				      parse_where(),
				      yyval.ifae ->ifae_addr));
			}
break;
case 134:
#line 1131 "parser.y"
{
			    sockaddr_un *addr;

			    addr = parse_addr_hostname(yyvsp[0].str .ptr, parse_error);
			    if (!addr) {
				/* Name resolution failure */

				PARSE_ERROR;
			    }
			    yyval.sockaddr  = sockdup(addr);
			    free_charstr(yyvsp[0].str );
			}
break;
case 135:
#line 1151 "parser.y"
{
			    if (parse_new_state(PS_PROTO)) {
				PARSE_ERROR;
			    }
			}
break;
case 143:
#line 1171 "parser.y"
{
			    kernel_trace_options = trace_set_global(kernel_trace_types,
								    TR_KRT_SYMBOLS|TR_KRT_IFLIST);
			}
break;
case 148:
#line 1184 "parser.y"
{
			    trace_store(kernel_trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , kernel_trace_types);
			}
break;
case 149:
#line 1187 "parser.y"
{}
break;
case 150:
#line 1189 "parser.y"
{
			    if (parse_limit_check("remnantholdtime",
						  (u_int) yyvsp[0].time ,
						  KRT_LIMIT_EXPIRE)) {
				PARSE_ERROR;
			    }
			    krt_t_expire = yyvsp[0].time ;
			}
break;
case 151:
#line 1197 "parser.y"
{}
break;
case 152:
#line 1198 "parser.y"
{}
break;
case 153:
#line 1200 "parser.y"
{
			    if (parse_limit_check("routes",
						  (u_int) yyvsp[0].num ,
						  KRT_LIMIT_ROUTES)) {
				PARSE_ERROR;
			    }
			    krt_limit_routes = yyvsp[0].num ;
			}
break;
case 156:
#line 1215 "parser.y"
{
			    BIT_SET(krt_options, KRT_OPT_NOCHANGE);
			}
break;
case 157:
#line 1219 "parser.y"
{
			    BIT_SET(krt_options, KRT_OPT_NOFLUSH);
			}
break;
case 160:
#line 1231 "parser.y"
{
			    krt_flash_routes = yyvsp[0].flag ;
			}
break;
case 161:
#line 1235 "parser.y"
{
			    if (parse_limit_check("flash limit",
						  (u_int) yyvsp[0].num ,
						  KRT_LIMIT_FLASH)) {
				PARSE_ERROR;
			    }
			    krt_flash_install_count = yyvsp[0].num ;
			}
break;
case 162:
#line 1247 "parser.y"
{
			    yyval.flag  = KRT_FLASH_INTERFACE;
			}
break;
case 163:
#line 1251 "parser.y"
{
			    yyval.flag  = KRT_FLASH_INTERNAL;
			}
break;
case 164:
#line 1255 "parser.y"
{
			    yyval.flag  = KRT_FLASH_ALL;
			}
break;
case 167:
#line 1267 "parser.y"
{
			    krt_install_priority = yyvsp[0].flag ;
			}
break;
case 168:
#line 1271 "parser.y"
{
			    if (parse_limit_check("install limit",
						  (u_int) yyvsp[0].num ,
						  KRT_LIMIT_INSTALL)) {
				PARSE_ERROR;
			    }
			    krt_install_count = yyvsp[0].num ;
			}
break;
case 169:
#line 1283 "parser.y"
{
			    yyval.flag  = KRT_INSTALL_PRIO_FLASH;
			}
break;
case 170:
#line 1287 "parser.y"
{
			    yyval.flag  = KRT_INSTALL_PRIO_HIGH;
			}
break;
case 171:
#line 1291 "parser.y"
{
			    yyval.flag  = KRT_INSTALL_PRIO_LOW;
			}
break;
case 172:
#line 1298 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 173:
#line 1302 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 174:
#line 1306 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 175:
#line 1313 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 176:
#line 1317 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 178:
#line 1325 "parser.y"
{
			    yyval.flag  = trace_parse_packet(yyvsp[-2].flag , yyvsp[-1].flag , yyvsp[0].u_num );
			}
break;
case 179:
#line 1329 "parser.y"
{
			    yyval.flag  = TR_KRT_SYMBOLS;
			}
break;
case 180:
#line 1333 "parser.y"
{
			    yyval.flag  = TR_KRT_REMNANTS;
			}
break;
case 181:
#line 1337 "parser.y"
{
			    yyval.flag  = TR_KRT_IFLIST;
			}
break;
case 182:
#line 1341 "parser.y"
{
			    yyval.flag  = TR_KRT_REQUEST;
			}
break;
case 183:
#line 1345 "parser.y"
{
			    yyval.flag  = TR_KRT_INFO;
			}
break;
case 184:
#line 1352 "parser.y"
{
			    yyval.u_num  = TR_KRT_INDEX_PACKETS;
			}
break;
case 185:
#line 1356 "parser.y"
{
			    yyval.u_num  = TR_KRT_INDEX_ROUTES;
			}
break;
case 186:
#line 1360 "parser.y"
{
			    yyval.u_num  = TR_KRT_INDEX_REDIRECT;
			}
break;
case 187:
#line 1364 "parser.y"
{
			    yyval.u_num  = TR_KRT_INDEX_INTERFACE;
			}
break;
case 188:
#line 1368 "parser.y"
{
			    yyval.u_num  = TR_KRT_INDEX_OTHER;
			}
break;
case 189:
#line 1377 "parser.y"
{
			    PROTO_SEEN(RTPROTO_RIP);

			    parse_gwlist = &rip_gw_list;

			    rip_trace_options = trace_set_global(rip_trace_types,
								 (flag_t) 0);
			}
break;
case 190:
#line 1386 "parser.y"
{
			    switch (yyvsp[-1].num ) {
			    case T_OFF:
				BIT_RESET(rip_flags, RIPF_ON);
				break;

			    case T_ON:
				BIT_SET(rip_flags, RIPF_ON);
				break;
			    }

			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 195:
#line 1409 "parser.y"
{
			    yyerrok;
			}
break;
case 196:
#line 1415 "parser.y"
{
			    rip_preference = yyvsp[0].pref ;
			}
break;
case 197:
#line 1419 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    rip_default_metric = yyvsp[0].metric .metric;
			}
break;
case 198:
#line 1426 "parser.y"
{
			    BIT_RESET(rip_flags, RIPF_CHOOSE);
			    BIT_SET(rip_flags, RIPF_BROADCAST);
			}
break;
case 199:
#line 1431 "parser.y"
{
			    BIT_RESET(rip_flags, RIPF_CHOOSE|RIPF_BROADCAST);
			}
break;
case 200:
#line 1435 "parser.y"
{
			    trace_store(rip_trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , rip_trace_types);
			}
break;
case 201:
#line 1439 "parser.y"
{
			    BIT_SET(rip_flags, RIPF_NOCHECK);
			}
break;
case 202:
#line 1443 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config , rip_config_free);

			    parse_adv_propagate_config(yyvsp[-1].adv , list, RTPROTO_RIP);

			    if (parse_adv_append(&rip_int_policy, yyvsp[-1].adv )) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 203:
#line 1455 "parser.y"
{
			    rip_n_trusted += parse_gw_flag(yyvsp[0].adv , RTPROTO_RIP, GWF_TRUSTED);
			    if (!rip_n_trusted) {
				PARSE_ERROR;
			    }
			}
break;
case 204:
#line 1462 "parser.y"
{
			    rip_n_source += parse_gw_flag(yyvsp[0].adv , RTPROTO_RIP, GWF_SOURCE);
			    if (!rip_n_source) {
				PARSE_ERROR;
			    }
			    BIT_SET(rip_flags, RIPF_SOURCE);
			}
break;
case 205:
#line 1470 "parser.y"
{
			    rip_auth_query = (struct rip_authinfo *) yyvsp[0].vt ;
			}
break;
case 207:
#line 1478 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-1].config , yyvsp[0].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 208:
#line 1488 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_IN, GS2A(TRUE));
			}
break;
case 209:
#line 1492 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_IN, GS2A(FALSE));
			}
break;
case 210:
#line 1496 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_OUT, GS2A(TRUE));
			}
break;
case 211:
#line 1500 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_OUT, GS2A(FALSE));
			}
break;
case 212:
#line 1504 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(RIP_CONFIG_METRICIN, GS2A(yyvsp[0].metric .metric));
			}
break;
case 213:
#line 1511 "parser.y"
{
			    if (parse_metric_check(RTPROTO_RIP, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(RIP_CONFIG_METRICOUT, GS2A(yyvsp[0].metric .metric));
			}
break;
case 214:
#line 1518 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_AUTH, yyvsp[0].vt );
			}
break;
case 215:
#line 1522 "parser.y"
{
			    yyval.config  = config_alloc(RIP_CONFIG_AUTH2, yyvsp[0].vt );
			}
break;
case 216:
#line 1526 "parser.y"
{
			    flag_t flag;
			    
			    switch (yyvsp[-1].num ) {
			    case 1:
				if (yyvsp[0].flag ) {
				    (void) sprintf(parse_error, "options not valid with version 1");
				    PARSE_ERROR;
				}
				flag = RIP_IFPS_V1;
				break;

			    case 2:
				if (yyvsp[0].flag ) {
				    flag = yyvsp[0].flag ;
				} else {
				    /* This means whatever options the interface is capable of */
#ifdef	IP_MULTICAST
				    flag = RIP_IFPS_V2;
#else	/* IP_MULTICAST */
				    flag = RIP_IFPS_V2BC;
#endif	/* IP_MULTICAST */
				}
				break;

			    default:
				(void) sprintf(parse_error, "invalid version");
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(RIP_CONFIG_FLAG, GS2A(flag));
			}
break;
case 217:
#line 1560 "parser.y"
{
			    yyval.flag  = 0;
			}
break;
case 218:
#line 1564 "parser.y"
{
			    yyval.flag  = RIP_IFPS_V2MC;
			}
break;
case 219:
#line 1568 "parser.y"
{
			    yyval.flag  = RIP_IFPS_V2BC;
			}
break;
case 220:
#line 1574 "parser.y"
{
			    yyval.vt  = (void_t) &rip_auth_none;
			}
break;
case 221:
#line 1578 "parser.y"
{
			    struct rip_authinfo *ap = (struct rip_authinfo *) task_block_alloc(rip_auth_block_index);

			    if (yyvsp[0].str .len > RIP_AUTH_SIZE) {
				sprintf(parse_error, "authentication-key \"%s\"%d longer than %d characters",
					yyvsp[0].str .ptr,
					yyvsp[0].str .len,
					RIP_AUTH_SIZE);
				PARSE_ERROR;
			    }

			    ap->auth_family = RIP_AF_AUTH;
			    ap->auth_type = htons((u_int16) yyvsp[-1].u_num );
			    /* Left justify the authentication key */
			    (void) strncpy((caddr_t) ap->auth_data, yyvsp[0].str .ptr, RIP_AUTH_SIZE);

			    free_charstr(yyvsp[0].str );

			    yyval.vt  = (void_t) ap;
			}
break;
case 222:
#line 1601 "parser.y"
{
			    yyval.u_num  = RIP_AUTH_SIMPLE;
			}
break;
case 223:
#line 1605 "parser.y"
{
			    yyval.u_num  = RIP_AUTH_SIMPLE;
			}
break;
case 224:
#line 1609 "parser.y"
{
			    yyval.u_num  = RIP_AUTH_MD5;
			}
break;
case 225:
#line 1616 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 226:
#line 1620 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 227:
#line 1624 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 228:
#line 1631 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 229:
#line 1635 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 231:
#line 1643 "parser.y"
{
			    yyval.flag  = trace_parse_packet(yyvsp[-2].flag , yyvsp[-1].flag , yyvsp[0].u_num );
			}
break;
case 232:
#line 1650 "parser.y"
{
			    yyval.u_num  = TR_RIP_INDEX_PACKETS;
			}
break;
case 233:
#line 1654 "parser.y"
{
			    yyval.u_num  = TR_RIP_INDEX_REQUEST;
			}
break;
case 234:
#line 1658 "parser.y"
{
			    yyval.u_num  = TR_RIP_INDEX_RESPONSE;
			}
break;
case 235:
#line 1662 "parser.y"
{
			    yyval.u_num  = TR_RIP_INDEX_OTHER;
			}
break;
case 236:
#line 1668 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_RIP;
			    parse_gwlist = &rip_gw_list;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 237:
#line 1685 "parser.y"
{
			    PROTO_SEEN(RTPROTO_HELLO);

			    parse_gwlist = &hello_gw_list;

			    hello_trace_options = trace_set_global(hello_trace_types,
								   (flag_t) 0);
			}
break;
case 238:
#line 1694 "parser.y"
{
			    switch (yyvsp[-1].num ) {
			    case T_OFF:
				BIT_RESET(hello_flags, HELLOF_ON);
				break;

			    case T_ON:
				BIT_SET(hello_flags, HELLOF_ON);
				break;
			    }
			    
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 243:
#line 1718 "parser.y"
{
			    yyerrok;
			}
break;
case 244:
#line 1725 "parser.y"
{
			    hello_preference = yyvsp[0].pref ;
			}
break;
case 245:
#line 1729 "parser.y"
{
			    if (parse_metric_check(RTPROTO_HELLO, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    hello_default_metric = yyvsp[0].metric .metric;
			}
break;
case 246:
#line 1736 "parser.y"
{
			    hello_flags = (hello_flags & ~HELLOF_CHOOSE) | HELLOF_BROADCAST;
			}
break;
case 247:
#line 1740 "parser.y"
{
			    hello_flags = hello_flags & ~(HELLOF_CHOOSE|HELLOF_BROADCAST);
			}
break;
case 248:
#line 1744 "parser.y"
{
			    trace_store(hello_trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , hello_trace_types);
			}
break;
case 249:
#line 1748 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config , 0);

			    parse_adv_propagate_config(yyvsp[-1].adv , list, RTPROTO_HELLO);

			    if (parse_adv_append(&hello_int_policy, yyvsp[-1].adv )) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 250:
#line 1760 "parser.y"
{
			    hello_n_trusted += parse_gw_flag(yyvsp[0].adv , RTPROTO_HELLO, GWF_TRUSTED);
			    if (!hello_n_trusted) {
				PARSE_ERROR;
			    }
			}
break;
case 251:
#line 1767 "parser.y"
{
			    hello_n_source += parse_gw_flag(yyvsp[0].adv , RTPROTO_HELLO, GWF_SOURCE);
			    if (!hello_n_source) {
				PARSE_ERROR;
			    }
			    BIT_SET(hello_flags, HELLOF_SOURCE);
			}
break;
case 253:
#line 1779 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-1].config , yyvsp[0].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 254:
#line 1789 "parser.y"
{
			    yyval.config  = config_alloc(HELLO_CONFIG_IN, GS2A(TRUE));
			}
break;
case 255:
#line 1793 "parser.y"
{
			    yyval.config  = config_alloc(HELLO_CONFIG_IN, GS2A(FALSE));
			}
break;
case 256:
#line 1797 "parser.y"
{
			    yyval.config  = config_alloc(HELLO_CONFIG_OUT, GS2A(TRUE));
			}
break;
case 257:
#line 1801 "parser.y"
{
			    yyval.config  = config_alloc(HELLO_CONFIG_OUT, GS2A(FALSE));
			}
break;
case 258:
#line 1805 "parser.y"
{
			    if (parse_metric_check(RTPROTO_HELLO, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(HELLO_CONFIG_METRICIN, GS2A(yyvsp[0].metric .metric));
			}
break;
case 259:
#line 1812 "parser.y"
{
			    if (parse_metric_check(RTPROTO_HELLO, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(HELLO_CONFIG_METRICOUT, GS2A(yyvsp[0].metric .metric));
			}
break;
case 260:
#line 1822 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 261:
#line 1826 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 262:
#line 1830 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 263:
#line 1837 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 264:
#line 1841 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 266:
#line 1849 "parser.y"
{
			    yyval.flag  = trace_parse_packet(yyvsp[-2].flag , yyvsp[-1].flag , yyvsp[0].u_num );
			}
break;
case 267:
#line 1856 "parser.y"
{
			    yyval.u_num  = TR_HELLO_INDEX_PACKETS;
			}
break;
case 268:
#line 1863 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_HELLO;
			    parse_gwlist = &hello_gw_list;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 269:
#line 1880 "parser.y"
{
			    PROTO_SEEN(RTPROTO_OSPF);

			    parse_gwlist = &ospf.gw_list;

			    ospf.trace_options = trace_set_global(ospf_trace_types,
								  (flag_t) 0);

			    /* Somewhere around here is where we will figure out which OSPF global structure we are */
			    /* refering to and initialize it once we support multiple instantations of OSPF that is. */
			}
break;
case 270:
#line 1892 "parser.y"
{
			    if (yyvsp[-1].num  == T_OFF) {
                                ospf.ospf_admin_stat = OSPF_DISABLED;
                            } else {
                                if (ospf_parse_valid_check(parse_error)) {
                                    PARSE_ERROR;
                                }
                                ospf.ospf_admin_stat = OSPF_ENABLED;
                            }

                            parse_proto = (proto_t) 0;
                            parse_gwlist = (gw_entry **) 0;
                        }
break;
case 275:
#line 1914 "parser.y"
{
                                yyerrok;
                        }
break;
case 276:
#line 1920 "parser.y"
{
                        }
break;
case 277:
#line 1923 "parser.y"
{
                            trace_store(ospf.trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , ospf_trace_types);
                        }
break;
case 278:
#line 1927 "parser.y"
{
                            ospf.export_interval = yyvsp[0].time ;
                        }
break;
case 279:
#line 1931 "parser.y"
{
                            ospf.export_limit = yyvsp[0].num ;
                        }
break;
case 280:
#line 1935 "parser.y"
{
			    ospf.mon_auth.auth_type = yyvsp[0].hex .type;
			    ospf.mon_auth.auth_length = yyvsp[0].hex .len;
			    bcopy(yyvsp[0].hex .ptr, (caddr_t) ospf.mon_auth.auth_key, yyvsp[0].hex .len);
			}
break;
case 281:
#line 1941 "parser.y"
{
			    ospf_auth_length = OSPF_AUTH_SIMPLE_SIZE;
			}
break;
case 282:
#line 1945 "parser.y"
{
			    ospf.mon_auth.auth_type = OSPF_AUTH_SIMPLE;
			    ospf.mon_auth.auth_length = OSPF_AUTH_SIMPLE_SIZE;
			    bcopy(yyvsp[0].hex .ptr, (caddr_t) ospf.mon_auth.auth_key, yyvsp[0].hex .len);
			}
break;
case 283:
#line 1951 "parser.y"
{
			    ospf.log_first = yyvsp[-1].u_num ;
			    ospf.log_every = yyvsp[0].u_num ;
			}
break;
case 284:
#line 1956 "parser.y"
{
			    ospf_AREA = ospf_parse_area_alloc(yyvsp[0].u_num , parse_error);
			    if (!ospf_AREA) {
				PARSE_ERROR;
			    }
			    ospf_AREA->authtype = OSPF_AUTH_NONE;		/* Default to no authentication */
			}
break;
case 285:
#line 1964 "parser.y"
{
			    if (ospf_parse_area_check(ospf_AREA, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 286:
#line 1973 "parser.y"
{
			    yyval.u_num  = OSPF_LOG_FIRST;
			}
break;
case 287:
#line 1977 "parser.y"
{
			    if (parse_limit_check("syslog first",
						  (u_int) yyvsp[0].num ,
						  OSPF_LIMIT_LOG_FIRST)) {
				PARSE_ERROR;
			    }
			    yyval.u_num  = yyvsp[0].num ;
			}
break;
case 288:
#line 1989 "parser.y"
{
			    yyval.u_num  = OSPF_LOG_EVERY;
			}
break;
case 289:
#line 1993 "parser.y"
{
			    if (parse_limit_check("syslog every",
						  (u_int) yyvsp[0].num ,
						  OSPF_LIMIT_LOG_EVERY)) {
				PARSE_ERROR;
			    }
			    yyval.u_num  = yyvsp[0].num ;
			}
break;
case 292:
#line 2006 "parser.y"
{
			    yyerrok;
			}
break;
case 293:
#line 2012 "parser.y"
{
			    ospf.preference_ase = yyvsp[0].pref ;
			}
break;
case 294:
#line 2016 "parser.y"
{
			    ospf.export_metric = yyvsp[0].metric .metric;
			}
break;
case 295:
#line 2020 "parser.y"
{
			    switch (yyvsp[0].metric .state) {
			    case PARSE_METRICS_SET:
				ospf.export_tag = yyvsp[0].metric .metric;
				break;

			    case PARSE_METRICS_ALTERNATE:
				ospf.export_tag = PATH_OSPF_TAG_TRUSTED |
				    ((yyvsp[0].metric .metric << PATH_OSPF_TAG_USR_SHIFT) & PATH_OSPF_TAG_USR_MASK);
				break;
			    }
			}
break;
case 296:
#line 2033 "parser.y"
{
			    ospf.export_type = yyvsp[0].metric .metric;
			}
break;
case 299:
#line 2041 "parser.y"
{
			    yyerrok;
			}
break;
case 300:
#line 2047 "parser.y"
{
			    ospf_AREA->authtype = yyvsp[0].hex .type;
			    ospf_auth_length = yyvsp[0].hex .len;
			}
break;
case 301:
#line 2052 "parser.y"
{
			    if (ospf_AREA->area_id == OSPF_BACKBONE) {
				(void) sprintf(parse_error, "stub option not valid for backbone");
				PARSE_ERROR;
			    }

			    /* This is a stub */
			    BIT_SET(ospf_AREA->area_flags, OSPF_AREAF_STUB);

			    /* And we inject a default */
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric )) {
				BIT_SET(ospf_AREA->area_flags, OSPF_AREAF_STUB_DEFAULT);
				ospf_AREA->dflt_metric = yyvsp[0].metric .metric;
			    }
			}
break;
case 302:
#line 2067 "parser.y"
{}
break;
case 303:
#line 2069 "parser.y"
{
			    register dest_mask_internal *dmi;

			    if (ospf_AREA->nrcnt) {
				(void) sprintf(parse_error,
					"net range already specified");
				PARSE_ERROR;
			    }

			    if (yyvsp[-1].adv ) {

			    	/* Install each of the entries */
			    	DMI_WALK_ALL(yyvsp[-1].adv ->adv_dm.dm_internal, dmi, adv) {
					ospf_parse_add_net(ospf_AREA,
					   	adv->adv_dm.dm_dest,
					   	adv->adv_dm.dm_mask,
					   	adv->adv_result.res_flag);
			    	} DMI_WALK_ALL_END(yyvsp[-1].adv ->adv_dm.dm_internal,
					dmi, adv) ;

			    	adv_free_list(yyvsp[-1].adv );
			    }
			}
break;
case 304:
#line 2093 "parser.y"
{
			    if (parse_adv_append(&ospf_AREA->intf_policy, yyvsp[0].adv )) {
				PARSE_ERROR;
			    }
			}
break;
case 305:
#line 2099 "parser.y"
{
			    struct INTF *vif;

			    vif = ospf_parse_virt_parse(ospf_AREA, yyvsp[-3].sockaddr , yyvsp[-1].u_num , yyvsp[0].conflist , parse_error);
			    if (!vif) {
				PARSE_ERROR;
			    }

			    config_list_free(yyvsp[0].conflist );
			}
break;
case 306:
#line 2113 "parser.y"
{
			    config_list *list = yyvsp[0].conflist ;

			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric )) {

				list = config_list_add(list,
						       config_alloc(OSPF_CONFIG_COST,
								    GS2A(yyvsp[-1].metric .metric)),
						       ospf_config_free);
				if (!list) {
				    PARSE_ERROR;
				}
			    }

			    parse_adv_propagate_config(yyvsp[-2].adv , list, RTPROTO_OSPF);

			    config_list_free(list);

			    yyval.adv  = yyvsp[-2].adv ;
			}
break;
case 307:
#line 2134 "parser.y"
{
			    config_list *list = yyvsp[0].conflist ;

			    list = config_list_add(list,
						   config_alloc(OSPF_CONFIG_TYPE,
								GS2A(NONBROADCAST)),
						   ospf_config_free);
			    if (!list) {
				PARSE_ERROR;
			    }
			    
			    if (PARSE_METRIC_ISSET(&yyvsp[-1].metric )) {

				list = config_list_add(list,
						       config_alloc(OSPF_CONFIG_COST,
								    GS2A(yyvsp[-1].metric .metric)),
						       ospf_config_free);
				if (!list) {
				    PARSE_ERROR;
				}
			    }

			    parse_adv_propagate_config(yyvsp[-3].adv , list, RTPROTO_OSPF);

			    config_list_free(list);

			    yyval.adv  = yyvsp[-3].adv ;
			}
break;
case 308:
#line 2165 "parser.y"
{
			    yyval.conflist  = (config_list *) 0;
			}
break;
case 309:
#line 2169 "parser.y"
{
			    yyval.conflist  = config_list_alloc(yyvsp[-1].config , ospf_config_free);
			}
break;
case 311:
#line 2177 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-2].config , yyvsp[-1].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 312:
#line 2184 "parser.y"
{
				yyerrok;
			}
break;
case 313:
#line 2191 "parser.y"
{
			    yyval.conflist  = (config_list *) 0;
			}
break;
case 314:
#line 2195 "parser.y"
{
			    yyval.conflist  = config_list_alloc(yyvsp[-1].config , ospf_config_free);
			}
break;
case 316:
#line 2203 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-2].config , yyvsp[-1].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 317:
#line 2210 "parser.y"
{
				yyerrok;
			}
break;
case 318:
#line 2217 "parser.y"
{
			    yyval.config  = config_alloc(OSPF_CONFIG_ENABLE, GS2A(TRUE));
			}
break;
case 319:
#line 2221 "parser.y"
{
			    yyval.config  = config_alloc(OSPF_CONFIG_ENABLE, GS2A(FALSE));
			}
break;
case 320:
#line 2225 "parser.y"
{
			    if (parse_limit_check("retransmit-interval",
						  (u_int) yyvsp[0].time ,
						  OSPF_LIMIT_RETRANSMITINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(OSPF_CONFIG_RETRANSMIT, GS2A(yyvsp[0].time ));
			}
break;
case 321:
#line 2234 "parser.y"
{
			    if (parse_limit_check("transit-delay",
						  (u_int) yyvsp[0].time ,
						  OSPF_LIMIT_TRANSITDELAY)) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(OSPF_CONFIG_TRANSIT, GS2A(yyvsp[0].time ));
			}
break;
case 322:
#line 2243 "parser.y"
{
			    yyval.config  = config_alloc(OSPF_CONFIG_PRIORITY, GS2A(yyvsp[0].num ));
			}
break;
case 323:
#line 2247 "parser.y"
{
			    if (parse_limit_check("hello-interval",
						  (u_int) yyvsp[0].time ,
						  OSPF_LIMIT_HELLOINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(OSPF_CONFIG_HELLO, GS2A(yyvsp[0].time ));
			}
break;
case 324:
#line 2256 "parser.y"
{
			    if (parse_limit_check("router-dead-interval",
						  (u_int) yyvsp[0].time ,
						  OSPF_LIMIT_ROUTERDEADINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(OSPF_CONFIG_ROUTERDEAD, GS2A(yyvsp[0].time ));
			}
break;
case 325:
#line 2265 "parser.y"
{
			    yyval.config  = config_alloc(OSPF_CONFIG_NOMULTI, GS2A(TRUE));
			}
break;
case 326:
#line 2269 "parser.y"
{
			    ospf_auth *oap = (ospf_auth *) task_block_alloc(ospf_auth_index);

			    oap->auth_type = yyvsp[0].hex .type;
			    oap->auth_length = yyvsp[0].hex .len;
			    bcopy(yyvsp[0].hex .ptr, (caddr_t) oap->auth_key, yyvsp[0].hex .len);
			    free_bytestr(yyvsp[0].hex );

			    yyval.config  = config_alloc(OSPF_CONFIG_AUTH, GS2A(oap));
			}
break;
case 327:
#line 2280 "parser.y"
{
			    ospf_auth *oap = (ospf_auth *) task_block_alloc(ospf_auth_index);

			    oap->auth_type = yyvsp[0].hex .type;
			    oap->auth_length = yyvsp[0].hex .len;
			    bcopy(yyvsp[0].hex .ptr, (caddr_t) oap->auth_key, yyvsp[0].hex .len);
			    free_bytestr(yyvsp[0].hex );

			    yyval.config  = config_alloc(OSPF_CONFIG_AUTH2, GS2A(oap));
			}
break;
case 328:
#line 2291 "parser.y"
{
			    /* Side-effect: The authentication type must be specified first */

			    ospf_auth *oap = (ospf_auth *) task_block_alloc(ospf_auth_index);
			    
			    switch (ospf_AREA->authtype) {
			    case OSPF_AUTH_NONE:
				sprintf(parse_error, "authentication-key specified when authentication-type is none");
				PARSE_ERROR;
				/* break; */

			    case OSPF_AUTH_SIMPLE:
				/* Simple password */
				break;

			    case OSPF_AUTH_MD5:
				/* MD5 crypto checksum */
				break;
				
			    default:
				sprintf(parse_error, "unknown authentication type: %d",
					ospf_AREA->authtype);
				PARSE_ERROR;
			    }

			    oap->auth_type = ospf_AREA->authtype;
			    oap->auth_length = yyvsp[0].hex .len;
			    bcopy(yyvsp[0].hex .ptr, (caddr_t) oap->auth_key, yyvsp[0].hex .len);

			    yyval.config  = config_alloc(OSPF_CONFIG_AUTH, GS2A(oap));

			    free_bytestr(yyvsp[0].hex );
			}
break;
case 330:
#line 2329 "parser.y"
{
			    if (parse_limit_check("poll-interval",
						  (u_int) yyvsp[0].time ,
						  OSPF_LIMIT_POLLINTERVAL)) {
				PARSE_ERROR;
			    }
			    yyval.config  = config_alloc(OSPF_CONFIG_POLL, GS2A(yyvsp[0].time ));
			}
break;
case 331:
#line 2338 "parser.y"
{
			    yyval.config  = config_alloc(OSPF_CONFIG_ROUTERS, GS2A(yyvsp[-1].ospf_router ));
			}
break;
case 332:
#line 2345 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 333:
#line 2349 "parser.y"
{
				yyval.metric  = yyvsp[0].metric ;
			}
break;
case 334:
#line 2355 "parser.y"
{
			    yyval.metric  = yyvsp[0].metric ;
			    if (parse_metric_check(RTPROTO_OSPF, &yyval.metric )) {
				PARSE_ERROR;
			    }
			}
break;
case 335:
#line 2365 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 336:
#line 2369 "parser.y"
{
			    yyval.metric  = yyvsp[0].metric ;
			}
break;
case 337:
#line 2375 "parser.y"
{
			    if (parse_limit_check("export-type",
						  (u_int) yyvsp[0].num ,
						  OSPF_LIMIT_EXPORTTYPE)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric , yyvsp[0].num );
			}
break;
case 338:
#line 2387 "parser.y"
{
			    yyval.u_num  = yyvsp[0].u_num ;
			}
break;
case 339:
#line 2391 "parser.y"
{
			    yyval.u_num  = OSPF_BACKBONE;
			}
break;
case 340:
#line 2397 "parser.y"
{
			    if (parse_limit_check("area-number",
						  (u_int) yyvsp[0].num ,
						  OSPF_LIMIT_AREA)) {
				PARSE_ERROR;
			    }
			    yyval.u_num  = htonl((u_int32) yyvsp[0].num );
			}
break;
case 341:
#line 2408 "parser.y"
{
			    ospf_auth_length = yyvsp[0].hex .len;
			}
break;
case 342:
#line 2412 "parser.y"
{
			    /* Copy the key */
			    yyval.hex  = yyvsp[0].hex ;	/* struct copy */
			    /* And get type type */
			    yyval.hex .type = yyvsp[-2].hex .type;
			}
break;
case 343:
#line 2421 "parser.y"
{
			    yyval.hex .type = OSPF_AUTH_NONE;
			    yyval.hex .len = 0;
			    
			}
break;
case 344:
#line 2427 "parser.y"
{
			    yyval.hex .type = OSPF_AUTH_SIMPLE;
			    yyval.hex .len = OSPF_AUTH_SIMPLE_SIZE;
			}
break;
case 345:
#line 2432 "parser.y"
{
			    yyval.hex .type = OSPF_AUTH_MD5;
			    yyval.hex .len = OSPF_AUTH_MD5_SIZE;
			}
break;
case 346:
#line 2439 "parser.y"
{
			    if (yyvsp[0].str .len > ospf_auth_length) {
				sprintf(parse_error, "authentication-key \"%s\"%d longer than %d characters",
					yyvsp[0].str .ptr,
					yyvsp[0].str .len,
					ospf_auth_length);
				PARSE_ERROR;
			    }

			    yyval.hex .ptr = (byte *) task_mem_calloc((task *) 0, sizeof (u_int32), OSPF_AUTH_SIZE);
			    yyval.hex .len = ospf_auth_length;
			    yyval.hex .type = 0;

			    /* Left justify */
			    strncpy((caddr_t) yyval.hex .ptr, yyvsp[0].str .ptr, yyval.hex .len);

			    free_charstr(yyvsp[0].str );
			}
break;
case 347:
#line 2458 "parser.y"
{
			    yyval.hex .ptr = (byte *) task_mem_calloc((task *) 0, sizeof (u_int32), OSPF_AUTH_SIZE);
			    yyval.hex .len = ospf_auth_length;
			    yyval.hex .type = 0;

			    /* Right justify the key */
			    bcopy((caddr_t) &yyvsp[0].num ,
				  yyval.hex .ptr + ospf_auth_length - sizeof (yyvsp[0].num ),
				  sizeof (yyvsp[0].num ));
			}
break;
case 348:
#line 2469 "parser.y"
{
			    if (yyvsp[0].hex .len > ospf_auth_length) {
				sprintf(parse_error, "authentication-key longer than %d characters",
					ospf_auth_length);
				PARSE_ERROR;
			    }

			    yyval.hex .ptr = (byte *) task_mem_calloc((task *) 0, sizeof (u_int32), OSPF_AUTH_SIZE);
			    yyval.hex .len = ospf_auth_length;
			    yyval.hex .type = 0;

			    /* Right justify the key */
			    bcopy((caddr_t) yyvsp[0].hex .ptr,
				  yyval.hex .ptr + ospf_auth_length - yyvsp[0].hex .len,
				  yyvsp[0].hex .len);

			    free_bytestr(yyvsp[0].hex );
			}
break;
case 351:
#line 2494 "parser.y"
{
			    yyerrok;
			}
break;
case 352:
#line 2500 "parser.y"
{
			    ospf_parse_add_host(ospf_AREA, sock2ip(yyvsp[-2].sockaddr ), yyvsp[0].metric .metric);

			    sockfree(yyvsp[-2].sockaddr );
			}
break;
case 354:
#line 2510 "parser.y"
{
			    (yyval.ospf_router  = yyvsp[-1].ospf_router )->ocr_next = yyvsp[-2].ospf_router ;
			}
break;
case 355:
#line 2514 "parser.y"
{
			    yyerrok;
			}
break;
case 356:
#line 2521 "parser.y"
{
			    yyval.ospf_router  = ospf_parse_router_alloc(sock2in(yyvsp[-1].gwp ->gw_addr), (u_int) yyvsp[0].num );
			}
break;
case 357:
#line 2528 "parser.y"
{
			    yyval.num  = 0;
			}
break;
case 358:
#line 2532 "parser.y"
{
			    yyval.num  = 1;
			}
break;
case 359:
#line 2538 "parser.y"
{
			    if (parse_limit_check("priority",
						  (u_int) yyvsp[0].num ,
						  OSPF_LIMIT_DRPRIORITY)) {
				PARSE_ERROR;
			    }
			    yyval.num  = yyvsp[0].num ;
			}
break;
case 360:
#line 2549 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_OSPF;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 361:
#line 2563 "parser.y"
{
			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    yyval.proto  = parse_proto = RTPROTO_OSPF_ASE;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 362:
#line 2580 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 363:
#line 2584 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 364:
#line 2588 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 365:
#line 2595 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 366:
#line 2599 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 368:
#line 2607 "parser.y"
{
			    yyval.flag  = trace_parse_packet(yyvsp[-2].flag , yyvsp[-1].flag , yyvsp[0].u_num );
			}
break;
case 369:
#line 2611 "parser.y"
{
			    yyval.flag  = TR_OSPF_LSA_BLD;
			}
break;
case 370:
#line 2615 "parser.y"
{
			    yyval.flag  = TR_OSPF_LSA_TX;
			}
break;
case 371:
#line 2619 "parser.y"
{
			    yyval.flag  = TR_OSPF_LSA_RX;
			}
break;
case 372:
#line 2623 "parser.y"
{
			    yyval.flag  = TR_OSPF_SPF;
			}
break;
case 373:
#line 2627 "parser.y"
{
			    yyval.flag  = TR_OSPF_TRAP;
			}
break;
case 374:
#line 2631 "parser.y"
{
#ifdef	DEBUG
			    yyval.flag  = TR_OSPF_DEBUG;
#else	/* DEBUG */
			    yyval.flag  = 0;
#endif	/* DEBUG */
			}
break;
case 375:
#line 2642 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_PACKETS;
			}
break;
case 376:
#line 2646 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_HELLO;
			}
break;
case 377:
#line 2650 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_DD;
			}
break;
case 378:
#line 2654 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_LSR;
			}
break;
case 379:
#line 2658 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_LSU;
			}
break;
case 380:
#line 2662 "parser.y"
{
			    yyval.u_num  = TR_OSPF_INDEX_ACK;
			}
break;
case 381:
#line 2670 "parser.y"
{
			    yyval.adv  = (adv_entry *) 0;
			}
break;
case 382:
#line 2674 "parser.y"
{
			    if (sock2ip(yyvsp[-2].dm .dm_dest) == INADDR_ANY) {
				sprintf(parse_error, "invalid range %A/%A",
					yyvsp[-2].dm .dm_dest,
					yyvsp[-2].dm .dm_mask);
				PARSE_ERROR;
			    }
			    yyval.adv  = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv ->adv_dm = yyvsp[-2].dm ;
			    yyval.adv ->adv_result.res_flag = yyvsp[-1].flag ;
			    yyval.adv  = adv_destmask_insert(parse_error, yyvsp[-3].adv , yyval.adv );
			    if (!yyval.adv ) {
				PARSE_ERROR;
			    }
			}
break;
case 383:
#line 2690 "parser.y"
{
			    yyerrok;
			}
break;
case 386:
#line 2702 "parser.y"
{
			    yyval.flag  = Advertise;
			}
break;
case 387:
#line 2706 "parser.y"
{
			    yyval.flag  = DoNotAdvertise;
			}
break;
case 388:
#line 2734 "parser.y"
{
			    icmp_trace_options = trace_set_global(icmp_trace_types,
								  (flag_t) 0);
			}
break;
case 392:
#line 2745 "parser.y"
{
			    yyerrok;
			}
break;
case 393:
#line 2753 "parser.y"
{
			    trace_store(icmp_trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , icmp_trace_types);
			}
break;
case 394:
#line 2760 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 395:
#line 2764 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 396:
#line 2768 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 397:
#line 2775 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 398:
#line 2779 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 400:
#line 2787 "parser.y"
{
			    yyval.flag  = trace_parse_packet(yyvsp[-2].flag , yyvsp[-1].flag , yyvsp[0].u_num );
			}
break;
case 401:
#line 2794 "parser.y"
{
			    yyval.u_num  = TR_ICMP_INDEX_PACKETS;
			}
break;
case 402:
#line 2798 "parser.y"
{
			    yyval.u_num  = TR_ICMP_INDEX_REDIRECT;
			}
break;
case 403:
#line 2802 "parser.y"
{
			    yyval.u_num  = TR_ICMP_INDEX_ROUTER;
			}
break;
case 404:
#line 2806 "parser.y"
{
			    yyval.u_num  = TR_ICMP_INDEX_INFO;
			}
break;
case 405:
#line 2810 "parser.y"
{
			    yyval.u_num  = TR_ICMP_INDEX_ERROR;
			}
break;
case 406:
#line 2821 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    PROTO_SEEN(RTPROTO_REDIRECT);

			    parse_gwlist = &redirect_gw_list;

			    redirect_trace_options = trace_set_global(redirect_trace_types,
								      (flag_t) 0);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 407:
#line 2832 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    switch (yyvsp[-1].num ) {
			    case T_ON:
				/* Enabled by default */
				break;

			    case T_OFF:
				redirect_disable(RTPROTO_REDIRECT);
				break;
			    }

			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 412:
#line 2858 "parser.y"
{
			    yyerrok;
			}
break;
case 413:
#line 2864 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_preference = yyvsp[0].pref ;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 414:
#line 2870 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    config_list *list = config_list_alloc(yyvsp[0].config , 0);

			    parse_adv_propagate_config(yyvsp[-1].adv , list, RTPROTO_REDIRECT);

			    if (parse_adv_append(&redirect_int_policy, yyvsp[-1].adv )) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 415:
#line 2884 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_n_trusted += parse_gw_flag(yyvsp[0].adv , RTPROTO_REDIRECT, GWF_TRUSTED);
			    if (!redirect_n_trusted) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 416:
#line 2893 "parser.y"
{
			    trace_store(redirect_trace_options, yyvsp[0].flag , yyvsp[-1].flag , yyvsp[-2].trace_file , redirect_trace_types);
			}
break;
case 418:
#line 2901 "parser.y"
{
			    yyval.config  = config_append(yyvsp[-1].config , yyvsp[0].config );
			    if (!yyval.config ) {
				PARSE_ERROR;
			    }
			}
break;
case 419:
#line 2911 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.config  = config_alloc(REDIRECT_CONFIG_IN, GS2A(TRUE));
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 420:
#line 2917 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.config  = config_alloc(REDIRECT_CONFIG_IN, GS2A(FALSE));
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 421:
#line 2926 "parser.y"
{
			    yyval.flag  = (flag_t) 0;
			}
break;
case 422:
#line 2930 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 423:
#line 2934 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  & ~yyvsp[0].flag ;
			}
break;
case 424:
#line 2941 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 425:
#line 2945 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 427:
#line 2966 "parser.y"
{
			}
break;
case 428:
#line 2973 "parser.y"
{
			    if (parse_new_state(PS_ROUTE)) {
				PARSE_ERROR;
			    }
			}
break;
case 429:
#line 2981 "parser.y"
{
			    /* Need to set this for static routes, not used for interface routes */
			    parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    rt_open(rt_task);
			}
break;
case 430:
#line 2988 "parser.y"
{
			    rt_close(rt_task, (gw_entry *) 0, 0, NULL);
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 433:
#line 2998 "parser.y"
{
				yyerrok;
			}
break;
case 434:
#line 3004 "parser.y"
{
			    /* Route to an interface */

			    if (rt_parse_route(yyvsp[-4].dm .dm_dest,
					       yyvsp[-4].dm .dm_mask,
					       (adv_entry *) 0,
					       yyvsp[-2].adv ,
					       PARSE_METRIC_ISSET(&yyvsp[-1].metric ) ? (pref_t) yyvsp[-1].metric .metric : RTPREF_STATIC,
					       yyvsp[0].flag ,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-4].dm .dm_dest);
			}
break;
case 435:
#line 3020 "parser.y"
{
			    /* Route to a gateway */

			    if (rt_parse_route_aspath(yyvsp[-6].dm .dm_dest,
						      yyvsp[-6].dm .dm_mask,
						      yyvsp[-4].adv ,
						      yyvsp[-3].adv ,
						      PARSE_METRIC_ISSET(&yyvsp[-1].metric ) ? (pref_t) yyvsp[-1].metric .metric : RTPREF_STATIC,
						      yyvsp[0].flag  | RTS_GATEWAY,
						      yyvsp[-2].aspath ,
						      parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-6].dm .dm_dest);
			}
break;
case 436:
#line 3039 "parser.y"
{
			    yyval.aspath  = (as_path *) 0;
			}
break;
case 437:
#line 3043 "parser.y"
{
			    yyval.aspath  = aspath_create(yyvsp[0].as );
			}
break;
case 438:
#line 3049 "parser.y"
{
			    assert(FALSE);
			}
break;
case 441:
#line 3055 "parser.y"
{
			    yyval.dm .dm_dest = sockdup(inet_addr_default);
			    yyval.dm .dm_mask = inet_mask_default;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A MASK: %A",
				      parse_where(),
				      yyval.dm .dm_dest,
				      yyval.dm .dm_mask));
			}
break;
case 442:
#line 3069 "parser.y"
{
			    yyval.flag  = 0;
			}
break;
case 443:
#line 3073 "parser.y"
{
			    yyval.flag  = yyvsp[-1].flag  | yyvsp[0].flag ;
			}
break;
case 444:
#line 3079 "parser.y"
{
			    yyval.flag  = RTS_RETAIN;
			}
break;
case 445:
#line 3083 "parser.y"
{
			    yyval.flag  = RTS_REJECT;
			}
break;
case 446:
#line 3087 "parser.y"
{
			    yyval.flag  = RTS_BLACKHOLE;
			}
break;
case 447:
#line 3091 "parser.y"
{
			    yyval.flag  = RTS_NOTINSTALL;
			}
break;
case 448:
#line 3099 "parser.y"
{
			    if (parse_new_state(PS_CONTROL)) {
				PARSE_ERROR;
			    }
			}
break;
case 449:
#line 3108 "parser.y"
{
			    assert(FALSE);
			}
break;
case 450:
#line 3112 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists .proto);
			    adv->adv_as = yyvsp[-2].as ;
			    adv->adv_list = yyvsp[-1].metric_adv .adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists .import_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 451:
#line 3139 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the import list
			     *	for the specified protocol.
			     */
			    (void) parse_adv_propagate_preference(yyvsp[-2].adv , yyvsp[-3].proto_lists .proto, &yyvsp[-1].metric_adv .metric, yyvsp[-1].metric_adv .adv);

			    switch (yyvsp[-2].adv ->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv ;
				    adv_entry *advn;

				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					/* Reset the type */
					adv->adv_flag = (adv->adv_flag & ~ADVF_TYPE) | ADVFT_ANY;
					if (parse_adv_append(&adv->adv_gwp->gw_import, adv)) {
					    PARSE_ERROR;
					}
				    } while ((adv = advn));
				}
				break;

			    case ADVFT_ANY:
				/* Global list */
				if (parse_adv_append(yyvsp[-3].proto_lists .import_list, yyvsp[-2].adv )) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_import[yyvsp[-3].proto_lists .proto], yyvsp[-2].adv )) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 452:
#line 3185 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;

			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    /*
			     *	Append the dest_mask list to the end of the OSPF import list.
			     */
			    adv = adv_alloc(ADVFT_PS, RTPROTO_OSPF_ASE);
			    adv->adv_list = yyvsp[-1].metric_adv .adv;
			    adv->adv_ps = (caddr_t) adv;

			    /* Set Tag */
			    if (PARSE_METRIC_ISSET(&yyvsp[-2].metric )) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG);
				adv->adv_result.res_metric = yyvsp[-2].metric .metric;
			    }

			    /* Set Preference */
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (parse_adv_append(&ospf.import_list, adv)) {
				PARSE_ERROR;
			    }
			}
break;
case 453:
#line 3221 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    adv_entry *adv_prop = yyvsp[-1].metric_adv .adv;
			    pmet_t *mp = &yyvsp[-1].metric_adv .metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists .proto);
			    adv->adv_as = yyvsp[-2].as ;
			    adv->adv_list = adv_prop;
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists .export_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 454:
#line 3247 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */

			    (void) parse_adv_propagate_metric(yyvsp[-2].adv , yyvsp[-3].proto_lists .proto, &yyvsp[-1].metric_adv .metric, yyvsp[-1].metric_adv .adv);

			    switch (yyvsp[-2].adv ->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv ;
				    adv_entry *advn;
				
				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					if (parse_adv_append(&adv->adv_gwp->gw_export, adv)) {
					    PARSE_ERROR;
					}
				    } while ((adv = advn));
				}
				break;

			    case ADVFT_ANY:
				/* Global list for the protocol */
				if (parse_adv_append(yyvsp[-3].proto_lists .export_list, yyvsp[-2].adv )) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_export[yyvsp[-3].proto_lists .proto], yyvsp[-2].adv )) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 455:
#line 3292 "parser.y"
{
			    adv_entry *adv;
			    adv_entry *adv_prop = yyvsp[-1].metric_adv .adv;
			    pmet_t *mp = &yyvsp[-1].metric_adv .metric;

			    /* If we export then we are a border router */
			    ospf.asbr = TRUE;

			    /* Make sure this PS type is known */
			    adv_psfunc_add(RTPROTO_OSPF_ASE, &ospf_adv_psfunc);

			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */
			    adv = adv_alloc(ADVFT_PS, RTPROTO_OSPF_ASE);
			    adv->adv_ps = (caddr_t) adv;
			    adv->adv_list = adv_prop;

			    /* Metric */
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    /* Type */
			    if (PARSE_METRIC_ISSET(&yyvsp[-3].metric )) {
				BIT_SET(adv->adv_flag, ADVFOT_FLAG);
				adv->adv_result.res_flag = yyvsp[-3].metric .metric;
			    }

			    /* Tag */
			    switch (yyvsp[-2].metric .state) {
			    case PARSE_METRICS_SET:
				BIT_SET(adv->adv_flag, ADVFOT_METRIC2|ADVFOT_FLAG);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG|OSPF_EXPORT_TAG_METRIC2);
				adv->adv_result.res_metric2 = yyvsp[-2].metric .metric;
				break;

			    case PARSE_METRICS_ALTERNATE:
				BIT_SET(adv->adv_flag, ADVFOT_METRIC2|ADVFOT_FLAG);
				BIT_SET(adv->adv_result.res_flag, OSPF_EXPORT_TAG|OSPF_EXPORT_TAG_METRIC2);
				adv->adv_result.res_metric2 = PATH_OSPF_TAG_TRUSTED |
				    ((yyvsp[-2].metric .metric << PATH_OSPF_TAG_USR_SHIFT) & PATH_OSPF_TAG_USR_MASK);
				break;
			    }

			    if (parse_adv_append(&ospf.export_list, adv)) {
				PARSE_ERROR;
			    }
			}
break;
case 456:
#line 3346 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-5].metric ;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_DM | yyvsp[-4].flag , 0);
			    adv->adv_dm = yyvsp[-6].dm ;	/* struct copy */
			    BIT_RESET(adv->adv_dm.dm_flags, DMF_EXACT);
			    BIT_SET(adv->adv_dm.dm_flags, DMF_REFINE);
			    adv->adv_list = yyvsp[-2].adv ;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    aggregate_list_inet = adv_destmask_insert(parse_error, aggregate_list_inet, adv);
			    if (!aggregate_list_inet) {
				PARSE_ERROR;
			    }
			}
break;
case 457:
#line 3374 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-4].metric ;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_DM | ADVF_AGGR_GENERATE, 0);
			    adv->adv_dm = yyvsp[-5].dm ;	/* struct copy */
			    BIT_RESET(adv->adv_dm.dm_flags, DMF_EXACT);
			    BIT_SET(adv->adv_dm.dm_flags, DMF_REFINE);
			    adv->adv_list = yyvsp[-2].adv ;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    aggregate_list_inet = adv_destmask_insert(parse_error, aggregate_list_inet, adv);
			    if (!aggregate_list_inet) {
				PARSE_ERROR;
			    }
			}
break;
case 458:
#line 3409 "parser.y"
{
			    yyval.flag  = 0;
			}
break;
case 459:
#line 3413 "parser.y"
{
			    yyval.flag  = ADVF_AGGR_BRIEF;
			}
break;
case 462:
#line 3425 "parser.y"
{
			    yyval.adv  = yyvsp[0].adv ;
			    BIT_SET(yyval.adv ->adv_flag, ADVF_FIRST);
			}
break;
case 463:
#line 3430 "parser.y"
{
			    yyval.adv  = yyvsp[-1].adv ;
			    if (parse_adv_append(&yyval.adv , yyvsp[0].adv )) {
				PARSE_ERROR;
			    }
			}
break;
case 464:
#line 3437 "parser.y"
{
			    yyerrok;
			}
break;
case 465:
#line 3444 "parser.y"
{
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;
			    
			    yyval.adv  = adv_alloc(ADVFT_ANY, yyvsp[-2].proto );
			    yyval.adv ->adv_list = yyvsp[-1].metric_adv .adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv ->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv ->adv_result.res_preference = pp->metric;
				}
			    }
			}
break;
case 466:
#line 3459 "parser.y"
{
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;
			    
			    yyval.adv  = adv_alloc(ADVFT_AS, yyvsp[-4].proto );
			    yyval.adv ->adv_as = yyvsp[-2].as ;
			    yyval.adv ->adv_list = yyvsp[-1].metric_adv .adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv ->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv ->adv_result.res_preference = pp->metric;
				}
			    }
			}
break;
case 467:
#line 3475 "parser.y"
{
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;
			    
			    yyval.adv  = adv_alloc(ADVFT_ASPATH, yyvsp[-3].proto );
			    yyval.adv ->adv_aspath = yyvsp[-2].asp_match ;
			    yyval.adv ->adv_list = yyvsp[-1].metric_adv .adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv ->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv ->adv_result.res_preference = pp->metric;
				}
			    }
			}
break;
case 468:
#line 3491 "parser.y"
{
			    pmet_t *pp = &yyvsp[-1].metric_adv .metric;
			    
			    yyval.adv  = adv_alloc(ADVFT_TAG, (proto_t) yyvsp[-4].proto );
			    yyval.adv ->adv_tag = yyvsp[-2].metric .metric;
			    yyval.adv ->adv_list = yyvsp[-1].metric_adv .adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv ->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv ->adv_result.res_preference = pp->metric;
				}
			    }
			}
break;
case 469:
#line 3510 "parser.y"
{
			    yyval.proto  = RTPROTO_ANY;
			}
break;
case 470:
#line 3514 "parser.y"
{
			    yyval.proto  = RTPROTO_DIRECT;
			}
break;
case 471:
#line 3518 "parser.y"
{
			    yyval.proto  = RTPROTO_STATIC;
			}
break;
case 472:
#line 3522 "parser.y"
{
			    yyval.proto  = RTPROTO_KERNEL;
			}
break;
case 473:
#line 3526 "parser.y"
{
			    yyval.proto  = RTPROTO_AGGREGATE;
			}
break;
case 474:
#line 3530 "parser.y"
{
			    yyval.proto  = RTPROTO_HELLO;
			}
break;
case 475:
#line 3534 "parser.y"
{
			    yyval.proto  = RTPROTO_RIP;
			}
break;
case 476:
#line 3538 "parser.y"
{
			    yyval.proto  = RTPROTO_OSPF;
			}
break;
case 477:
#line 3542 "parser.y"
{
			    yyval.proto  = RTPROTO_OSPF_ASE;
			}
break;
case 478:
#line 3553 "parser.y"
{
			    parse_export_proto = yyval.proto_lists .proto = yyvsp[0].proto ;

			    switch (yyvsp[0].proto ) {
#if	defined(PROTO_EGP)
			    case RTPROTO_EGP:
				yyval.proto_lists .import_list = &egp_import_list;
				yyval.proto_lists .export_list = &egp_export_list;
				break;
#endif

#if	defined(PROTO_BGP)
			    case RTPROTO_BGP:
				yyval.proto_lists .import_list = &bgp_import_list;
				yyval.proto_lists .export_list = &bgp_export_list;
				break;
#endif

			    default:
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto )));
				PARSE_ERROR;
			    }
			}
break;
case 479:
#line 3583 "parser.y"
{
			}
break;
case 480:
#line 3586 "parser.y"
{
			    trace_log_tf(trace_global,
					 0,
					 LOG_WARNING,
					 ("parse: %s use of the ``listen'' keyword is deprecated; removal is recommended",
					  parse_where()));
			}
break;
case 481:
#line 3596 "parser.y"
{
			    yyval.proto_lists  = yyvsp[0].proto_lists ;
			    
			    parse_proto = yyvsp[0].proto_lists .proto;
			    parse_gwlist = yyvsp[0].proto_lists .gw_list;

			    if (!yyvsp[0].proto_lists .import_list) {
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists .proto)));
				PARSE_ERROR;
			    }
			    
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists .proto))));
			}
break;
case 482:
#line 3623 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv .metric);
			    yyval.metric_adv .adv = (adv_entry *) 0;
			}
break;
case 483:
#line 3628 "parser.y"
{
			    yyval.metric_adv .metric = yyvsp[-3].metric ;
			    yyval.metric_adv .adv = adv_destmask_finish(yyvsp[-1].adv );
			}
break;
case 484:
#line 3636 "parser.y"
{
			    yyval.adv  = (adv_entry *) 0;
			}
break;
case 485:
#line 3640 "parser.y"
{
			    
			    yyval.adv  = adv_destmask_insert(parse_error, yyvsp[-2].adv , yyvsp[-1].adv );
			    if (!yyval.adv ) {
				PARSE_ERROR;
			    }
			}
break;
case 486:
#line 3648 "parser.y"
{
			    yyerrok;
			}
break;
case 487:
#line 3655 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 488:
#line 3659 "parser.y"
{
			    parse_contig_masks = TRUE;

			    if (yyvsp[-1].dm .dm_dest
				&& (socktype(yyvsp[-1].dm .dm_dest) != AF_INET)) {
				sprintf(parse_error, "address not INET");
				PARSE_ERROR
			    }

			    yyval.adv  = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv ->adv_dm = yyvsp[-1].dm ;
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric )) {
				if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric )) {
				    BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv ->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv ->adv_result.res_preference = yyvsp[0].metric .metric;
				}
			    }
			}
break;
case 489:
#line 3687 "parser.y"
{
			    yyval.proto_lists  = yyvsp[0].proto_lists ;
			    
			    parse_export_proto = parse_proto = yyvsp[0].proto_lists .proto;
			    parse_gwlist = yyvsp[0].proto_lists .gw_list;

			    if (!yyvsp[0].proto_lists .export_list) {
				(void) sprintf(parse_error,
					       "unknown export protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists .proto)));
				PARSE_ERROR;
			    }
			    
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists .proto))));
			}
break;
case 490:
#line 3711 "parser.y"
{
			    yyval.proto  = parse_export_proto = RTPROTO_OSPF_ASE;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 491:
#line 3725 "parser.y"
{
			}
break;
case 492:
#line 3728 "parser.y"
{
			    trace_log_tf(trace_global,
					 0,
					 LOG_WARNING,
					 ("parse: %s use of the ``announce'' keyword is deprecated; removal is recommended",
					  parse_where()));
			}
break;
case 493:
#line 3741 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv .metric);
			    yyval.metric_adv .adv = (adv_entry *) 0;
			}
break;
case 494:
#line 3746 "parser.y"
{
			    yyval.metric_adv .metric = yyvsp[-3].metric ;
			    yyval.metric_adv .adv = yyvsp[-1].adv ;
			}
break;
case 495:
#line 3754 "parser.y"
{
			    yyval.adv  = (adv_entry *) 0;
			}
break;
case 496:
#line 3758 "parser.y"
{
			    yyval.adv  = yyvsp[-2].adv ;
			    if (parse_adv_append(&yyval.adv , yyvsp[-1].adv )) {
				PARSE_ERROR;
			    }
			}
break;
case 497:
#line 3765 "parser.y"
{
			    yyerrok;
			}
break;
case 498:
#line 3773 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(yyvsp[-1].adv , yyvsp[-2].proto , &yyvsp[0].metric_adv .metric, yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			}
break;
case 499:
#line 3779 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(yyvsp[-1].adv , yyvsp[-2].proto , &yyvsp[0].metric_adv .metric, yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 500:
#line 3786 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_ANY | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-1].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			}
break;
case 501:
#line 3796 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(yyvsp[-1].adv , yyvsp[-2].proto , &yyvsp[0].metric_adv .metric, yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 502:
#line 3803 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_ANY | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-1].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			}
break;
case 503:
#line 3812 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_AS | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-3].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    yyval.adv ->adv_as = yyvsp[-1].as ;
			    parse_proto = (proto_t) 0;
			}
break;
case 504:
#line 3823 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_ASPATH | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-2].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    yyval.adv ->adv_aspath = yyvsp[-1].asp_match ;
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 505:
#line 3835 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_TAG|ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-3].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    yyval.adv ->adv_tag = yyvsp[-1].metric .metric;
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 506:
#line 3847 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(yyvsp[-1].adv , yyvsp[-2].proto , &yyvsp[0].metric_adv .metric, yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 507:
#line 3854 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(yyvsp[-1].adv , yyvsp[-2].proto , &yyvsp[0].metric_adv .metric, yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 508:
#line 3861 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_ANY | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-1].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			}
break;
case 509:
#line 3870 "parser.y"
{
			    yyval.adv  = parse_adv_propagate_metric(adv_alloc(ADVFT_ANY | ADVF_FIRST,
								      (proto_t) 0),
							    yyvsp[-1].proto ,
							    &yyvsp[0].metric_adv .metric,
							    yyvsp[0].metric_adv .adv);
			    parse_proto = (proto_t) 0;
			}
break;
case 510:
#line 3881 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_DIRECT;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 511:
#line 3894 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 512:
#line 3907 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_AGGREGATE;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 513:
#line 3920 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_KERNEL;
			    parse_gwlist = &krt_gw_list;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 514:
#line 3933 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_DEFAULT;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 515:
#line 3947 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv .metric);
			    yyval.metric_adv .adv = (adv_entry *) 0;
			}
break;
case 516:
#line 3952 "parser.y"
{
			    yyval.metric_adv .metric = yyvsp[-1].metric ;
			    yyval.metric_adv .adv = yyvsp[0].adv ;
			}
break;
case 517:
#line 3960 "parser.y"
{
			    yyval.adv  = (adv_entry *) 0;
			}
break;
case 518:
#line 3964 "parser.y"
{
			    yyval.adv  = adv_destmask_finish(yyvsp[-1].adv );
			}
break;
case 519:
#line 3972 "parser.y"
{
			    yyval.adv  = (adv_entry *) 0;
			}
break;
case 520:
#line 3976 "parser.y"
{
			    yyval.adv  = adv_destmask_insert(parse_error, yyvsp[-2].adv , yyvsp[-1].adv );
			    if (!yyval.adv ) {
				PARSE_ERROR;
			    }
			}
break;
case 521:
#line 3983 "parser.y"
{
			    yyerrok;
			}
break;
case 522:
#line 3990 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 523:
#line 3994 "parser.y"
{
			    parse_contig_masks = TRUE;

			    if (yyvsp[-1].dm .dm_dest
				&& (socktype(yyvsp[-1].dm .dm_dest) != AF_INET)) {
				sprintf(parse_error, "address not INET");
				PARSE_ERROR
			    }

			    yyval.adv  = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv ->adv_dm = yyvsp[-1].dm ;
			    if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric )) {
				BIT_SET(yyval.adv ->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(&yyvsp[0].metric )) {
				yyval.adv ->adv_result.res_metric = yyvsp[0].metric .metric;
				BIT_SET(yyval.adv ->adv_flag, ADVFOT_METRIC);
			    }
			}
break;
case 528:
#line 4028 "parser.y"
{
			    yyval.dm .dm_dest = sockdup(inet_addr_default);
			    yyval.dm .dm_mask = inet_mask_default;
			    yyval.dm .dm_flags = (flag_t) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: all",
				      parse_where()));
			}
break;
case 529:
#line 4042 "parser.y"
{
			    yyval.dm .dm_dest = sockdup(inet_addr_default);
			    yyval.dm .dm_mask = inet_mask_default;
			    yyval.dm .dm_flags = (flag_t) DMF_EXACT;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A",
				      parse_where(),
				      yyval.dm .dm_dest));
			}
break;
case 530:
#line 4058 "parser.y"
{
			    yyval.adv  = adv_alloc(ADVFT_GW | ADVF_FIRST, (proto_t) 0);
			    yyval.adv ->adv_gwp = yyvsp[0].gwp ;
			}
break;
case 531:
#line 4063 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_GW, (proto_t) 0);

			    adv->adv_gwp = yyvsp[0].gwp ;
			    yyval.adv  = yyvsp[-1].adv ;
			    if (parse_adv_append(&yyval.adv , adv)) {
				PARSE_ERROR;
			    }
			}
break;
case 532:
#line 4076 "parser.y"
{
			    /*
			     *	Make sure host is on a locally attached network then
			     *	find or create a gw structure for it.  Requires that
			     *	parse_proto and parse_gwlist are previously set
			     */
			    if (!if_parse_withdst(yyvsp[0].sockaddr )) {
				(void) sprintf(parse_error, "gateway not a host address on an attached network: '%A'",
					       yyvsp[0].sockaddr );
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    PARSE_ERROR;
				} else {
				    yyerror(parse_error);
				}
			    }
			    if (!parse_gwlist) {
				(void) sprintf(parse_error, "gateway specification not valid for %s",
					       trace_state(rt_proto_bits, parse_proto));
				PARSE_ERROR;
			    }
			    yyval.gwp  = gw_locate(parse_gwlist,
					   parse_proto,
					   (task *) 0,
					   (as_t) 0,
					   (as_t) 0,
					   yyvsp[0].sockaddr ,
					   (flag_t) 0);
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s GATEWAY: %A  PROTO: %s",
				      parse_where(),
				      yyval.gwp ->gw_addr,
				      gd_lower(trace_state(rt_proto_bits, yyval.gwp ->gw_proto))));
			    sockfree(yyvsp[0].sockaddr );
			}
break;
case 533:
#line 4115 "parser.y"
{ 
			    sockaddr_un *addr;

			    addr = parse_addr_hostname(yyvsp[0].str .ptr, parse_error);
			    if (!addr) {
				/* Name resolution failure */
				
				PARSE_ERROR;
			    }
			    yyval.sockaddr  = sockdup(addr);
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s HOST: %A",
				      parse_where(),
				      yyval.sockaddr ));
			    free_charstr(yyvsp[0].str );
			}
break;
case 534:
#line 4134 "parser.y"
{
			    yyval.sockaddr  = yyvsp[0].sockaddr ;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s HOST: %A",
				      parse_where(),
				      yyval.sockaddr ));
			}
break;
case 535:
#line 4146 "parser.y"
{
			    yyval.dm .dm_dest = yyvsp[0].sockaddr ;
			    yyval.dm .dm_mask = inet_mask_host;
			    yyval.dm .dm_flags = DMF_EXACT;

			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A",
				      parse_where(),
				      yyval.dm .dm_dest));
			}
break;
case 536:
#line 4161 "parser.y"
{
			    sockaddr_un *addr;

			    addr = parse_addr_netname(yyvsp[0].str .ptr, parse_error);
			    if (!addr) {
				/* Name resolution failure */

				PARSE_ERROR;
			    }
			    yyval.sockaddr  = sockdup(addr);
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s NETWORK: %A",
				      parse_where(),
				      yyval.sockaddr ));
			    free_charstr(yyvsp[0].str );
			}
break;
case 537:
#line 4180 "parser.y"
{
			    yyval.sockaddr  = yyvsp[0].sockaddr ;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s NETWORK: %A",
				      parse_where(),
				      yyval.sockaddr ));
			}
break;
case 538:
#line 4193 "parser.y"
{
			    yyval.dm .dm_dest = yyvsp[0].sockaddr ;
			    yyval.dm .dm_mask = inet_mask_natural(yyvsp[0].sockaddr );
			    yyval.dm .dm_flags = (flag_t) 0;
			    if (sock2ip(yyval.dm .dm_dest) & ~sock2ip(yyval.dm .dm_mask)) {
				sprintf(parse_error, "host or mask option needed");
				PARSE_ERROR;
			    }
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A MASK: %A",
				      parse_where(),
				      yyval.dm .dm_dest,
				      yyval.dm .dm_mask));
			}
break;
case 539:
#line 4210 "parser.y"
{
			    yyval.dm .dm_dest = yyvsp[-2].sockaddr ;
			    if (parse_limit_check("inet mask bits",
						  (u_int) yyvsp[0].num ,
						  INET_LIMIT_MASKLEN)) {
				PARSE_ERROR;
			    }
			    yyval.dm .dm_mask = inet_masks[yyvsp[0].num ];
			    yyval.dm .dm_flags = (flag_t) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A MASK: %A",
				      parse_where(),
				      yyval.dm .dm_dest,
				      yyval.dm .dm_mask));
			}
break;
case 540:
#line 4228 "parser.y"
{
			    register byte *ap = yyvsp[-2].sockaddr ->a.ga_data;
			    register byte *mp = yyvsp[0].sockaddr ->a.ga_data;
			    register byte *alp = (byte *) yyvsp[-2].sockaddr  + socksize(yyvsp[-2].sockaddr );
			    register byte *mlp = (byte *) yyvsp[0].sockaddr  + socksize(yyvsp[0].sockaddr );

			    /* Skip zero fields */
			    while (!*ap && ap < alp) {
				ap++, mp++;
			    }
			    
			    while (ap < alp) {
				if (mp < mlp) {
				    if (*ap++ & ~*mp++) {
					break;
				    }
				} else {
				    if (*ap++) {
					break;
				    }
				}
			    }
			    if (ap < alp) {
				sprintf(parse_error, "Non-masked bits not zero for %A mask %A",
					yyvsp[-2].sockaddr ,
					yyvsp[0].sockaddr );
				PARSE_ERROR;
			    }

			    yyval.dm .dm_dest = yyvsp[-2].sockaddr ;
			    yyval.dm .dm_mask = yyvsp[0].sockaddr ;
			    yyval.dm .dm_flags = (flag_t) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s DEST: %A MASK: %A",
				      parse_where(),
				      yyval.dm .dm_dest,
				      yyval.dm .dm_mask));
			}
break;
case 541:
#line 4272 "parser.y"
{
			    yyval.dm  = yyvsp[-1].dm ;
			    yyval.dm .dm_flags = yyvsp[0].num ;
			}
break;
case 542:
#line 4279 "parser.y"
{
			    yyval.sockaddr  = inet_mask_locate(yyvsp[0].in_addr .s_addr);
			    if (!yyval.sockaddr ) {
				if (parse_contig_masks) {
				    (void) sprintf(parse_error, "mask not contiguous");
				    PARSE_ERROR;
				} else {
				    yyval.sockaddr  = mask_locate(sockbuild_in(0, yyvsp[0].in_addr .s_addr));
				}
			    }
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s MASK: %A",
				      parse_where(),
				      yyval.sockaddr ));
			}
break;
case 543:
#line 4300 "parser.y"
{
			    yyval.sockaddr  = sockdup(sockbuild_in(0, yyvsp[0].in_addr .s_addr));

			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s IP_ADDR: %A",
				      parse_where(),
				      yyval.sockaddr ));
			}
break;
case 544:
#line 4314 "parser.y"
{
			    u_int32 addr = yyvsp[0].num ;
			    
			    if (addr) {
				/* Normalize the address */
				while (!(addr & 0xff000000)) {
				    addr <<= 8;
				}
			    }
			    yyval.in_addr .s_addr = htonl(addr);
			}
break;
case 545:
#line 4326 "parser.y"
{
			    int i;
			    u_int32 addr = 0;

			    if (yyvsp[0].hex .len > sizeof(addr)) {
				sprintf(parse_error, "octet or hex string too long to be an IP address");
				PARSE_ERROR;
			    }

			    for (i = 0; i < sizeof(addr); i++) {
				addr <<= 8;
				if (i < yyvsp[0].hex .len) {
				    BIT_SET(addr, yyvsp[0].hex .ptr[i]);
				}
			    }
			    yyval.in_addr .s_addr = htonl(addr);
			    free_bytestr(yyvsp[0].hex );
			}
break;
case 546:
#line 4348 "parser.y"
{
			    if (parse_limit_check("ttl",
						  (u_int) yyvsp[0].num ,
						  INET_LIMIT_TTL)) {
				PARSE_ERROR;
			    }
			    yyval.num  = yyvsp[0].num ;
			}
break;
case 547:
#line 4365 "parser.y"
{
			    assert(FALSE);
			}
break;
case 549:
#line 4372 "parser.y"
{
			    assert(FALSE);
			}
break;
case 551:
#line 4379 "parser.y"
{
			    assert(FALSE);
			}
break;
case 553:
#line 4386 "parser.y"
{
			    assert(FALSE);
			}
break;
case 555:
#line 4393 "parser.y"
{
			    yyval.num  = (flag_t) 0;
			}
break;
case 556:
#line 4397 "parser.y"
{
			    yyval.num  = DMF_EXACT;
			}
break;
case 557:
#line 4401 "parser.y"
{
			    yyval.num  = DMF_REFINE;
			}
break;
case 558:
#line 4410 "parser.y"
{
			    yyval.str  = yyvsp[0].str ;
			    yyval.str .ptr = task_mem_strdup((task *) 0, yyvsp[0].str .ptr);
			}
break;
case 559:
#line 4415 "parser.y"
{
			    yyval.str  = yyvsp[0].str ;
			    yyval.str .ptr = task_mem_strdup((task *) 0, yyvsp[0].str .ptr);
			}
break;
case 561:
#line 4424 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.proto_lists .proto = RTPROTO_REDIRECT;
			    yyval.proto_lists .import_list = &redirect_import_list;
			    yyval.proto_lists .export_list = (adv_entry **) 0;
			    yyval.proto_lists .gw_list = &redirect_gw_list;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 562:
#line 4433 "parser.y"
{
			    yyval.proto_lists .proto = RTPROTO_HELLO;
			    yyval.proto_lists .import_list = &hello_import_list;
			    yyval.proto_lists .export_list = &hello_export_list;
			    yyval.proto_lists .gw_list = &hello_gw_list;
			}
break;
case 563:
#line 4440 "parser.y"
{
			    yyval.proto_lists .proto = RTPROTO_RIP;
			    yyval.proto_lists .import_list = &rip_import_list;
			    yyval.proto_lists .export_list = &rip_export_list;
			    yyval.proto_lists .gw_list = &rip_gw_list;
			}
break;
case 564:
#line 4450 "parser.y"
{
			    assert(FALSE);
			}
break;
case 565:
#line 4455 "parser.y"
{ yyval.num  = T_ON; }
break;
case 566:
#line 4456 "parser.y"
{ yyval.num  = T_OFF; }
break;
case 567:
#line 4462 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric , yyvsp[0].num );
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s METRIC: %d",
				      parse_where(),
				      yyval.metric .metric));
			}
break;
case 568:
#line 4472 "parser.y"
{
			    PARSE_METRIC_INFINITY(&yyval.metric );
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s METRIC: infinity",
				      parse_where()));
			}
break;
case 569:
#line 4483 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 570:
#line 4487 "parser.y"
{
			    if (parse_metric_check(parse_export_proto, &yyvsp[0].metric )) {
				PARSE_ERROR;
			    }
			    yyval.metric  = yyvsp[0].metric ;
			}
break;
case 571:
#line 4497 "parser.y"
{
			    yyval.metric  = yyvsp[0].metric ;
			}
break;
case 572:
#line 4501 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric );
			}
break;
case 573:
#line 4509 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 574:
#line 4513 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric , yyvsp[0].pref );
			}
break;
case 576:
#line 4521 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric );
			}
break;
case 577:
#line 4527 "parser.y"
{
			    if (parse_limit_check("preference",
						  (u_int) yyvsp[0].num ,
						  LIMIT_PREFERENCE)) {
				PARSE_ERROR;
			    }
			    yyval.pref  = yyvsp[0].num ;
			}
break;
case 578:
#line 4540 "parser.y"
{
			    /* Remove quotes from the string if present */
			    char *cp;

			    yyval.str  = yyvsp[0].str ;
				
			    switch (*yyval.str .ptr) {
			    case '<':
				*yyval.str .ptr = '>';
				/* Fall through */

			    case '"':
				cp = &yyval.str .ptr[yyval.str .len-1];
				if (*cp == *yyval.str .ptr) {
				    *cp = (char) 0;
				    yyval.str .len -= 2;
				    cp = yyval.str .ptr + 1;
				    break;
				}
				/* Fall Through */

			    default:
				cp = yyval.str .ptr;
			    }

			    yyval.str .ptr = task_mem_strdup((task *) 0, cp);
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s STRING: \"%s\" length: %d",
				      parse_where(),
				      yyval.str .ptr,
				      yyval.str .len));
			}
break;
case 580:
#line 4579 "parser.y"
{
			    yyval.num  = -yyvsp[0].num ;
			}
break;
case 582:
#line 4586 "parser.y"
{
			    int i = 0;
			    int len = sizeof(yyval.num );

			    yyval.num  = 0;
			    if (yyvsp[0].hex .len > len) {
				sprintf(parse_error, "octet or hex string too long to be a number");
				PARSE_ERROR;
			    } else if (yyvsp[0].hex .len < len) {
				len = yyvsp[0].hex .len;
			    }
			    while (i < len) {
				yyval.num  = (yyval.num  << 8) | yyvsp[0].hex .ptr[i++];
			    }
			    free_bytestr(yyvsp[0].hex );
			}
break;
case 585:
#line 4611 "parser.y"
{
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num ,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    };
			    yyval.time  = yyvsp[0].num ;
			}
break;
case 586:
#line 4620 "parser.y"
{
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num ,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num ,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time  = (yyvsp[-2].num  * 60) + yyvsp[0].num ;
			}
break;
case 587:
#line 4634 "parser.y"
{
			    if (parse_limit_check("hours",
						  (u_int) yyvsp[-4].num ,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num ,
						  LIMIT_MINUTES)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num ,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time  = ((yyvsp[-4].num  * 60) + yyvsp[-2].num ) * 60 + yyvsp[0].num ;
			}
break;
case 588:
#line 4660 "parser.y"
{
			    yyval.u_num  = 1;
			}
break;
case 589:
#line 4664 "parser.y"
{
			    if (parse_limit_check("as loop limit",
						  (u_int) yyvsp[0].num ,
						  LIMIT_AS_LOOPS)) {
				PARSE_ERROR;
			    }
			    yyval.u_num  = yyvsp[0].num ;
			}
break;
case 590:
#line 4676 "parser.y"
{
			    if (parse_limit_check("autonomous system",
						  (u_int) yyvsp[0].num ,
						  LIMIT_AS)) {
				PARSE_ERROR;
			    }
			    yyval.as  = yyvsp[0].num ;
			}
break;
case 591:
#line 4693 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 592:
#line 4697 "parser.y"
{
			    yyval.metric  = yyvsp[0].metric ;
			}
break;
case 594:
#line 4704 "parser.y"
{
			    PARSE_METRIC_ALTERNATE(&yyval.metric , 0);
			}
break;
case 595:
#line 4708 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num ,
						  PATH_OSPF_TAG_USR_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_ALTERNATE(&yyval.metric , yyvsp[0].num );
			}
break;
case 596:
#line 4719 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric );
			}
break;
case 597:
#line 4723 "parser.y"
{
			    yyval.metric  = yyvsp[0].metric ;
			}
break;
case 598:
#line 4729 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num ,
						  PATH_OSPF_TAG_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric , yyvsp[0].num );
			}
break;
case 604:
#line 4753 "parser.y"
{
			    yyval.proto  = parse_proto = RTPROTO_ANY;
			    parse_gwlist = (gw_entry **) 0;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("parse: %s PROTO: %s",
				      parse_where(),
				      gd_lower(trace_state(rt_proto_bits, yyval.proto ))));
			}
break;
case 610:
#line 4771 "parser.y"
{
			    aspath_init_regex();
			}
break;
case 611:
#line 4775 "parser.y"
{
			    yyval.asp_match  = aspath_consume_current(yyvsp[-2].asp_stack );
			    yyval.asp_match ->origin_mask = yyvsp[0].flag ;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("%s: path %X origins %s",
				      parse_where(),
				      yyval.asp_match ,
				      aspath_adv_origins(yyval.asp_match ->origin_mask)));
			}
break;
case 612:
#line 4789 "parser.y"
{
			    /* Set all bits on */
			    yyval.flag  = (flag_t) -1;
			}
break;
case 613:
#line 4794 "parser.y"
{
			    /* Set all bits on */
			    yyval.flag  = (flag_t) -1;
			}
break;
case 614:
#line 4799 "parser.y"
{
			    yyval.flag  = yyvsp[0].flag ;
			}
break;
case 616:
#line 4807 "parser.y"
{
			    yyval.flag  = yyvsp[-2].flag  | yyvsp[0].flag ;
			}
break;
case 617:
#line 4813 "parser.y"
{
			    yyval.flag  = (1 << PATH_ORG_IGP);
			}
break;
case 618:
#line 4817 "parser.y"
{
			    yyval.flag  = (1 << PATH_ORG_EGP);
			}
break;
case 619:
#line 4821 "parser.y"
{
			    yyval.flag  = (1 << PATH_ORG_XX);
			}
break;
case 620:
#line 4827 "parser.y"
{
			    aspath_simple_regex(&yyval.asp_stack , &yyvsp[0].asp_stack );
			}
break;
case 621:
#line 4831 "parser.y"
{
			    aspath_merge_regex(&yyval.asp_stack , &yyvsp[-2].asp_stack , &yyvsp[0].asp_stack );
			}
break;
case 622:
#line 4837 "parser.y"
{
			    aspath_copy_regex(&yyval.asp_stack , &yyvsp[0].asp_stack );
			}
break;
case 623:
#line 4841 "parser.y"
{
			    if(!aspath_prepend_regex(&yyval.asp_stack , &yyvsp[-1].asp_stack , &yyvsp[0].asp_stack )) {
				YYERROR;
			    }
			}
break;
case 624:
#line 4849 "parser.y"
{
			    aspath_copy_regex(&yyval.asp_stack , &yyvsp[0].asp_stack );
			}
break;
case 625:
#line 4853 "parser.y"
{
			    aspath_zero_or_more_term(&yyval.asp_stack , &yyvsp[-1].asp_stack );
			}
break;
case 626:
#line 4857 "parser.y"
{
			    aspath_one_or_more_term(&yyval.asp_stack , &yyvsp[-1].asp_stack );
			}
break;
case 627:
#line 4861 "parser.y"
{
			    aspath_zero_or_one_term(&yyval.asp_stack , &yyvsp[-1].asp_stack );
			}
break;
case 628:
#line 4865 "parser.y"
{
			    if (!aspath_range_term(&yyval.asp_stack , &yyvsp[-3].asp_stack , &yyvsp[-1].asp_range )) {
				sprintf(parse_error,
					"too many AS path regexp states");
				PARSE_ERROR;
			    }
			}
break;
case 629:
#line 4875 "parser.y"
{
			    if (!aspath_as_transition(&yyval.asp_stack , yyvsp[0].as )) {
				sprintf(parse_error,
					"too many AS path regexp states");
				PARSE_ERROR;
			    }
			}
break;
case 630:
#line 4883 "parser.y"
{
			    if (!aspath_any_transition(&yyval.asp_stack )) {
				sprintf(parse_error,
					"too many AS path regexp states");
				PARSE_ERROR;
			    }
			}
break;
case 631:
#line 4891 "parser.y"
{
			    aspath_copy_regex(&yyval.asp_stack , &yyvsp[-1].asp_stack );
			}
break;
case 632:
#line 4896 "parser.y"
{
			    yyval.asp_range .begin = yyvsp[0].num ;
			    yyval.asp_range .end = yyvsp[0].num ;
			    if (!yyvsp[0].num ) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[0].num );
				PARSE_ERROR;
			    }
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("%s: RANGE: {%d}",
				      parse_where(),
				      yyval.asp_range .begin));
			}
break;
case 633:
#line 4912 "parser.y"
{
			    yyval.asp_range .begin = yyvsp[-1].num ;
			    yyval.asp_range .end = 0;
			    if (!yyvsp[-1].num ) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-1].num );
				PARSE_ERROR;
			    }
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("%s: RANGE: {%d,}",
				      parse_where(),
				      yyval.asp_range .begin));
			}
break;
case 634:
#line 4928 "parser.y"
{
			    yyval.asp_range .begin = yyvsp[-2].num ;
			    yyval.asp_range .end = yyvsp[0].num ;
			    if (!yyvsp[-2].num ) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-2].num );
				PARSE_ERROR;
			    }
			    if (yyvsp[0].num  < yyvsp[-2].num  || !yyvsp[0].num ) {
				sprintf(parse_error, "invalid range end: %d",
					yyvsp[0].num );
				PARSE_ERROR;
			    }
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("%s: RANGE: {%d,%d}",
				      parse_where(),
				      yyval.asp_range .begin,
				      yyval.asp_range .end));
			}
break;
#line 6993 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#ifdef YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#ifdef YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
